/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: target_config.h 369 2007-07-18 12:48:50Z honda $
 */

/*
 *  åȰ¸⥸塼idea6410NTѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "idea6410nt.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ٥롼򥫡ͥǻĤ
 */
#define VECTOR_KERNEL

/*
 *  ٥롼ʤΥ٥ɥ쥹Ƭ
 */
#define VECTOR_START  0x00

/*
 *  ǡν򤷤ʤ
 */
// #define TOPPERS_OMIT_DATA_INIT

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ      0x2000U
// TODO: check about DEFAULT_ISTK??

/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1    20
#define SIL_DLY_TIM2    10

/*
 *  ߥϥɥֹ˴ؤ
 */
#define TMIN_INHNO  VIC_TMIN_INTNO
#define TMAX_INHNO  VIC_TMAX_INTNO
#define TNUM_INH    VIC_TNUM_INT

#define TMIN_INTNO  VIC_TMIN_INTNO
#define TMAX_INTNO  VIC_TMAX_INTNO
#define TNUM_INT    VIC_TNUM_INT

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֹϰϤȽ
 *
 *  ӥåȥѥΤưפˤ뤿ˡ8Ϸ֤ˤʤäƤ롥
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)   VALID_INTNO(intno)

/*
 *  ߥϥɥϿѥơ֥
 *   ֤ϥե졼
 */
extern const FP inh_tbl[TNUM_INH];

/*
 *  ߥϥɥ
 */
Inline void
x_define_inh(INHNO inhno, FP inthdr)
{
	vic_set_vector(inhno, inthdr);
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 * VIC configuration functions
 */

/*
 * Functions to change external <--> internal representation of priority
 * masks:
 * 
 *   - External=PRI=ipm:     -15 ~ 0
 *   - Internal=uint8_t=iipm: 0 ~ 15
 *
 * This is because in uITRON interrupt priorities are represented with
 * negative numbers (so they dont conflict with task priorities)
 */

#define EXT_IPM(iipm)   ((PRI)(iipm - 0x0fU))     // to external (iipm=0~15)
#define INT_IPM(ipm)    ((uint8_t)(ipm + 0x0fU))  // to internal (ipm=-15~0)

/*
 * Macro defining the internal IPM to enable all interrupts. That is, set the 
 * IPM to the lowest priority (15 = 0 + 0x0fU)
 */
#define IIPM_ENAALL (INT_IPM(TIPM_ENAALL)) // e.g.: IIPM_ENAALL=15

/*
 *  Set the interrupt priority mask IPM
 */
Inline void set_iipm(uint8_t iipm)
{
	vic_cpu_set_priority(iipm);
}

Inline void x_set_ipm(PRI intpri)
{
	set_iipm(INT_IPM(intpri));
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  Get the current interrupt priority mask IPM
 */
Inline uint8_t current_iipm(void)
{
	return(vic_cpu_current_priority());  // 0~15
}

Inline PRI x_get_ipm(void)
{
	return(EXT_IPM(current_iipm())); // -15 ~ 0
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  Disable/Enable interrupts functions
 */

extern uint64_t	bitpat_cfgint;

#define SUPPORT_DIS_INT /* dis_int supported */
#define SUPPORT_ENA_INT /* ena_int is supported */

Inline bool_t x_disable_int(INTNO intno)
{
	if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
		return(false);
	}
	vic_disable_int(intno);
// 	idf |= INTNO_BITPAT(intno);
    return(true);
}

Inline bool_t x_enable_int(INTNO intno)
{
	if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
		return(false);
	}

	vic_enable_int(intno);
// 	idf &= ~INTNO_BITPAT(intno);
	return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)
#define t_enable_int(intno)   x_enable_int(intno)
#define i_enable_int(intno)   x_enable_int(intno)

/*
 *  Clear pending interrupts
 */
Inline void x_clear_int(INTNO intno)
{
    vic_clear_pending(intno);
}

#define t_clear_int(intno) x_clear_int(intno)
#define i_clear_int(intno) x_clear_int(intno)

/*
 *  Check if a interrupt is active (polling)
 */
Inline bool_t x_probe_int(INTNO intno)
{
    return(vic_probe_int(intno));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri);

Inline void i_begin_int(INTNO intno){}

Inline void i_end_int(INTNO intno)
{
	vic_cpu_end_int(intno);
}

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

/*
 *  atexitνȥǥȥ饯μ¹
 */
Inline void
call_atexit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }
}

/*
 *  ߥϥɥtarget_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);


#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_config.h"

/*
 *  ȥ졼˴ؤ
 */
// #include "nulltrace/trace_config.h"

#endif /* TOPPERS_TARGET_CONFIG_H */