/*
 *  TOPPERS/SafeG Dual-OS monitor
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Safety Gate Dual-OS monitor
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *     Graduate School of Information Science, Nagoya University, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
#define CP15_CONTROL_WRITE(x) \
    __asm__ volatile ("mcr p15, 0, %0, c1, c0, 0"::"r"(x))

#define CP15_SET_VBAR(x)    \
    __asm__ volatile ("mcr p15, 0, %0, c12, c0, 0"::"r"(x))

#define PCLK_GATE           (0x7e00f034)
#define S3C64XX_PA_GPIO     (0x7F008000)
#define S3C64XX_GPM_BASE    (S3C64XX_PA_GPIO + 0x0820)
#define S3C64XX_GPMCON      (S3C64XX_GPM_BASE + 0x00)
#define S3C64XX_GPMDAT      (S3C64XX_GPM_BASE + 0x04)
#define S3C64XX_GPMPUD      (S3C64XX_GPM_BASE + 0x08)

extern void *vector_table;
extern void uart_init(void);
extern void uart_putc(char c);
extern void timer_init(void (*callback)(void));
extern void tzpc_init(void);

void the_timer_callback(void)
{
	static unsigned int p = 0;

	if (p++ % 2)
		*((volatile  unsigned int *)S3C64XX_GPMDAT) &= ~0xF;
	else
		*((volatile  unsigned int *)S3C64XX_GPMDAT) |= 0xF;
}

void exc_c_handler(void)
{
	uart_putc('E'); uart_putc('X'); uart_putc('C');
}

int main(void)
{
	CP15_SET_VBAR(&vector_table);
	CP15_CONTROL_WRITE(0);
	uart_init();
	*((volatile unsigned int *)PCLK_GATE) = 0xFFFFFFFF;
	*((volatile unsigned int *)S3C64XX_GPMCON) = 0x1111;
	timer_init(the_timer_callback);
	tzpc_init();

	while(1) {
		__asm__ volatile ("smc #0");
	}

	return 0;
}
