/*
 *  TOPPERS/SafeG Dual-OS monitor
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Safety Gate Dual-OS monitor
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *     Graduate School of Information Science, Nagoya University, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
extern char __itcm_start, __itcm_end, __text_load_start;

#define __section(S) __attribute__ ((__section__(#S)))
#define __init __attribute__((long_call)) __section(.initialization)

static void __init copy(char *dest, char *src, unsigned int count) {
	char *dst8 = dest;
	char *src8 = src;

	while (count--) {
		*dst8++ = *src8++;
	}
}

static void __init itcm_copy(void)
{
	char *start;
	char *end;
	char *ram;
	
	start = &__itcm_start;
	end   = &__itcm_end;
	ram   = &__text_load_start;
	
	copy(start, ram, (unsigned int)(end-start));
}

#define CP15_TCM_SEL_WRITE(x)   __asm__ volatile ("mcr p15, 0, %0, c9, c2, 0"::"r"(x))
#define CP15_ITCM_NS_WRITE(x)   __asm__ volatile ("mcr p15, 0, %0, c9, c1, 3"::"r"(x))
#define CP15_ITCM_REG_WRITE(x)  __asm__ volatile ("mcr p15, 0, %0, c9, c1, 1"::"r"(x))

void __init tcm_init(void)
{
	CP15_TCM_SEL_WRITE(0);
	CP15_ITCM_NS_WRITE(0);
	CP15_ITCM_REG_WRITE(0x80000000 | 1);
	itcm_copy();
	__asm__ volatile("b 0x80000000");
}
