/*
 *  TOPPERS/SafeG Dual-OS monitor
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Safety Gate Dual-OS monitor
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *     Graduate School of Information Science, Nagoya University, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
#define CPSR_IRQ_BIT  (0x80)
#define CPSR_FIQ_BIT  (0x40)
#define CPSR_SVC      (0x13)
#define CPSR_FIQ      (0x11)

    .section .initialization,"x"
    .align 5
    .global initialization
initialization:
    msr  cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    ldr  sp, =__init_stack_end
    mov  fp, #0
    mov  r7, #0
    b    tcm_init
    b    .

    .section .vector,"a"
    .align 5
    .global vector_table
vector_table:
    ldr pc, reset_vector
    ldr pc, exc_vector
    ldr pc, exc_vector
    ldr pc, exc_vector
    ldr pc, exc_vector
    ldr pc, exc_vector
    ldr pc, exc_vector
    ldr pc, fiq_vector

reset_vector:
    .long   secure_start
fiq_vector:
    .long   fiq_handler
exc_vector:
    .long   exc_handler

    .text
    .align  5
    .global secure_start
secure_start:
    msr  cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    ldr  sp, =__stack_end
    mov  fp, #0
    mov  r7, #0
    bl   main

    .text
    .align 5
    .global fiq_handler
fiq_handler:
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    stmfd sp!, {r0-r3,ip,lr,pc}

    msr   cpsr, #(CPSR_FIQ|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    sub   r0, lr, #4
    mrs   r1, spsr

    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    str   r0, [sp,#0x18]
    stmfd sp!,{r1}

    bl fiq_c_handler

    ldmfd sp!,{r1}
    msr   spsr, r1
    ldmfd sp!,{r0-r3,ip,lr,pc}^

    .text
    .align 5
    .global exc_handler
exc_handler:
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)
    bl    exc_c_handler
    b     .
