/*
 *  TOPPERS/SafeG Dual-OS monitor
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Safety Gate Dual-OS monitor
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *     Graduate School of Information Science, Nagoya University, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
#define CP15_CONTROL_WRITE(x) \
	__asm__ volatile ("mcr p15, 0, %0, c1, c0, 0"::"r"(x))

#define CP15_SET_VBAR(x)    \
	__asm__ volatile ("mcr p15, 0, %0, c12, c0, 0"::"r"(x))

#define CP15_GET_SCR(x)    \
	__asm__ volatile ("mrc p15, 0, %0, c1, c1, 0":"=r"(x))

extern void *vector_table;
extern void tzic_init(void);
extern void uart_init(void);
extern void uart_putc(char c);
extern char uart_getc(void);
extern void uart_puts(const char *s);
extern void uart_putnum(unsigned int number, int base);

void fiq_c_handler(void)
{
	char c;

	uart_puts("FIQ pressed char: ");
	c = uart_getc();
	uart_putc(c);
	uart_putc('\n');
}

void exc_c_handler(void)
{
	uart_putc('E'); uart_putc('X'); uart_putc('C');
}

int main(void)
{
	unsigned int reg;

	CP15_SET_VBAR(&vector_table);
	CP15_CONTROL_WRITE(0);
	CP15_GET_SCR(reg);

	uart_init();

	if (reg & 1) {
		uart_puts("\nNon secure ");
	} else {
		uart_puts("\nSecure ");
	}

	uart_puts("hello world\n");

	tzic_init();

	__asm__ volatile ("msr cpsr, #(0x13|0x80)"); // enable FIQ, IRQ disabled

	while(1);

	return 0;
}
