/*
 *  TOPPERS/SafeG Dual-OS monitor
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Safety Gate Dual-OS monitor
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *     Graduate School of Information Science, Nagoya University, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
#define __REG(x)	(*((volatile unsigned int *)(x)))

#define AIPSTZ_BASE           0x53F00000
#define AISPTZ_MPROT0         (AIPSTZ_BASE + 0x0000)
#define AISPTZ_MPROT1         (AIPSTZ_BASE + 0x0004)
#define AISPTZ_OPACR0         (AIPSTZ_BASE + 0x0040)
#define AISPTZ_OPACR1         (AIPSTZ_BASE + 0x0044)
#define AISPTZ_OPACR2         (AIPSTZ_BASE + 0x0048)
#define AISPTZ_OPACR3         (AIPSTZ_BASE + 0x004C)
#define AISPTZ_OPACR4         (AIPSTZ_BASE + 0x0050)

void aipstz_init(void)
{
	unsigned int csu_reg;

	// Initialize the control registers (u-boot already does this job)
	__REG(AISPTZ_MPROT0) = 0x77777777;
	__REG(AISPTZ_MPROT1) = 0x77777777;
	__REG(AISPTZ_OPACR0) = 0x44444444;
	__REG(AISPTZ_OPACR1) = 0x44444444;
	__REG(AISPTZ_OPACR2) = 0x44444444;
	__REG(AISPTZ_OPACR3) = 0x44444444;
	__REG(AISPTZ_OPACR4) = 0x44000000;

	// set everything to non-secure experimentally
	// CSU values (use x S:0x63F9C000 in ds-5):
	// - 0x63F9C000 ~ 0x63F9C07C: 32 registers 0x00330033
	//   33 is probably the sec_config_X (for each X peripheral, so we can
	//   set 64 peripherals.
	//
	// - To discover the UART1 one, we use "x N:0x53FBC080" until it does not
	//   generate a precise abort (we set FF instead of 33)
	for(csu_reg = 0x63F9C000; csu_reg < 0x63F9C080; csu_reg = csu_reg + 4)
		__REG(csu_reg) = 0x00FF00FF;
}
