/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_sil.h 542 2010-02-24 09:59:10Z ertl-honda $
 */

/*
 *   sil.hΥåװ¸MPCOREѡ
 *
 *  Υ󥯥롼ɥեϡsil.hƬǥ󥯥롼ɤ롥¾Υե
 *  뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥󥯥롼
 *  ɤˡt_stddef.h󥯥롼ɤΤǡ˰¸Ƥ
 *  褤
 */

#ifndef TOPPERS_CHIP_SIL_H
#define TOPPERS_CHIP_SIL_H

/*
 *  ARMǶ̤
 */
#include "arm_gcc/common/core_sil.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ԥåѿchip_config.c
 */
extern uint32_t TOPPERS_spn_var;

/*
 *  ԥåμ
 */
Inline uint32_t
TOPPERS_sil_loc_spn(void)
{
	uint32_t irq_fiq_mask; 
	uint32_t locked;
	uint32_t pre_cpsr_c;
	uint32_t dis_cpsr_c;

	/* ƤӽФcpsrbit07ξ */
	Asm("mrs  %0,CPSR" : "=r"(pre_cpsr_c));

	/* ߥå֤ */
	irq_fiq_mask = TOPPERS_disint();

	/* ߥåְܹԸcpsrbit07ξ */
	Asm("mrs  %0,CPSR" : "=r"(dis_cpsr_c));

	while(true) {
		/* ԥåμ */
		Asm("   mov      r2, #0x01   \n"
			"\t ldrex    r1, [%1]    \n"
			"\t cmp      r1, #0x00   \n"
			"\t msrne    cpsr_c, %2  \n" /* ƤӽФξ֤ءʳߵġ */
			"\t wfene                \n"
			"\t msrne    cpsr_c, %3  \n" /* ߥå֤ */
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked)
			:"r"(&TOPPERS_spn_var),"r"(pre_cpsr_c),"r"(dis_cpsr_c)
			:"r1","r2", "cc");

		if (locked == 0) {
			/* ԥå */
			/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
			Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0));
#elif __TARGET_ARCH_ARM == 7
			Asm("dmb");
#endif /* __TARGET_ARCH_ARM == 7 */
			Asm("":::"memory");
			return irq_fiq_mask;
		}
	}
}

/*
 *  ԥåֵ
 */
Inline void
TOPPERS_sil_unl_spn(uint32_t irq_fiq_mask)
{
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
	Asm("mcr p15, 0, %0, c7, c10, 5"::"r" (0));
#elif __TARGET_ARCH_ARM == 7
	Asm("dmb");
#endif /* __TARGET_ARCH_ARM == 7 */
	TOPPERS_spn_var = 0U;
	/* Data Sync Barrier */
#if __TARGET_ARCH_ARM == 6
	Asm("mcr	p15, 0, %0, c7, c10, 4"::"r"(0));
#elif __TARGET_ARCH_ARM == 7
	Asm("dsb");
#endif /* __TARGET_ARCH_ARM == 7 */
	/* ԥåԤΥإ٥Ȥ */
	Asm("sev");

	/* ԥåμξ֤ */
	TOPPERS_set_fiq_irq(irq_fiq_mask);
}

/*
 *  ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_irq_fiq_mask = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_irq_fiq_mask))

/*
 *  ץåIDμ
 */
Inline void
sil_get_pid(ID *p_prcid)
{
	uint32_t index;

	Asm("mrc p15, 0, %0, c0, c0, 5":"=r"(index));
	*p_prcid = (index & 0x0f) + 1;
}
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CHIP_SIL_H */
