/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2009-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: arm.h 2 2008-05-09 18:12:27Z ertl-honda $
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "chip_test.h"

/*
 *  ޥȥ쥸
 */
static void * const tm_cnt[] = {
	(void *)(MPCORE_PMR_BASE + 0x0708),
	(void *)(MPCORE_PMR_BASE + 0x0808),
	(void *)(MPCORE_PMR_BASE + 0x0908),
	(void *)(MPCORE_PMR_BASE + 0x0a08),
};

/*
 *  ޳ߥơ쥸
 */
static void * const tm_isr[] = {
	(void *)(MPCORE_PMR_BASE + 0x070C),
	(void *)(MPCORE_PMR_BASE + 0x080C),
	(void *)(MPCORE_PMR_BASE + 0x090C),
	(void *)(MPCORE_PMR_BASE + 0x0a0C),
};

/*
 *  ޳ߥɥ쥸
 */
static void * const tm_lr[] = {
	(void *)(MPCORE_PMR_BASE + 0x0700),
	(void *)(MPCORE_PMR_BASE + 0x0800),
	(void *)(MPCORE_PMR_BASE + 0x0900),
	(void *)(MPCORE_PMR_BASE + 0x0a00),
};

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick(void)
{
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_stop_tick_pe(i);
	}
}

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick_pe(ID prcid)
{
	uint_t prc_index = prcid - 1;
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	sil_wrw_mem(tm_cnt[prc_index], 00);
	SIL_UNL_SPN();
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick(void)
{
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_start_tick_pe(i);
	}
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick_pe(ID prcid)
{
	uint_t prc_index = prcid - 1;
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	sil_wrw_mem(tm_cnt[prc_index],
				(MPCORE_TM_PS_1MHZ << MPCORE_TM_CNT_PS_OFFSET)
				| MPCORE_TM_CNT_IEN | MPCORE_TM_CNT_AR | MPCORE_TM_CNT_EN);
	SIL_UNL_SPN();
}

/*
 *  ƥåιץå(ƥå߾֤ǸƤӽФ)
 */
void
ttsp_target_gain_tick(void) {
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_gain_tick_pe(i);
	}
}

/*
 *  ƥåιץå(ƥå߾֤ǸƤӽФ)
 */
void
ttsp_target_gain_tick_pe(ID prcid) {
	uint_t prc_index = prcid - 1;
	volatile PCB *p_pcb = get_mp_p_pcb(prcid);
	EVTTIM	current_time1, current_time2;
	ID pid;
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	current_time1 = p_pcb->p_tevtcb->current_time;

	/* ޡΥȡʥȥɤʤ*/
	sil_wrw_mem(tm_cnt[prc_index],
				(MPCORE_TM_PS_1MHZ << MPCORE_TM_CNT_PS_OFFSET)
				| MPCORE_TM_CNT_IEN | MPCORE_TM_CNT_EN);
	SIL_UNL_SPN();

	/* PEФƤϡ֤ʤޤԤ */
	sil_get_pid(&pid);
	if (pid == prcid) {
		do{
			current_time2 = p_pcb->p_tevtcb->current_time;
		}while(current_time1 == current_time2);
	}
}

/*
 *  ƥåѥ޳׵ȯʼץå(ƥå߾֤ǸƤӽФ)
 */ 
void
ttsp_target_raise_tick_int(void)
{
	uint_t prc_index = x_prc_index();
	SIL_PRE_LOC;

	SIL_LOC_SPN();

	/* ޡΥȡʥȥɤʤ*/
	sil_wrw_mem(tm_cnt[prc_index],
				(MPCORE_TM_PS_1MHZ << MPCORE_TM_CNT_PS_OFFSET)
				| MPCORE_TM_CNT_IEN | MPCORE_TM_CNT_EN);
	SIL_UNL_SPN();

	/* ȯޤԤ */
	while((sil_rew_mem(tm_isr[prc_index]) & MPCORE_TM_ISR_SCBIT) != MPCORE_TM_ISR_SCBIT);
}
