/*
 *  TOPPERS/FMP Kernel  
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_wdt.c 64 2011-09-29 14:00:04Z ertl-tohta $
 */

/*
 *  ޥɥ饤СARM PrimeCell Watchdog Timer Moduleѡ
 *  
 *  [Private TimerȤΰ㤤]
 *  Watchdog Timerˤ Timer mode  Watchdog mode2Υ⡼ɤ롣
 *      Timer mode    : Watchdog Counter Register 0ˤʤꡢĳߤ
 *                      ĤƤ硢ߤȯ(ֹ30)
 *      Watchdog mode : Watchdog Counter Register 0ˤʤä硢CPU
 *                      ꥻåȿ椬Ϥ롣
 *  
 *  ܥɥ饤ФǤ Watchdog Timer̾ΥޤȤƻѤ뤿ᡢ
 *  Timer mode ꤷƤ롣
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"


/*
 *  ޳׵Υꥢ
 */
Inline void
target_timer_int_clear()
{
	/* ڥǥ󥰥ӥåȤ򥯥ꥢ */
	sil_wrw_mem((void *)MPCORE_WDT_ISR, MPCORE_WDT_ISR_SCBIT);
}

/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
	uint32_t    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

	/*  */
	sil_wrw_mem((void *)MPCORE_WDT_CNT, 0x00);

    /* Watchdog Timer ̾勵ޤȤ */
    sil_wrw_mem((void *)MPCORE_WDT_DR, 0x12345678);
    sil_wrw_mem((void *)MPCORE_WDT_DR, 0x87654321);

	/*  */
	sil_wrw_mem((void *)MPCORE_WDT_CNT, 0x00);

	/* ڥǥ󥰥ӥåȥꥢ */
	target_timer_int_clear();

	/* ͤ */
	sil_wrw_mem((void *)MPCORE_WDT_LR, cyc - 1);

	/*
	 * ޡ(ߵ)
	 * 1MHzǥȤ褦˥ץꥹ顼
	 */
	sil_wrw_mem((void *)MPCORE_WDT_CNT,
				(MPCORE_TM_PS_1MHZ << MPCORE_WDT_CNT_PS_OFFSET)
                //| MPCORE_WDT_CNT_WDTMODE
				| MPCORE_WDT_CNT_IEN
                | MPCORE_WDT_CNT_AR
                | MPCORE_WDT_CNT_EN
                );
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
	/* ߥꥢ */
	target_timer_int_clear();

	/*  */
	sil_wrw_mem((void *)MPCORE_WDT_CNT, 0x00);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
	ID prcid;

	/* ߥꥢ */
	target_timer_int_clear();

	iget_pid(&prcid);
	i_begin_int((0x10000 << (prcid - 1))|DIC_IRQNO_WDT);
	signal_time();     /* ƥåζ */
	i_end_int((0x10000 << (prcid - 1))|DIC_IRQNO_WDT);
}
