/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: mpcore.c 553 2010-03-16 02:51:56Z ertl-honda $
 */

#include "kernel_impl.h"

/*
 *  DIC CPU󥿥եϢ
 */

/*
 *  CPU󥿥եν
 */
void
dic_cpu_init(void)
{
	/* CPU󥿥ե̵ */
	sil_wrw_mem((void *)DIC_CPUIF_CR, 0);

	/* ͥ٤ */
	dic_cpu_set_priority(DIC_MIN_PRIORITY);

	/* ͥ٤ӥåͭ */
	dic_cpu_set_bp(DIC_CPUIF_BPR_ALL);

	/* ڥǥ󥰤ƤǽΤǡEOI ˤꥯꥢ */
	sil_wrw_mem((void *)DIC_CPUIF_EOI,
				sil_rew_mem((void *)DIC_CPUIF_IAR));
#ifdef NONTRUST
	/* CPU󥿥եͭ */
	sil_wrw_mem((void *)DIC_CPUIF_CR, DIC_CPUIF_CR_EN);
#else

#ifdef TOPPERS_WITH_SAFEG
	/* CPU󥿥եͭ */
	sil_wrw_mem((void *)DIC_CPUIF_CR, (DIC_CPUIF_CR_EN_S|DIC_CPUIF_CR_EN_NS|DIC_CPUIF_CR_FIQEN) );
#else
	/* CPU󥿥եͭ */
	sil_wrw_mem((void *)DIC_CPUIF_CR, DIC_CPUIF_CR_EN);
#endif /* TOPPERS_WITH_SAFEG */

#endif /* NONTRUST */
}

/*
 *  CPU󥿥եνλ
 */
void
dic_cpu_stop(void)
{
	/* CPU󥿥ե̵ */
	sil_wrw_mem((void *)(DIC_CPUIF_CR), 0);
}


/*
 * DIC DIS󥿥եϢ
 */

/*
 *  ߶ػ
 */
void
dic_disable_int(uint8_t id)
{
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((void *)(DIC_CE + offset_addr), (1 << offset_bit));
}

/*
 *  ߵ
 */
void
dic_enable_int(uint8_t id)
{
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((void *)(DIC_SE + offset_addr), (1 << offset_bit));
}

/*
 * ߥڥǥ󥰥ꥢ
 */
void
dic_clear_pending(uint8_t id)
{
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((void *)(DIC_CP + offset_addr), (1 << offset_bit));
}

/*
 *  ߥڥǥ󥰥å
 */
void
dic_set_pending(uint8_t id){
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((void *)(DIC_SP + offset_addr), (1 << offset_bit));
}

/*
 *  ׵Υå
 */
bool_t
dic_probe_int(uint8_t id){
	uint32_t state;
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	state = sil_rew_mem((void *)(DIC_SP + offset_addr));

	if ((state & (1 << offset_bit)) == (1 << offset_bit)) {
		return(true);
	}
	else {
		return(false);
	}
}

/*
 *  ߥե졼
 */
void
dic_config(uint8_t id, uint8_t config){
	uint16_t offset_addr;
	uint16_t offset_bit;
	uint32_t cfgr_reg_val;
	SIL_PRE_LOC;

	offset_addr = (id / 16) * 4;
	offset_bit  = (id % 16) * 2;

	SIL_LOC_SPN();
	cfgr_reg_val  = sil_rew_mem((void *)(DIC_ICR + offset_addr));
	cfgr_reg_val &= ~(0x03U << offset_bit);
	cfgr_reg_val |= (0x03U & config) << offset_bit;
	sil_wrw_mem((void *)(DIC_ICR + offset_addr), cfgr_reg_val);
	SIL_UNL_SPN();
}

/*
 *  ͥ٤Υå
 *  ɽϤ
 */
void
dic_set_priority(uint8_t id, int pri){
	uint16_t offset_addr;
	uint16_t offset_bit;
	uint32_t pr_reg_val;
	SIL_PRE_LOC;

	offset_addr = (id / 4) * 4;
	offset_bit  = ((id % 4) * 8) + IPM_BIT_OFFSET;

	SIL_LOC_SPN();
	pr_reg_val  = sil_rew_mem((void *)(DIC_IPR + offset_addr));
	pr_reg_val &= ~(IPM_BIT_MASK << offset_bit);
	pr_reg_val |= (IPM_BIT_MASK & pri) << (offset_bit); 
	sil_wrw_mem((void *)(DIC_IPR + offset_addr), pr_reg_val);
	SIL_UNL_SPN();
}

/*
 *  DICߥåȤ
 *  cpusϥåȤȤCPUΥӥåȥѥǻ
 *   CPU0 : 0x01
 *   CPU1 : 0x02
 *   CPU2 : 0x04
 *   CPU3 : 0x08
 */
void
dic_set_target(uint8_t id, uint8_t cpus)
{
	uint32_t offset_addr;
	uint32_t offset_bit;
	uint32_t itr_reg_val;
	SIL_PRE_LOC;

	offset_addr = (id / 4) * 4;
	offset_bit  = (id % 4) * 8;

	SIL_LOC_SPN();
	itr_reg_val  = sil_rew_mem((void *)(DIC_ITR + offset_addr));
	itr_reg_val &= ~(0xf << offset_bit);
	itr_reg_val |= (cpus << offset_bit);
	sil_wrw_mem((void *)(DIC_ITR + offset_addr), itr_reg_val);
	SIL_UNL_SPN();
}

/*
 * GICγߥƥ
 * ֹȤΥƥǻ
 * ns(non secure bit) : 
 *     0 -> secure(FIQ) setting
 *     1 -> non-secure(IRQ) setting
 */
void dic_set_security(int intno, unsigned int ns){
    unsigned int reg = DIC_SEC + ((intno/32)*4);
    *((volatile unsigned int *)reg) |= (ns << (intno%32));
}


/*
 *  DIC󥿥եν
 */
void
dic_init(void)
{
	int i;
	unsigned int add;

	/* DIC󥿥ե̵ */
	sil_wrw_mem((void *)(DIC_CR), 0);

	// all interrupts are secure setting
	for(add=0x1E001080; add<=0x1E0010FC; add+=4){
		*((volatile unsigned int *)add) = 0x0; //0xFFFFFFFF;
	}

#if __TARGET_ARCH_ARM == 7
#ifndef NONTRUST
    /* ߤΥƥ */
    dic_set_security(54,1);
    dic_set_security(57,1);    
    dic_set_security(58,1);    
    dic_set_security(66,1);    
    dic_set_security(67,1);    
    dic_set_security(76,1);    
    dic_set_security(79,1);
	//non-trust timer (Test Chip¢SP804_0) non-secure setting(for Linux)
    dic_set_security(80,1);    
	//non-trust timer (Test Chip¢SP804_1) non-secure setting
    dic_set_security(81,1);    

	//non-trust UART non-secure setting
    dic_set_security(84,1);        

#endif
#endif /* __TARGET_ARCH_ARM == 7 */

	/* ߤƶػ */
	for(i = 0; i < DIC_TNUM_INT/32; i++){
		sil_wrw_mem((void *)(DIC_CE + (4 * i)), 0xffffffff);
	}

	/* ڥǥ󥰤򥯥ꥢ */
	for(i = 0; i < DIC_TNUM_INT/32; i++){
		sil_wrw_mem((void *)(DIC_CP + (4 * i)), 0xffffffff);
	}

	/* ͥٺ  */
	for(i = 0; i < DIC_TNUM_INT/4; i++){
		sil_wrw_mem((void *)(DIC_IPR + (4 * i)), 0xffffffff);
	}

	/* åȽCPU0ء */
	for(i = TMIN_GLOBAL_INTNO/4; i < DIC_TNUM_INT/4; i++){
//	for(i = 0; i < DIC_TNUM_INT/4; i++){
		sil_wrw_mem((void *)(DIC_ITR + (4 * i)), 0x01010101);
	}

	/* ⡼ɽ(1-N Level) */
	for(i = 0; i < DIC_TNUM_INT/16; i++){
		sil_wrw_mem((void *)(DIC_ICR + (4 * i)), 0x55555555);
	}
#ifndef NONTRUST
	/* DIC󥿥եͭ */
	sil_wrw_mem((void *)(DIC_CR), (DIC_CR_ENABLE|DIC_CR_NS_ENABLE));
#else
	/* DIC󥿥եͭ */
	sil_wrw_mem((void *)(DIC_CR), DIC_CR_ENABLE);
#endif
}


/*
 * (trust only)
 * ǽ(ޥץåʳǤ¹Ԥ)ߥƥν
 * SGIγֹΥƥץåǹԤɬפ롣
 */
void
dic_sgi_sec_init(void)
{
	/* DIC󥿥ե̵ */
	sil_wrw_mem((void *)(DIC_CR), 0);

    /* all SGI non-secure setting */
    //*((volatile unsigned int *)0x1E001080) = 0xFFFF;
    /* all PPI non-secure setting */
    //*((volatile unsigned int *)0x1E001080) |= 0xFFFF0000;

	/*
     * SGI non-secure setting 
	 * ȥ饹¦Ǥϳֹ23ץåֳֹȤƻȤȤˤ
     * ( kzm_ca9Linux(SMP)ǤϡꥳΥ֡Ȥ
     *   swi(ֹ1)Ѥ뤿 )
     */
    dic_set_security(0,1);    
    dic_set_security(1,1);    
    //dic_set_security(2,1);    
    //dic_set_security(3,1);    

	/* PPI non-secure setting */
    dic_set_security(29,1);        

	/* DIC󥿥եͭ */
	sil_wrw_mem((void *)(DIC_CR), (DIC_CR_ENABLE|DIC_CR_NS_ENABLE));
}


/*
 *  DIC󥿥եνλ
 */
void
dic_stop(void)
{
	/* DIC󥿥ե̵ */
	sil_wrw_mem((void *)(DIC_CR), 0);
}

/*
 *
 * SCUϢδؿ
 *
 */


#ifdef NONTRUST
#include "safeg_syscalls.h"
#endif


/*
 *  CP15AUXILIARY쥸SAӥåȤ򥻥åȤSMP⡼ɤˤ
 */
Inline void
enable_sa(void){
	uint32_t bits;

	CP15_AUXILIARY_READ(bits);
	bits |= CP15_AUXILIARY_SA_BIT;
#ifndef NONTRUST
	CP15_AUXILIARY_WRITE(bits);
#endif

//#ifdef NONTRUST
//	safeg_switch_to_t(T_SMC_SWITCH_RET, 0);
//#endif
}

Inline void
scu_enable(void){
	uint32_t scu_ctrl;

	/* SCU tag RAMS ̵ */
	sil_wrw_mem((void*)MPCORE_SCU_IALL, MPCORE_SCU_IALL_WAYS);

	/* SCUͭ */
	scu_ctrl  = sil_rew_mem((void *)MPCORE_SCU_CTRL);
	scu_ctrl |= MPCORE_SCU_CTRL_EN;
	sil_wrw_mem((void *)MPCORE_SCU_CTRL, scu_ctrl);
}

/*
 *  SCUνʥޥץåΤ߼¹ԡ
 */
void
scu_init(void){
	/* SCU ͭ */
	scu_enable();

	/* ƤΥΥ⡼ɤNORMALȤ */
	sil_wrw_mem((void *)MPCORE_SCU_CPUST, 0x00U);
	
#ifndef NONTRUST
	/* Υȥ饹¦A9¢ޤؤΥ */
	sil_wrw_mem((void *)MPCORE_SCU_SNSAC, 0xFFF); //CPU
	//sil_wrw_mem((void *)MPCORE_SCU_SNSAC, 0x111);  //CPU0Τߵ
#endif
}


/*
 *  SMP⡼ɤꤹ
 */
void
mpcore_smp_mode_enable(void){
	uint32_t sr;

	/* ߶ػ */
	sr = current_sr();
	set_sr(sr|CPSR_IRQ_BIT|CPSR_FIQ_BIT);
	//set_sr(sr|CPSR_CPULOCK);
	
	/* 㥷̵ */
	mpcore_dcache_clean_and_invalidate();
	mpcore_icache_invalidate();

	/* Data Synchronization Barrier */
	mpcore_data_sync_barrier();

	/* TLBν */
	mpcore_invalidate_unfied_tlb();

	/* CP15SMP/nAMP bit 򥻥åȤ */
	enable_sa();

	/* ߶ػ߾֤򸵤᤹ */
	set_sr(sr);
}

/*
 *  Då򳫻
 */
void
mpcore_dcache_enable(void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);

	/* ǤONʤ꥿ */
	if (bits & CP15_CONTROL_C_BIT){
		return;
	}

	mpcore_dcache_invalidate();

	bits |= CP15_CONTROL_C_BIT;
	CP15_CONTROL_WRITE(bits);
}

/*
 *  Dåߤ̵Ȥ롥
 *  CA9ǤϡDå夬̵ʾ֤Clean and Invalidate()¹Ԥȡ
 *  ˽뤿ᡤDåξ֤ȽǤơ̵ʾϡInvalidate
 *  ΤߤԤ 
 */
void
mpcore_dcache_disable(void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);
	if( bits & CP15_CONTROL_C_BIT ){
		bits &= ~CP15_CONTROL_C_BIT;
		CP15_CONTROL_WRITE(bits);
		mpcore_dcache_clean_and_invalidate();
	}
	else{
		mpcore_dcache_invalidate();
	}
}

/*
 * Iåγ
 */
void mpcore_icache_enable (void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);

	/*
	 *  Ǥͭʤ꥿
	 */
	if(bits & CP15_CONTROL_I_BIT){
		return;
	}

	mpcore_icache_invalidate();

	bits |= CP15_CONTROL_I_BIT;
	CP15_CONTROL_WRITE(bits);
}

/*
 *  Iå
 */
void
mpcore_icache_disable (void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);
	bits &= ~CP15_CONTROL_I_BIT;
	CP15_CONTROL_WRITE(bits);

	mpcore_icache_invalidate();
}

/*
 *  I/Dåξͭ
 */
void
mpcore_cache_enable(void)
{
	mpcore_dcache_enable();
	mpcore_icache_enable();
}

/*
 *  I/Dåξ̵
 */
void
mpcore_cache_disable(void)
{
	mpcore_dcache_disable();
	mpcore_icache_disable();
}

/*
 *  MMUϢΥɥ饤
 */
#define DOMAIN_NO  1
#define PAGE_TABLE_SIZE  0x00004000 /* 4KB */

/*
 * ڡơ֥
 */
static uint8_t PageTable[TNUM_PRCID][PAGE_TABLE_SIZE]  __attribute__ ((aligned (0x4000)));

#define my_PageTable (PageTable[x_prc_index()])

/*
 * ڡơ֥Υꤹ
 */
static void
mmu_set_section(uintptr_t va, uintptr_t pa,
                uint8_t s, uint8_t tex, uint8_t ap,
                uint8_t c, uint8_t b)
{
	uint32_t ttb;
	uint32_t *sptr;

	/*
	 * ڡơ֥Υ١ɥ쥹
	 */
	CP15_TTB0_READ(ttb);

	/*
	 * VA饻Υɥ쥹
	 */
	sptr  = (uint32_t *)((ttb & 0xFFFFC000) | (((va & 0xFFF00000) >> 20) << 2));
	*sptr = pa | (s << 16) | (tex << 12) | (ap << 10) | (c << 3) | (b << 2) | (1 << 1);
	
}

#define SIZE_1M    0x00100000

/*
 * ˽,Υޥåԥ󥰤Ԥ
 * ޥåԥ󥰤ñ̤1MB 
 */
void
mmu_map_memory(MEMORY_ATTRIBUTE *m_attribute)
{
	uint32_t size;
	uintptr_t va;
	uintptr_t pa;

	size = m_attribute->size;
	va   = m_attribute->va;
	pa   = m_attribute->pa;

	/* MBñ̤ˤʤ褦˥ */
	size = (size + 0x000FFFFF) & ~0x000FFFFF;

	while(size > 0) {
		mmu_set_section(va, pa,
						m_attribute->s,
						m_attribute->tex,
						m_attribute->ap,
						m_attribute->c,
						m_attribute->b);

		va   += SIZE_1M;
		pa   += SIZE_1M;
		size -= SIZE_1M;
	}

	
}




/*
 *  MMUν
 */
void
mpcore_mmu_init(void){
	MEMORY_ATTRIBUTE m_attribute;

	uint32_t bits = 0;

	/* ץեåХåե򥯥ꥢ */
	mpcore_pbuffer_flash();
	
	/*
	 * TTBR0ѤѤ˻
	 */
	CP15_TTBCR_WRITE(0);


	/*
	 * Ѵơ֥(TT)ȤơPageTableѤ
	 * SharedӥåȤ򥻥å 
	 */
#if __TARGET_ARCH_ARM == 6
	CP15_TTB0_WRITE((((uint32_t)my_PageTable)|CP15_TTB0_RGN_S|CP15_TTB0_RGN_WBWA));
#else /* __TARGET_ARCH_ARM == 7 */
	CP15_TTB0_WRITE((((uint32_t)my_PageTable)|CP15_TTB0_RGN_S|CP15_TTB0_RGN_WBWA|CP15_TTB0_IRGN_WBWA));
#endif /* __TARGET_ARCH_ARM == 7 */

	/* ץեåХåե򥯥ꥢ */
	mpcore_pbuffer_flash();


	/*
	 * ʪɥ쥹 = ۥɥ쥹
	 * Υ󥭥å֥롤ΥХåե֥Ȥ 
	 */
	m_attribute.pa   = 0x00000000;
	m_attribute.va   = m_attribute.pa;
	m_attribute.size = 0x80000000;
	m_attribute.s    = 1;          /* ͭ         */
	m_attribute.ap   = 3;          /* ե륢 */
	m_attribute.tex  = 0;          /* Strongly Ordered */
	m_attribute.c    = 0;
	m_attribute.b    = 0;


	mmu_map_memory (&m_attribute);


	m_attribute.pa   = 0x80000000;
	m_attribute.va   = m_attribute.pa;

	mmu_map_memory (&m_attribute);

	/*
	 *  åȰ¸ǤMMUν
	 */
	target_mmu_init();


	/*
	 * ɥᥤֹ򥻥å
	 */
	CP15_DOMAINS_WRITE(DOMAIN_NO);

	/*
	 * CONTROLץå MӥåȡXPӥåȤ򥻥åȤơ
	 * MMUͭˤ
	 */
	CP15_CONTROL_READ(bits);
	bits |= CP15_CONTROL_M_BIT | CP15_CONTROL_XP_BIT;
	CP15_CONTROL_WRITE(bits);
}

#if __TARGET_ARCH_ARM == 6
/*
 * SCU󥿤νMN0ѡ
 */
void
scu_counter_init(void)
{
	/*
	 *  MN0 Cycle Count 
	 */
	sil_wrw_mem((void *)MPCORE_SCU_PM_EVT0,
				sil_rew_mem((void *)MPCORE_SCU_PM_EVT0) | MPCORE_SCU_PM_EVT_CYC_COUNT0_4);

	/*
	 *  ꥻåȤȥ
	 */
	sil_wrw_mem((void *)MPCORE_SCU_PM_CTRL,
			sil_rew_mem((void *)MPCORE_SCU_PM_CTRL) | MPCORE_SCU_PM_CTRL_RST | MPCORE_SCU_PM_CTRL_ENA);
}
#endif /* __TARGET_ARCH_ARM == 6 */
