/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *								Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2001-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	@(#) $Id$
 */

/*
 *		ץå¸⥸塼SH2A-DUALѡ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *	ƳֹIPRξơ֥
 *	Ƥϡץå˰ۤʤΤᡤ
 *	ץåե
 */
const IPR_INFO ipr_info_tbl[TNUM_INT] = {
	IPR_INFO_TBL_DATA
};

extern PCB* const p_pcb_table[TNUM_PRCID];
extern const FP* const p_vectors_table[TNUM_PRCID];

/*
 *	ץå¸ν
 */
void
prc_initialize(void)
{
	uint_t pindex;
	PCB *my_p_pcb;
	TPCB *my_p_tpcb;
	
	pindex = sil_get_pindex();
	my_p_pcb = p_pcb_table[pindex];
	my_p_tpcb = &(my_p_pcb->target_pcb);
	set_gbr(my_p_pcb);	/*  ׸Ƥgcc¸  */

   /*
	*  ƥȤν
	*  ͥ뵯ư󥿥ƥȤȤư뤿ᡢ
	*  excnest_count1ˤƤ
	*/
	my_p_tpcb->excnest_count = 1;
	my_p_tpcb->istkpt = istkpt_table[pindex];
	
	/*
	 *	CPUåե饰¸Τѿν
	 */
	my_p_tpcb->lock_flag = true;
	my_p_tpcb->saved_iipm = IIPM_ENAALL;
	
	/*
	 *	ߥȥν
	 *	ץå
	 */
	irc_initialize(pindex);

	/*
	 *	٥١쥸ν
	 */
	set_vbr((void *)p_vectors_table[pindex]);
}

/*
 *	ץå¸νλ
 */
void
prc_exit(void)
{
	/*
	 *	software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *	ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *	Ǥ롥
	 */
	if (x_sense_mprc()) {
		extern void    software_term_hook(void);
		void (*volatile fp)(void) = software_term_hook;

		if (fp != 0) {
			(*fp)();
		}
	}
}

#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 *	ϿƤʤ㳰ȯȸƤӽФ
 */
void
default_exc_handler(void *p_excinf)
{
	uint32_t *sp	= (uint32_t*)p_excinf;
	uint32_t excno  = *(sp + P_EXCINF_OFFSET_VECTOR);
	uint32_t pc 	= *(sp + P_EXCINF_OFFSET_PC);
	uint32_t sr 	= *(sp + P_EXCINF_OFFSET_SR);
	uint32_t pr 	= *(sp + P_EXCINF_OFFSET_PR);
	uint32_t *sp_val = sp + P_EXCINF_OFFSET_SP;
	uint32_t prcid, local_excno, reg, i;
	char 	 *msg;
	
	local_excno = excno & 0xffffU;
	prcid = excno >> 16U;
	
	switch(local_excno) {
		case POWER_ON_RESET_VECTOR:
			msg = "Power on reset exception occurs.";
			break;
		case MANUAL_RESET_VECTOR:
			msg = "Manual reset exception occurs.";
			break;
		case GENERAL_ILLEGAL_INSTRUCTION_VECTOR:
			msg = "General illegal instruction exception occurs.";
			break;

#ifdef RAM_ERROR_VECTOR
		case RAM_ERROR_VECTOR:
			msg = "RAM error exception occurs.";
			break;
#endif	/*	RAM_ERROR_VECTOR  */

		case SLOT_ILLEGAL_INSTRUCTION_VECTOR:
			msg = "Slot illegal instruction exception occurs.";
			break;
		case CPU_ADDRESS_ERROR_VECTOR:
			msg = "CPU address error exception occurs.";
			break;
		case NMI_VECTOR:
			msg = "NMI occurs.";
			break;
		case USER_BREAK_VECTOR:
			msg = "User break interrupt occurs.";
			break;
		case H_UDI_VECTOR:
			msg = "H-UDI interrupt occurs.";
			break;
		case DIVIDE_BY_ZERO_VECTOR:
			msg = "Divided by 0 exception occurs.";
			break;
		case OVER_FLOW_VECTOR:
			msg = "Over flow exception occurs.";
			break;
		case SLEEP_ERROR_VECTOR:
			msg = "Sleep error occurs.";
			break;

#ifdef DMA_ADDRESS_ERROR_VECTOR
		case DMA_ADDRESS_ERROR_VECTOR:
			msg = "DMA address error exception occurs.";
			break;
#endif	/*	DMA_ADDRESS_ERROR_VECTOR  */

#ifdef FPU_VECTOR
		case FPU_VECTOR:
			msg = "FPU exception occurs.";
			break;
#endif /*  FPU_VECTOR  */

#if defined(SH2A) || defined(SH2A_DUAL)
		case BANK_OVER_FLOW_VECTOR:
			msg = "Bank over flow exception occurs.";
			break;
		case BANK_UNDER_FLOW_VECTOR:
			msg = "Bank under flow exception occurs.";
			break;
#endif /*  defined(SH2A) || defined(SH2A_DUAL)	*/

		default:
   			msg = "Unregistered Expevt error occurs.";
   			break;
   	}
	syslog_1(LOG_EMERG, "%s", msg);

	syslog_2(LOG_EMERG, "(prcid = %d, Local EXCNO = %d)",
							prcid, local_excno);
	syslog_3(LOG_EMERG, "VectorNo = %d PC = 0x%08x SP = 0x%08p",
		   excno, pc, sp_val);
	syslog_2(LOG_EMERG, "SR = 0x%08x PR=0x%08x", sr, pr);
	for(i = 0; i < 8; ++i) {
		reg = *(sp + P_EXCINF_OFFSET_R0 + i);
		syslog_2(LOG_EMERG, " r%d=0x%08x", i, reg);
	}
	target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *	̤Ͽγߤȯ˸ƤӽФ
 */
void
default_int_handler(INTNO intno)
{
	INTNO local_intno  	= LOCAL_INTNO(intno);
	uint_t prcid		= ((uint_t)intno) >> 16U;
	
	syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
	syslog_1(LOG_EMERG, "INTNO = %d",intno);
	syslog_2(LOG_EMERG, "(prcid = %d, Local INTNO = %d)",
							prcid, local_intno);
	target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
