/*
 *	TOPPERS Software
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2009 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *  @(#) $Id$
 */

/*
 *	sil.hΥץå¸SH2A-DUALѡ
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ǥȿž
 */
Inline uint16_t toppers_sil_rev_endian_uint16(uint16_t src)
{
	uint16_t dst;
	Asm("swap.b %1, %0" : "=r"(dst) : "r"(src) );
	return dst;
}

#define	TOPPERS_SIL_REV_ENDIAN_UINT16(data) \
		toppers_sil_rev_endian_uint16(data)

Inline uint32_t toppers_sil_rev_endian_uint32(uint32_t src)
{
	uint32_t dst;
	Asm("swap.b %1, %0 \n"		/*  0x12340x1243  */
		"swap.w %0, %0 \n" 		/*  0x12430x4312  */
		"swap.b %0, %0"			/*  0x43120x4321  */
		: "=r"(dst) : "r"(src) );
	return dst;
}

#define	TOPPERS_SIL_REV_ENDIAN_UINT32(data) \
		toppers_sil_rev_endian_uint32(data)

/*
 *	쥸ؿ
 *	ηåΤᡢȤ̤򤷤Ƥ롣
 */

/*
 *	8ӥåȡ쥸ɽФ
 */
Inline uint8_t
sil_reb_reg(uint8_t *reg)
{
	uint8_t	data;

	data = *((volatile uint8_t *) reg);
	return(data);
}

Inline void
sil_wrb_reg(uint8_t *reg, uint8_t data)
{
	*((volatile uint8_t *) reg) = data;
}

/*
 *	16ӥåȡ쥸ɽФ
 */
Inline uint16_t
sil_reh_reg(uint16_t *reg)
{
	uint16_t	data;

	data = *((volatile uint16_t *) reg);
	return(data);
}

Inline void
sil_wrh_reg(uint16_t *reg, uint16_t data)
{
	*((volatile uint16_t *) reg) = data;
}

/*
 *	32ӥåȡ쥸ɽФ
 */
Inline uint32_t
sil_rew_reg(uint32_t *reg)
{
	uint32_t	data;

	data = *((volatile uint32_t *) reg);
	return(data);
}

Inline void
sil_wrw_reg(uint32_t *reg, uint32_t data)
{
	*((volatile uint32_t *) reg) = data;
}


/*
 *	16ӥåȡ쥸黻
 */
Inline void
sil_orh_reg(uint16_t *reg, uint32_t bitptn)
{
	uint32_t reg_val = sil_reh_reg(reg);
	
	reg_val |= bitptn;
	sil_wrh_reg(reg, reg_val);
}

Inline void
sil_anh_reg(uint16_t *reg, uint32_t bitptn)
{
	uint32_t reg_val = sil_reh_reg(reg);
	
	reg_val &= bitptn;
	sil_wrh_reg(reg, reg_val);
}


/*
 *	16ӥåȡ쥸Υӥåȡåȡꥢ
 */
Inline void
sil_seth_bit(uint16_t *reg, uint_t bit)
{
	uint32_t reg_val = sil_reh_reg(reg);
	
	/*
	 *	bit7ʲǤС
	 *	bset̿Ÿ뤳Ȥ
	 */
	reg_val |= (1U << bit);
	sil_wrh_reg(reg, reg_val);
}

Inline void
sil_clrh_bit(uint16_t *reg, uint_t bit)
{
	uint32_t reg_val = sil_reh_reg(reg);
	
	/*
	 *	bit7ʲǤС
	 *	bclr̿Ÿ뤳Ȥ
	 */
	reg_val &= ~(1U << bit);
	sil_wrh_reg(reg, reg_val);
}


/*
 *	NMI٤Ƥγߤζػ
 */
Inline uint32_t
TOPPERS_disint(void)
{
	uint32_t  TOPPERS_sr;

	Asm("stc  sr,%0" : "=r"(TOPPERS_sr));
	Asm("ldc %0, sr" : : "r"(TOPPERS_sr | 0x000000f0U) : "memory", "t");
	return(TOPPERS_sr & 0x000000f0U);
}

/*
 *	ͥ٥ޥɽˤθͤ
 */
Inline void
TOPPERS_set_iipm(uint32_t TOPPERS_iipm)
{
	uint32_t  TOPPERS_sr;

	Asm("stc  sr,%0" : "=r"(TOPPERS_sr));
	TOPPERS_sr = (TOPPERS_sr & ~0x000000f0U) | TOPPERS_iipm;
	Asm("ldc %0, sr" : : "r"(TOPPERS_sr) : "memory", "t");
}


/*
 *	ߥå֤
 *	
 *	ǥޥ졼󤷡ΥץåȰۤʤץå
 *	SR쥸ؤν񤭹ߤιͻ
 *	
 *	ޥ졼ȯΤϡޥ졼󸵥ץå
 *	ץå
 *	ߥå֡
 *	ͥ٥ޥ
 *	ξ˸¤Τǡޥ졼Ǽ¹ԺƳݤˤϡ
 *	嵭ξ֤ˤʤäƤꡢSR쥸񤭤Ƥʤ
 */
#define SIL_PRE_LOC 	 uint32_t TOPPERS_saved_iipm
#define SIL_LOC_INT()	 ((void)(TOPPERS_saved_iipm = TOPPERS_disint()))
#define SIL_UNL_INT()	 (TOPPERS_set_iipm(TOPPERS_saved_iipm))

/*
 *	ԥåμ
 */
Inline uint32_t
TOPPERS_sil_loc_spn(void)
{
	uint32_t saved_iipm;
	uint8_t semr0;
	uint8_t *p_semr0 = (uint8_t *)SEMR0;

  retry:
	/* ߥå֤*/
	saved_iipm = TOPPERS_disint();
	
	semr0 = sil_reb_reg(p_semr0);
		/*
		 *	SEMR0 == 0 
		 *	SEMR0 == 1 
		 */
	if (semr0 == 0) {
		/* ԥåǤʤä */
		/* ߥå֤ξ֤ */
		TOPPERS_set_iipm(saved_iipm);
		goto retry;
	}

	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	return saved_iipm;
}

/*
 *	ԥåβ
 */
Inline void
TOPPERS_sil_unl_spn(uint32_t saved_iipm)
{
	/* Ƥ񤭴ǽ */
	Asm("":::"memory");
	sil_wrb_reg((uint8_t *)SEMR0, SEMR_SEMF_BIT);

	/* ߥå֤ξ֤ */
	TOPPERS_set_iipm(saved_iipm);
}

/*
 *	ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_saved_iipm = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_saved_iipm))


/*
 *	ץåINDEX0ꥸˤμ
 *	
 *	CPU00
 *	CPU11
 */
Inline uint_t
sil_get_pindex(void)
{
	uint_t index;
	uint32_t cpuidr = sil_rew_reg((uint32_t *)CPUIDR);
	
	if ((cpuidr & CPUIDR_ID_BIT) == 0U) {
		index = 0U;
	} else {
		index = 1U;
	}
	return index;
}

/*
 *	ץåIDμ
 *	
 *	CPU01
 *	CPU12
 */
Inline void
sil_get_pid(ID *p_id)
{
	*p_id = sil_get_pindex() + 1U;
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
