/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ץå¸⥸塼SH2A-DUALѡ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"


/*
 *	ߥȥΥ쥸
 */
const IRC_REG irc_reg_tbl[TNUM_PRCID] = {
	IRC_REG_DATA
};

/*
 *	߸쥸
 */
uint16_t *const idcnt_tbl[TNUM_IDCNT] = {
	IDCNT_REG_DATA
};

/*
 *	ޥե쥸
 */
uint8_t *const semr_tbl[TNUM_SEMR] = {
	SEMR_REG_DATA
};


/*
 *  str_ker() μ¹˥ޥץåΤ߼¹Ԥ
 */
void
prc_mprc_initialize(void)
{
	int_t i;
	uint16_t *p_idcnt;
	
	/*
	 *	ޥե쥸ν
	 *	SEMRnSEMFӥåȢ1ǡ꥽βɽ
	 */
	for(i = 0; i < TNUM_SEMR; ++i) {
		sil_wrb_mem(semr_tbl[i], SEMR_SEMF_BIT);
	}

	/*
	 * ߸쥸
	 * ڥեοˤäơ߸쥸ι
	 * ۤʤ뤿ᡢåװ¸롣
	 */
	for (i = 0; i < TNUM_IDCNT; ++i) {
		p_idcnt = idcnt_tbl[i];
		if (p_idcnt != NULL) {
			/*
			 *	IDCNTn쥸INTENӥåȤ򥯥ꥢ
			 *    INTENӥåȤ8ӥåȤ˼ޤäƤʤᡢ
			 *    sil_clrh_bitѤƤ⡢Ŭʤ
			 *    ~IDCNT_INTEN򥳥ѥ˵᤿
			 */
			sil_anh_reg(p_idcnt, ~IDCNT_INTEN);
		}
	}
}

/*
 *	׵饤°
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask)
{
	SIL_PRE_LOC;
	INTNO iintno, local_intno;
	uint_t prcindex;
	uint32_t ipr_val;
#ifndef NDEBUG
	bool_t ret;
	uint_t prcid_in_intno = intno >> 16U;
	uint_t bitptn = 1U << (prcid_in_intno - 1U);

	assert((bitptn & affinity_mask) != 0);
	assert(VALID_INTNO_CFGINT(intno));
	assert((-15 <= intpri) && (intpri <= TMAX_INTPRI));
#endif /* NDEBUG */

	local_intno	= LOCAL_INTNO(intno);
	prcindex = x_prc_index();

	SIL_LOC_INT();

	/*
	 *	ö̤˳ߤػߤʳ߶ػߥե饰򥻥åȡ
	 */
#ifdef NDEBUG
	(void)x_disable_int(intno);
#else /* NDEBUG */
	ret = x_disable_int(intno);
	assert(ret == true);
#endif /* NDEBUG */

	/*
	 *	װ˳°ꤹ롣
	 *	ץåֳߤΤ߳ͥ٥뤬ʤΤǡ
	 *	˿ʬ롣
	 */
	if (LOCAL_INTNO_IS_IPI(local_intno)) {
		/*
		 *	ץåֳߤξ
		 *⤷ʤ
		 */
	}
	else {
		iintno = INT_INTNO(local_intno);			/*	׸ƤNMIϳʤ  */
		ipr_val = int_iipm_tbl[prcindex][iintno];	/*	׸ƤNMIϳʤ  */
		/*
		 *	ͥ٥
		 *ֹбIPRͤꤹ롥
		 *IRQߤξ硢߶ػߥե饰ꥢ뤬
		 *(x_enable_int_irq( )ߥå֤ʤΤǡ
		 *Ϥʤ(׸Ƥʤ
		 */
		irc_set_ipr(local_intno, ipr_val, prcindex);
		
		/*
		 *	Ĥγװ˽򿶤ʬ롣
		 */
		if (LOCAL_INTNO_IS_IRQ(local_intno)) {
			/*	IRQξ  */
			x_config_int_irq(local_intno, intatr, prcindex);
		}
		else if (LOCAL_INTNO_IS_PERIPHERAL(local_intno)) {
			/*	¢ե⥸塼ξ  */
			x_config_int_peripheral(local_intno, intatr, prcindex);
		}
		else if (LOCAL_INTNO_IS_PINT(local_intno)) {
			/*	PINTߤξ  */
			x_config_int_pint(local_intno, intatr, prcindex);
		}
		else {
			/*	¾⤷ʤ	*/
			assert(0);
		}
	}

	/*
	 *	߶ػߥե饰򥯥ꥢ(ɬפʾ)
	 */
	if ((intatr & TA_ENAINT) != 0U) {
#ifdef NDEBUG
		(void) x_enable_int(intno);
#else /* NDEBUG */
		ret = x_enable_int(intno);
		assert(ret == true);
#endif /* NDEBUG */
	}

	SIL_UNL_INT();
}

