/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ץå¸⥸塼SH2A-DUALѡ
 *
 *	Υ󥯥롼ɥեϡsh7xxx_config.hʤޤϡ饤
 *	롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *	ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_SH2A_DUAL_CONFIG_H
#define TOPPERS_SH2A_DUAL_CONFIG_H

/*
 *	μ
 */
#define SH2A_DUAL

/*
 *	ѤǤ̿᥻å
 *	SH1̿ˤĤƤϡ٤ƤΥǥݡȤΤǡ
 *	ʤ
 */
#define TOPPERS_SUPPORT_SH2_INSTRUCTION
#define TOPPERS_SUPPORT_SH2E_INSTRUCTION
#define TOPPERS_SUPPORT_SH2A_INSTRUCTION

/*
 *	ʳֹ桿ߥϥɥֹ桿CPU㳰ֹФΥޥ
 */
#define LOCAL_INTNO_MASK	0xffffU
#define LOCAL_INHNO_MASK	0xffffU
#define LOCAL_EXCNO_MASK	0xffffU

/*
 *	Хʳֹ桿CPU㳰ֹ
 *	ʳֹ桿CPU㳰ֹѴޥ
 */
#define LOCAL_INTNO(intno)		((intno) & LOCAL_INTNO_MASK)
#define LOCAL_EXCNO(excno)		((excno) & LOCAL_EXCNO_MASK)


/*
 *	ֹ椫߼̤Ƚ̤뤿Υޥ
 *	prc_config.h٤Υեi_begin_int()
 *	ǻѤ뤿ᡢ˵ҤƤ롣
 */
/*	IRQ  */
#define LOCAL_INTNO_IS_IRQ(intno) 								\
		((TMIN_INTNO_IRQ <= (intno)) && ((intno) <= TMAX_INTNO_IRQ))
#define INTNO_IS_IRQ(intno)		LOCAL_INTNO_IS_IRQ(LOCAL_INTNO(intno))

/*	¢ե⥸塼	*/
#define LOCAL_INTNO_IS_PERIPHERAL(intno) 								\
		((TMIN_INTNO_PERIPHERAL <= (intno)) && ((intno) <= TMAX_INTNO_PERIPHERAL))
#define INTNO_IS_PERIPHERAL(intno)	LOCAL_INTNO_IS_PERIPHERAL(LOCAL_INTNO(intno))

/*	PINT	*/
#define LOCAL_INTNO_IS_PINT(intno) 								\
		((TMIN_INTNO_PINT <= (intno)) && ((intno) <= TMAX_INTNO_PINT))
#define INTNO_IS_PINT(intno)	LOCAL_INTNO_IS_PINT(LOCAL_INTNO(intno))

/*	ץåֳ	*/
#define LOCAL_INTNO_IS_IPI(intno) 								\
		((TMIN_INTNO_IPI <= (intno)) && ((intno) <= TMAX_INTNO_IPI))
#define INTNO_IS_IPI(intno)		LOCAL_INTNO_IS_IPI(LOCAL_INTNO(intno))

/*
 *	ֹ椫IRQֹؤѴ
 */
#define LOCAL_INTNO_TO_IRQNO(intno) (((intno) - TMIN_INTNO_IRQ))
#define INTNO_TO_IRQNO(intno) 	LOCAL_INTNO_TO_IRQNO(LOCAL_INTNO(intno))

/*
 *	ֹ椫PINTֹؤѴ
 */
#define LOCAL_INTNO_TO_PINTNO(intno) (((intno) - TMIN_INTNO_PINT))
#define INTNO_TO_PINTNO(intno) 	LOCAL_INTNO_TO_PINTNO(LOCAL_INTNO(intno))

/*
 *	ֹ椫IDCNT쥸ѥǥåؤѴ
 */
#define LOCAL_INTNO_TO_IDCNT(intno) (((intno) - TMIN_INTNO_IDCNT))
#define INTNO_TO_IDCNT(intno) 	LOCAL_INTNO_TO_IDCNT(LOCAL_INTNO(intno))

/*
 *	ֹ椫ץåֳߤγͥ٥ؤѴ
 */
#define LOCAL_INTNO_TO_IP_INT_LEVEL(intno) \
		(15U - ((intno) - IPI15_VECTOR))
#define INTNO_TO_IP_INT_LEVEL(intno) 	LOCAL_INTNO_TO_IP_INT_LEVEL(LOCAL_INTNO(intno))

/*
 *	ȥIPR쥸Υɥ쥹κ
 */
#define PRC_IPR_OFFSET	(C1IPR01 - C0IPR01)


#ifndef TOPPERS_MACRO_ONLY

#include <sil.h>

/*
 *	ߥȥΥ쥸
 *	
 * ڥեοˤäơߥȥΥ쥸
 * ۤʤ뤿ᡢåװ¸롣
 */
extern const IRC_REG irc_reg_tbl[TNUM_PRCID];

/*
 *	߸쥸
 */
extern uint16_t *const idcnt_tbl[TNUM_IDCNT];

/*
 *	ޥե쥸
 */
extern uint8_t *const semr_tbl[TNUM_SEMR];

/*
 *  str_ker() ǥޥץåǹԤ
 */
extern void prc_mprc_initialize(void);


/*
 * IRCν
 */
Inline void
irc_initialize(uint_t prcindex)
{
   	uint_t i;
   	const IRC_REG * p_irc_reg = &irc_reg_tbl[prcindex];
	
	/*	׸ƤŪ	*/
	/*	׸ƤξץåƱͤˤ	*/
	sil_wrh_reg(p_irc_reg->icr0, 0x0000U);
	sil_wrh_reg(p_irc_reg->icr1, 0x0000U);
	sil_wrh_reg(p_irc_reg->icr2, 0x0000U);
	
#ifdef USE_BANKED_REG
	/*
	 * NMI,UBCʳΤ٤Ƥγߤǥ쥸Х󥯤λѤ
	 * 쥸Х󥯡Сե㳰
	 */
	sil_wrh_reg(p_irc_reg->ibnr, (IBNR_BE0 | IBNR_BOVE));
#else
	/* 쥸Х󥯻Ѷػ */
	sil_wrh_reg(p_irc_reg->ibnr, 0x0000U);
#endif /* USE_BANKED_REG */

   	/*	ͥ٥쥸ν  */
	for (i=0; i < TNUM_IPR; ++i) {
		sil_wrh_reg(p_irc_reg->ipr[i], 0x0000U);
	}
}


/*
 *	IRQߤ°
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 ATR intatr°
 *	 uint_t prcindexץåǥå0ꥸ
 */
Inline void
x_config_int_irq(INTNO local_intno, ATR intatr, uint_t prcindex)
{
	uint16_t *p_irqer, *p_irqrr;
	uint32_t icr1_val	= sil_reh_reg((uint16_t *)C0ICR1);
	uint32_t irqno		= LOCAL_INTNO_TO_IRQNO(local_intno);
	uint32_t offset		= irqno << 1U;	/*	irqno * 2  */

	/*
	 *	åȥꥬλ꤬ʤСǥեȤǥ٥ȥꥬ
	 *	Ȥ롣
	 *	ӥåȤ򥯥ꥢޤޤǤС٥ȥꥬȤʤ롣
	 */
	icr1_val &=  ~(0x03U << offset);
	
	if((intatr & TA_POSEDGE) != 0U) {
		/*
		 *	ݥƥ֥å
		 */
		icr1_val |= (IRQ_POSEDGE << offset);
	}

	/*
	 *	ͥƥ֥åλ꤬롢
	 *	ޤϡåȥꥬǡλ꤬ʤС
	 *	ͥƥ֥åȤ롣
	 */
	if(((intatr & TA_NEGEDGE) != 0U) ||
	   (((intatr & TA_EDGE) != 0U) && ((intatr & TA_BOTHEDGE) == 0U))) {
		/*
		 *	ͥƥ֥å
		 */
		icr1_val |= (IRQ_NEGEDGE << offset);
	}
	/*
	 *	C0ICR1C0ICR1ƱƤꤷʤФʤʤ
	 *	׸Ƥץå֤¾椹ɬפ롣
	 */
	sil_wrh_reg((uint16_t *)C0ICR1, icr1_val);
	sil_wrh_reg((uint16_t *)C1ICR1, icr1_val);
	
	/*
	 *	CnIRQER쥸IRQnӥåȤ򥻥åȤ롣
	 */
	p_irqer = irc_reg_tbl[prcindex].irqer;
	sil_seth_bit(p_irqer, irqno);
	
	/*
	 *	׵Υꥢ
	 *	CnIRQRR쥸IRQnFӥåȤ򥯥ꥢ롣
	 */
	p_irqrr = irc_reg_tbl[prcindex].irqrr;
	sil_clrh_bit(p_irqrr, irqno);
}

/*
 *	¢ե⥸塼뤫γߤ°
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 ATR intatr°
 *	 uint_t prcindexץåǥå0ꥸ
 */
Inline void
x_config_int_peripheral(INTNO local_intno, ATR intatr, uint_t prcindex)
{
	int_t index 		= LOCAL_INTNO_TO_IDCNT(local_intno);
	uint16_t *p_idcnt 	= idcnt_tbl[index];

	/*
	 *	׵դCPUꤹ롣
	 */
	if (prcindex == 0) {
		sil_anh_reg(p_idcnt, ~IDCNT_CPUN);
	}
	else {
		sil_orh_reg(p_idcnt, IDCNT_CPUN);
	}
}

/*
 *	PINTߤ°
 *	 INTNO local_intnoץåǤΥʳֹ
 *	 ATR intatr°
 *	 uint_t prcindexץåǥå0ꥸ
 */
Inline void
x_config_int_pint(INTNO local_intno, ATR intatr, uint_t prcindex)
{
	uint32_t icr2_val	= sil_reh_reg((uint16_t *)C0ICR2);
	uint_t pintno 		= LOCAL_INTNO_TO_PINTNO(local_intno);
	uint32_t bitptn		= 1U << pintno;

	/*
	 *	٥ȥꥬζ
	 *	
	 *	ǥեȤǥ٥ȥꥬ
	 *	Ūʻ꤬Сϥ٥ȥꥬȤ롣
	 */
	if((intatr & TA_HIGHLEVEL) != 0U) {
		/*
		 *	ϥ٥ȥꥬ
		 */
		icr2_val |= bitptn;
	}
	else {
		/*
		 *	٥ȥꥬ
		 */
		icr2_val &= ~bitptn;
	}

	/*
	 *	C0ICR2C0ICR2ƱƤꤷʤФʤʤ
	 *	׸Ƥץå֤¾椹ɬפ롣
	 */
	sil_wrh_reg((uint16_t *)C0ICR2, icr2_val);
	sil_wrh_reg((uint16_t *)C1ICR2, icr2_val);
}

/*
 *	ߥϥɥɬפIRC
 *
 *	IRQߤǤĥåȥꥬξϳ׵򥯥ꥢ롥
 *	åȥꥬ٥ȥꥬȽ̤ȥСإåɤ礭Τǡ
 *	˥ꥢ롥
 *	ʥ٥ȥꥬǥꥢ򤷤ƤⳲϤʤ
 *
 *	IRQRR쥸١ߡ꡼ɤơ ӥåȤ0񤭹ࡣ
 *	δ֡ߥå֤ˤƤΤϡʲΤ褦ʥɤ
 *	ᡣ
 *
 *	3γߤͤ롣
 *	ͥ٤ϡl > m > nνȤ롣
 *	ʳlͥ٤⤤
 *	
 *	1.	mγߤȯ(mӥåȤå)
 *	2.	mγߥϥɥ餬¹(nϳ߶ػ)
 *	3.	IRQRR꡼(l = 0, m = 1, n = 0)
 *	4.	lγߤȯ(lӥåȤå)
 *	5.	lγߥϥɥ餬¹(nϳ߶ػ)
 *	6.	nγߤȯα(nӥåȤå)
 *	7.	IRQRR꡼(l = 1, m = 1, n = 1)
 *	8.	IRQRR饤(l = 0, m = 1, n = 1)
 *	9.	lγߥϥɥ齪λ
 *	10. mγߥϥɥƳ
 *	11. IRQQ饤(l = 0, m = 0, n = 0)
 *	
 *	11ʳ n ꥢǽ롥
 */
Inline void
i_begin_int(INTNO intno)
{
	SIL_PRE_LOC;
	uint_t index;
	uint32_t irqpr, bitptn;
	uint16_t *irqrr_addr;
	INTNO local_intno = LOCAL_INTNO(intno);

	if (LOCAL_INTNO_IS_IRQ(local_intno)) {
		index = x_prc_index();
		irqrr_addr = irc_reg_tbl[index].irqrr;
		/*
		 * ١ߡ꡼ɤơ ӥåȤ0񤭹ࡣ
		 *	ѿbitptnѤƤΤϡߥåζ֤
		 *	û뤿
		 */
		bitptn = ~(0x01U << LOCAL_INTNO_TO_IRQNO(local_intno));
		SIL_LOC_INT();
		irqpr = sil_reh_reg(irqrr_addr);
		irqpr &= bitptn;
		sil_wrh_reg(irqrr_addr, irqpr);
		SIL_UNL_INT();
	}
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *	ץå¸⥸塼SH2A-DUALѡ
 */
#include "prc_config.h"

#endif /* TOPPERS_SH2A_DUAL_CONFIG_H */
