/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.c 512 2010-02-01 05:33:27Z ertl-honda $
 */

/*
 *		ץå¸⥸塼SH4Aѡ
 */
#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  SILΥԥåѿ
 */
uint32_t TOPPERS_spn_var;

/*
 *  å˻Ѥߡѿ
 */
uint32_t dangling_dummy;

/*
 *  ƳֹIPRξơ֥
 *  Ƥϡץå˰ۤʤΤᡤ
 *  ץåե
 */
const IPR_INFO ipr_info_tbl[TNUM_INH] = {
    IPR_INFO_TBL_DATA 
};

/*
 *  ƳֹMSKCLRξơ֥
 *  Ƥϡץå˰ۤʤΤᡤ
 *  ץåե
 */
const MSK_INFO mskclr_info_tbl[TNUM_INH] = {
    MSKCLR_INFO_TBL_DATA
};

/*
 *  ͥΥ٥١
 */
extern void base_vec(void);

/*
 *  start.S ǤƱ
 */
volatile uint_t   start_sync;

/*
 *  sta_ker ǤΥХꥢƱѿ
 */
static volatile bool_t   prc_init[TNUM_PRCID];
static volatile uint_t   sys_start;

/*
 *  ƱΤΥޥ
 */
#define MAGIC_START 0x87654321U

/*
 *  sta_ker ǤΥХꥢƱ
 */
void
sta_ker_barrier_sync(void){
	volatile uint_t i, j;
	volatile uint_t flag;

	prc_init[x_prc_index()] = true;

	if (x_sense_mprc()) {
		do{
			flag = 0;
			for(i = 0; i < TNUM_PRCID; i++){
				if(prc_init[i] == true){
					flag++;
				}
			}
			for(j = 0; j < 100; j++);
		}while (flag < TNUM_PRCID);
		sys_start = MAGIC_START;
		start_sync = 0;

      
	}
	else {
		while(sys_start != MAGIC_START){
			for(j = 0; j < 100; j++);
		}
	}
}

/*
 *  str_ker()ǥޥץåǹԤ
 */
void
prc_mprc_initialize(void)
{
	/*
	 *  SILΥԥåѿν
	 */
	TOPPERS_spn_var = 0U;

	/*
	 * ͥ٥쥸ν
	 */
	init_int2pri();

	/*
	 *  ߥȥν
	 */
	init_irc();
}


/*
 *  ץå¸ν
 */
void
prc_initialize(void)
{
	TPCB *p_tpcb = get_my_p_tpcb();

	/*
	 *  CPUåե饰¸Τѿν
	 */
	p_tpcb->lock_flag = true;
	p_tpcb->saved_iipm = IIPM_ENAALL;

	set_vbr(base_vec);
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{

}

/*
 *  ׵饤°
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask)
{
	assert(VALID_INTNO_CFGINT(intno));
	assert(-15 <= intpri && intpri <= TMAX_INTPRI);

	/* 
	 *  öߤػߤ
	 */    
	(void)x_disable_int(intno) ;

	/*
	 *  ٥ȥꥬ/åȥꥬ
	 *  IRQΤߥݡȤ
	 */
	if(INTNO_IRQ(INTNO_MASK(intno)) != 0U){
		uint16_t icr1_val = sil_rew_mem((void*)ICR1);
		uint16_t offset   = INTNO_IRQ_OFFSET(INTNO_MASK(intno)) * 2U;

		icr1_val &=  ~(0x03U << offset);
        
		if((intatr & TA_POSEDGE) != 0U) {
		/*
		 *  ݥƥ֥å
		 */
			icr1_val |= IRQ_POSEDGE << offset;            
        }else if((intatr & TA_NEGEDGE) != 0U) {
		 /*
		  *  ͥƥ֥å
		 */
			icr1_val |= IRQ_NEGEDGE << offset;                        
        }else {
		/*
		 *  ٥ȥꥬ
		 */
			icr1_val |= IRQ_LOWLEVEL << offset;
		}
        
		sil_wrw_mem((void*)ICR1, icr1_val);
	}

	/*
	 *  ׵ޥ(ɬפʾ)
	 *  Ʊ˳ͥ٤⥻åȤ
	 */

	if ((intatr & TA_ENAINT) != 0U) {
		(void) x_enable_int(intno);
	}

	/*
	 *ߥޥꥢ쥸å
	 */
	set_target_irc(intno,x_prc_index());

}


#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 *  Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
void
default_exc_handler(void *p_excinf)
{
	uint32_t expevt = *(((uint32_t*)p_excinf) + P_EXCINF_OFFSET_EXPEVT);
	uint32_t spc    = *(((uint32_t*)p_excinf) + P_EXCINF_OFFSET_SPC);
	uint32_t ssr    = *(((uint32_t*)p_excinf) + P_EXCINF_OFFSET_SSR);
	uint32_t pr     = *(((uint32_t*)p_excinf) + P_EXCINF_OFFSET_PR);
    
	syslog(LOG_EMERG, "Unregistered Expevt error occurs.");
	syslog(LOG_EMERG, "Expevt = %08x SPC = %08x SR = %08x PR=%08X",
           expevt, spc, ssr, pr);
	target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *  ̤Ͽγߤȯ˸ƤӽФ
 */
void
default_int_handler(void *p_excinf)
{
	uint32_t spc     = *(((uint32_t*)p_excinf) + 13U);
	uint32_t ssr     = *(((uint32_t*)p_excinf) + 11U);
	uint32_t pr      = *(((uint32_t*)p_excinf) + 12U);
	uint32_t intevt  = sil_rew_mem((void*)INTEVT);
#ifdef USE_INTEVT2    
	uint32_t intevt2 = sil_rew_mem((void*)INTEVT2);
#endif /* USE_INTEVT2 */      
	syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
#ifdef USE_INTEVT2    
	syslog(LOG_EMERG, "INTEVT = %08x INTEVT2 = %08x SPC = %08x SR = %08x PR = %08x ",
           intevt, intevt2, spc, ssr, pr);
#else
	syslog(LOG_EMERG, "INTEVT = %08x SPC = %08x SR = %08x PR = %08x ",
           intevt, spc, ssr, pr);    
#endif /* USE_INTEVT2 */      
	target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
