/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.h 540 2010-02-17 10:48:07Z ertl-honda $
 */


/*
 *		ץå¸⥸塼SH4Aѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

/*
 * ץåμ
 */
#define SH4A

#ifdef FPU_ENABLE

/*
 *  FPSCRPRӥåȤν
 */
#ifdef FPU_DOUBLE
#define FPSCR_PR_INIT 0x00080000  /*  */
#else  /* FPU_SINGLE FPU_SINGLE_ONLY */
#define FPSCR_PR_INIT 0x0000000   /* ñ */
#endif /* FPU_DOUBLE */

/*
 *  FPSCRPRӥåȰʳ
 */
#ifndef FPSCR_INIT
#define FPSCR_INIT 0x00040000
#endif  /* FPSCR_INIT */

#endif /* FPU_ENABLE */

/*
 * ߥϥɥֹɽѴ
 */
#define EXT_INHNO(iintno) (CAST(uint16_t, (iinhno) << 5)) /* ɽɽ */
#define INT_INHNO(intno)  (CAST(uint16_t, (inhno) >> 5))  /* ɽɽ */

/*
 * ֹɽѴ
 */
#define EXT_INTNO(iintno)   (CAST(uint16_t, (iintno) << 5)) /* ɽɽ */
#define INT_INTNO(intno)    (CAST(uint16_t, (intno) >> 5))  /* ɽɽ */

/*
 * ֥ǳֹ椫 inh_tbl Υޥ
 * regˤϡֹݻƤ
 * 쥸ꤹ 
 */
#ifdef TOPPERS_ASM_MACRO
.macro index_intno reg
    shlr2 \reg
    shlr  \reg
.endm
#endif /* TOPPERS_ASM_MACRO */
     
/*
 * CPU㳰ϥɥֹ˴ؤ
 */ 
#define TMIN_EXCNO 0x040U
#define TMAX_EXCNO 0x820U
#define TNUM_EXC   0x42U
     
/*
 * CPU㳰ϥɥֹɽѴ
 */
#define EXT_EXCNO(iexcno)  (CAST(uint16_t, (iexcno) << 5)) /* ɽɽ */
#define INT_EXCNO(excno)   (CAST(uint16_t, (excno)  >> 5)) /* ɽɽ */

/*
 * ֥CPU㳰ֹ椫 exch_tbl Υޥ
 * regˤϡEXPEVT쥸ͤݻƤ
 * 쥸ꤹ 
 */
#ifdef TOPPERS_ASM_MACRO
.macro index_excno reg
    shlr2 \reg
    shlr  \reg
.endm
#endif /* TOPPERS_ASM_MACRO */

#ifndef TOPPERS_MACRO_ONLY
  
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ݡȤ뵡ǽ
 */
#define SUPPORT_DIS_INT            /* dis_int򥵥ݡȤ */
#define SUPPORT_ENA_INT            /* ena_int򥵥ݡȤ */


/*
 *  å⡼ɤ
 *    P1(0x8..)              : 饤ȥ롼
 *    P0(0x0..),U0,P3(0x3..) : ԡХå
 */
#ifdef ENABLE_CACHE_WRITE_BACK

#ifdef ENABLE_CACHE_COHERENCE
#define CCR_MODE  UINT_C(0x00000101) /* ҡͭ饤ȥХå */
#else  /* ENABLE_CACHE_COHERENCE */
#define CCR_MODE  UINT_C(0x00010101) /* ҡ̵饤ȥХå */
#endif /* ENABLE_CACHE_COHERENCE */

#else /* ENABLE_CACHE_WRITE_BACK */

#ifdef ENABLE_CACHE_COHERENCE
#define CCR_MODE  UINT_C(0x00000103) /* ҡͭ饤ȥ롼 */
#else  /* ENABLE_CACHE_COHERENCE */
#define CCR_MODE  UINT_C(0x00010103) /* ҡ̵饤ȥ롼 */
#endif /* ENABLE_CACHE_COHERENCE */

#endif /* ENABLE_CACHE_WRITE_BACK */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *  ޥץå֤
 */
Inline bool_t
x_sense_mprc(void)
{
	if (x_prc_index() == (TOPPERS_MASTER_PRCID - 1)) {
		return true;
	}
	else {
		return false;
	}
}

/* CPUֳѥ쥸  */
static const uint_t int_ici_tbl[TNUM_PRCID] = {
	C0INTICI,
#if TNUM_PRCID >= 2 
	C1INTICI,
#endif /* TNUM_PRCID >= 2 */
#if TNUM_PRCID >= 3
	C2INTICI,
#endif /* TNUM_PRCID >= 3 */
#if TNUM_PRCID >= 4
	C3INTICI,
#endif /* TNUM_PRCID >= 4 */
};

static const uint_t int_ici_clr_tbl[TNUM_PRCID] = {
	C0INTICICLR,
#if TNUM_PRCID >= 2
	C1INTICICLR,
#endif /* TNUM_PRCID >= 2 */
#if TNUM_PRCID >= 3
	C2INTICICLR,
#endif /* TNUM_PRCID >= 3 */
#if TNUM_PRCID >= 4
	C3INTICICLR,
#endif /* TNUM_PRCID >= 4 */
};

Inline void
ici_int(uint_t prcindex)
{
	sil_wrw_mem((void *)int_ici_tbl[prcindex], (1 << (prcindex<<2)));
}

Inline void
ici_int_clr(void)
{
	uint_t prcindex = x_prc_index();

	sil_wrw_mem((void *)int_ici_clr_tbl[prcindex],
				sil_rew_mem((void *)int_ici_tbl[prcindex]));
}

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  ֹΥޥʲ16bitΤߤͭ
 */
#define INTNO_MASK(intno) (intno & 0xffffU)

/*
 *  ߥϥɥֹΥޥʲ16bitΤߤͭ
 */
#define INHNO_MASK(intno) (intno & 0xffffU)

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} CTXB;

/*
 *  sta_ker ǤΥХꥢƱ
 */
extern void sta_ker_barrier_sync(void);

extern void x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask);
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ͥ٥ޥ饤֥
 *  
 *  SH34Ǥϡơ쥸SRˤ47ӥåȤ4ӥåȤ˳ͥ
 *  ޥʥϡɥγͥ٥ޥIPMˤ֤Ƥ롥IPM
 *  ¸Ƥˡͥ٤γɽ-1Ϣ³͡ˤȤ
 *  ȤǽǤ뤬;פʺӥåȥեȤȿžɬפˤʤ롥
 *  򤱤뤿ˡIPM¸ˤϡSR47ӥåȤФ
 *  ȤȤˤ롥ͤͥ٥ޥɽȸƤӡIIPMȽ
 *  Ȥˤ롥
 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡCAST
 */
#define EXT_IPM(iipm)    (-CAST(PRI,(iipm) >> 4))       /* ɽɽ */
#define INT_IPM(ipm)     (CAST(uint16_t, -(ipm)) << 4)  /* ɽɽ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint8_t
current_iipm(void)
{
	return((uint8_t)(current_sr() & 0xF0U));
}

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint8_t iipm)
{
	set_sr((current_sr() & ~0xF0U) | iipm);
}

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  SH34ϥơ쥸(SR)˳ͥ٥ޥ(IPM)äƤ롥
 *  CPUåե饰ǽʤΤᡤŪCPUå
 *  饰¸롥
 *
 *  ޤCPUå֤ѿ(lock_flag)Ѱդ롥
 *
 *  CPUåե饰ꥢƤ֤ϡIPMǥγͥ
 *  ޥͤꤹ롥δ֤ϡǥγͥ٥ޥϡ
 *  IPMѤ롥
 * 
 *  ФCPUåե饰åȤ줤֤ϡIPM򡤥ͥ
 *  ΤΤ٤Ƥγ׵ޥ(TIPM_LOCK)ȡ
 *  γͥ٥ޥȤι⤤ꤹ롥δ֤Υǥγ
 *  ͥ٥ޥϡΤѿ(saved_iipm, ɽݻ)
 *  դݻ롥
 */

/*
 *  ƥȤλ
 *
 *  SH34ǤϡƥȤȽˡߤΥͥȲ
 *  R7_BANK1Ѥ롥
 * 
 */
Inline bool_t
sense_context(void)
{
	uint32_t nest;

	Asm("stc r7_bank,%0" : "=r"(nest));
	return(nest > 0U);
}

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
    return(get_my_p_tpcb()->lock_flag);
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUå֤Ǥγͥ٥ޥ
 *
 *  TIPM_LOCKϡCPUå֤Ǥγͥ٥ޥʤ
 *  ΤΤ٤Ƥγߤޥͤ롥
 */
#define TIPM_LOCK    TMIN_INTPRI

/*
 *  CPUå֤Ǥγͥ٥ޥɽ
 */
#define IIPM_LOCK    INT_IPM(TIPM_LOCK)

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL  INT_IPM(TIPM_ENAALL)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUåե饰¸Τѿ
 * 
 *  ѿϡCPUå֤λΤ߽񤭴Ƥ褤Ȥ롥
 *  饤ؿǡνѲʤ褦volatile ꡥ 
 */

/*
 *  CPUå֤ؤΰܹ
 *
 *  IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *  ͥΤΤ٤Ƥγߤޥ͡TIPM_LOCKˤ
 *  ꤹ롥ޤlock_flagtrueˤ롥
 *
 *  IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *  saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϥǥ
 *  γͥ٥ޥTIPM_LOCKƱ⤤٥
 *  Ƥ֤ˤ롥
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *  ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
	uint8_t iipm;

	/*
	*  current_iipm()֤ͤľsaved_iipm¸ѿiipm
	*  ѤƤΤϡcurrent_iipm()Ƥľ˳ߤȯ
	*  ư줿߽saved_iipmѹǽ뤿
	*  롥
	*/
	iipm = current_iipm();
	if (IIPM_LOCK > iipm) {
		set_iipm(IIPM_LOCK);
	}
	get_my_p_tpcb()->saved_iipm = iipm;
	get_my_p_tpcb()->lock_flag = true;
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β
 *
 *  lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *  saved_iipm¸᤹ͤ
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *  ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
	get_my_p_tpcb()->lock_flag = false;
	set_iipm(get_my_p_tpcb()->saved_iipm);
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  chg_ipmͭʳͥ٤ϰϤȽ
 *
 *  TMIN_INTPRIͤˤ餺chg_ipmǤϡ-15TIPM_ENAALLʡ0ˤϰ
 *  Ǥ뤳ȤȤʥåγĥˡ
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-15 <= (intpri) && (intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *  CPUåե饰ꥢƤϡϡɥγͥ٥
 *  ꤹ롥CPUåե饰åȤƤϡsaved_iipm
 *  ꤷˡϡɥγͥ٥ޥꤷ褦
 *  ʥǥΡ˳ͥ٥ޥTIPM_LOCKι⤤ꤹ롥
 */
Inline void
x_set_ipm(PRI intpri)
{
	uint8_t   iipm = INT_IPM(intpri);

	if (!get_my_p_tpcb()->lock_flag) {
	set_iipm(iipm);
	}
	else {
		get_my_p_tpcb()->saved_iipm = iipm;
#if TIPM_LOCK == -15
		/*
		*  TIPM_LOCK-15ξˤϡλǥϡɥγͥ
		*  ٥ޥɬ15ꤵƤ뤿ᡤꤹɬפϤʤ
		*/
      
#else /* TIPM_LOCK == -15 */
		set_iipm(iipm > IIPM_LOCK ? iipm : IIPM_LOCK);
#endif /* TIPM_LOCK == -15 */
	}
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *  CPUåե饰ꥢƤϥϡɥγͥ٥
 *  򡤥åȤƤsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
	uint8_t iipm;

	if (!get_my_p_tpcb()->lock_flag) {
		iipm = current_iipm();
	}
	else {
		iipm = get_my_p_tpcb()->saved_iipm;
	}
	return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 * ͥ٥쥸
 */
Inline void
set_irc_ipr(uint32_t address, uint32_t offset, uint8_t val)
{
	uint32_t ipr_val;
	SIL_PRE_LOC;
	SIL_LOC_INT();

	ipr_val = sil_rew_mem((void *) address);
	ipr_val &= ~(0x0FU << offset);
	ipr_val |= (uint32_t)val << offset;    
	sil_wrw_mem((void *) address, ipr_val);

	SIL_UNL_INT();
}

/*
 *  ƥ  CPUå֤ʤ true
 *  t_sense_lock()PCB򥢥뤿ᡤߤػߤƼ¹Ԥ롥   
 */
Inline bool_t
sense_tskctx_unl(void)
{
	bool_t result;
	uint8_t iipm;

	/* CPUå */
	iipm = current_iipm();
	if (IIPM_LOCK > iipm) {
		set_iipm(IIPM_LOCK);
	}

	result = (!sense_context() && !t_sense_lock());

	/* CPUå */
	if (IIPM_LOCK > iipm) {
		set_iipm(iipm);
	}

	return(result);
}



/*
 *  󥿥ƥ  CPUå֤ʤ true
 *  t_sense_lock()PCB򥢥뤿ᡤߤػߤƼ¹Ԥ롥 
 */
Inline bool_t
sense_intctx_unl(void)
{
	bool_t result;

	uint8_t iipm;

	/* CPUå */
	iipm = current_iipm();
	if (IIPM_LOCK > iipm) {
		set_iipm(IIPM_LOCK);
	}

	result = (sense_context() && !t_sense_lock());

	/* CPUå */
	set_iipm(iipm);

	return(result);
}

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void dispatch(void);

/*
 *  Υޥ졼core_support.S
 */
extern void dispatch_and_migrate(ID prcid);

/*
 *  ߤΥƥȤΤƥޥ졼core_support.S
 */
extern void exit_and_migrate(ID prcid);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФprc_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void    start_r(void);

#define activate_context(p_tcb)                                         \
{                                                                       \
	(p_tcb)->tskctxb.sp = (void *)((char *)((p_tcb)->p_tinib->stk)      \
                                        + (p_tcb)->p_tinib->stksz);     \
	(p_tcb)->tskctxb.pc = (void *) start_r;                             \
}

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 */
Inline void
initialize_exception(void)
{
}
     
/*
 *  SH34γߥƥȳ߽ǥμ¸
 * 
 *  SH34γߤϡե⥸塼ߡIRQ, PINTߤʬ
 *  Ǥ줾찷ۤʤ롥Τᡤߥϥɥֹ椫顤
 *  γߤʬह뤿ΥޥѰդ롥
 * 
 *  PINTߤ15bitΥץåؤγ׵饤Ǽ¸Ƥ뤬
 *  IRCؤγ׵饤PINT0PINT7PINT0PINT7Ȥä2ܤˤʤ
 *  Ƥ롥ΤᡤͥǤ̤ˤϰ鷺2ܤγߤȤư
 *  PINTϡ̤PINTER쥸ˤĶػ߲ǽǤ뤬ͥ
 *  ϡPINTER쥸ϼ갷ʤΤᡤPINTER쥸
 *  ϡ桼ץǹԤɬפ롥ƱͤPINT׵٥
 *  ꤹICR2桼ץǹԤɬפ롥ʤ
 *  ߤꤷݤγߥϥɥǤIRR0Υꥢ
 *  i_begin_int()ǹԤPINTߤɤȽꤹޥѰդ롥
 *
 *  ƱͤIRQߤȽꤹޥѰդ롥
 */

/*
 *  PINTߤɤȽꤹ뤿Υޥ
 */
#define INTNO_PINT(intno) ((0x700 == (intno)) || (0x720 == (intno)))
#define INTNO_PINT_OFFSET(intno) (((INTNO_MASK(intno)) - 0x700) >> 5)

/*
 *  IRQߤɤȽꤹ뤿Υޥ
 */
#define INTNO_IRQ(intno) ((0x600 <= (intno)) && ((intno) <= 0x6A0))
#define INTNO_IRQ_OFFSET(intno) (((INTNO_MASK(intno)) - 0x600) >> 5)
     
/*
 *  ͥ
 *
 *  Ƴߤγͥ٤ϳͥ쥸(IPRXX)ˤä
 *  ꤹ롥ե⥸塼ξ硤ե⥸塼ǽǤ롥
 *  㤨SCIFϡERI2, RXI2, BRI2, TXI2Ȥ4Ĥγ׵饤
 *  ݡȤ뤬Ƥγ׵饤ФƱͥ٤
 *  ʤΤᡤƳ׵饤ˤɤγͥ쥸
 *  ꤹ뤫ơ֥Ѱդ롥ޤֹϢ³
 *  ƤᡤݡȤƤʤֹˤϡnumber-1ꤹ롥ơ
 *  ֥
 */

/*
 *  ƳֹꤹIPRξΤι¤  
 */
typedef struct {
	/* IPRA:0, IPRB:1, IPRC:2, IPRD:3, IPRE:4, IPRF:5, IPRG:6 */
	uint32_t address; 
	/* bit512:3, bit118:2, bit74:1, bit30:0 */
	uint8_t  offset;
} IPR_INFO;
/*
 *  ƳֹIPRξơ֥
 */
extern const IPR_INFO ipr_info_tbl[TNUM_INH];

/*
 *  ƳֹꤹMSKCLRξΤι¤  
 */
typedef struct {
	uint32_t address; 
	uint32_t  mask;
} MSK_INFO;
/*
 *  ƳֹMSKCLRξơ֥
 */
extern const MSK_INFO mskclr_info_tbl[TNUM_INH];

/*
 *  ߥȥν
 *  ToDo öѿ˥ȥΥɥ쥹롥
 */
Inline void
init_irc(void)
{
	/* ߥȥ쥸 */
	sil_wrw_mem((void*)ICR0, 0x00800000U);
	/* ߥȥ쥸 */
	sil_wrh_mem((void*)ICR1, 0x00000000U);

	/*
	 *  ߥޥ쥸ν
	 */
	init_int2msk();
}

/*
 *  ֹ桦ߥϥɥֹ
 *
 *  ߥϥɥֹ(inhno)ȳֹ(intno)ϡȯ˳
 *  ߻ݥ쥸ꤵͤѤ롥߻ݥ쥸ϡINTEVT
 *  INTEVT22बꡤ줾ꤵͤۤʤ롥SH34
 *  INTEVTѤƤߤINTEVT2Ѥ롥Τᡤץ
 *  åηեѰդơɤΥ쥸Ѥ뤬
 *  ꤹ뤳ȤȤ롥ޤݡȤߤκۤʤ뤿ᡤ
 *  ͤץåηե롥
 *
 *  INTENTꤵͤϥѡͤǤ뤿ᡤΤޤޤͤͥ
 *  Υơ֥ΥǥåѤȡ̵̤ΰ褬ȯ롥
 *  ΤᡤͥǤϡINTENTꤵͤ򥷥եȤͤѤ
 *  롥եȤͤץå˰ۤʤ뤿ץåη
 *  ե롥
 *
 *  ɽ̾ϡiintno,iinhnoȤ롥
 */

/*
 *  ֹϰϤȽ
 * 
 *  TMIN_INTNOTMAX_INTNOϰϤǤäƤֹͭǤʤ礬뤿
 *  ᡤipr_info_tbl[]ֹͭ椫å
 */
#define VALID_INTNO(intno) \
        ((TMIN_INTNO <= (INTNO_MASK(intno))) && ((INTNO_MASK(intno)) <= TMAX_INTNO) && (ipr_info_tbl[INT_INTNO(INTNO_MASK(intno))].address != 0U))
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)

/*
 *  CPU㳰ϥɥֹ
 *
 *  CPU㳰ϥɥֹȤƤϡ㳰ݥ쥸ꤹ㳰ɤ
 *  Ѥ롥ݡȤCPU㳰ϥɥϥץåο˰ۤʤ뤎
 *  ǡץåηե롥
 *
 *  ߥϥɥֹƱCPU㳰ϥɥֹ⥹ѡǤ뤿ᡤ
 *  ͥǤͤ򥷥եȤɽѤ롥 
 */
#define VALID_EXCNO_DEFEXC(excno) \
        (TMIN_EXCNO <= (excno) && (excno) <= TMAX_EXCNO)

/*
 *  ߥϥɥ
 *
 *  ߥϥɥϿ롥ߥϥɥơ֥Τϥե
 *  졼Ū
 */ 
extern const FP inh_tbl[TNUM_INH];

/*
 *  ߥϥɥ
 *
 *  ٥ȥֹinhnoγߥϥɥεưinthdrꤹ롥
 *  ϥɥơ֥
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry, uint_t affinity_mask)
{
  	assert(((TMIN_INHNO <= INHNO_MASK(inhno)) && (INHNO_MASK(inhno) <= TMAX_INHNO)));
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);



/*
 *  ׵ػߥե饰
 *
 *  SH34IRCϳ׵ػߥե饰ʤߤػߤϡ
 *  ͥ쥸(IPRXX)0ꤹɬפ롥ͥ
 *  쥸0ˤ뤳Ȥǳ׵ػߥե饰¸Ȥ
 *  ֡ͥ٤򵭲Ƥΰ褬ɬפȤʤ롥ե졼
 *  ǤΥơ֥Ѱդ롥ʤΥơ֥ϳߤǳ
 *  װ˱SRꤹɬפ뤿ᡤɽȤ롥ޤ
 *  ߥϥɥǤΤᡤIPMǤϤʤߥϥ
 *  ¹ԻSRƱ˻ġΤᡤIPMͤΤߤ
 *  ϡ8bitΤߤ򻲾Ȥɬפ롥Ƥϥե졼
 *  Ū롥
 */
extern const uint32_t int_iipm_tbl[TNUM_INT];

/*
 *  ׵ػߥե饰Υå
 *
 *  ͥ쥸(IPRAG)0ꤹ롥
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	uint16_t iintno  = INT_INTNO(INTNO_MASK(intno));
	uint32_t address = ipr_info_tbl[iintno].address;
	uint32_t offset  = ipr_info_tbl[iintno].offset;
	uint32_t iipm    = int_iipm_tbl[iintno];

	/*
	 *  °ꤵƤʤ
	 */
	if ((iipm & 0x01U) != 0) {
		return(false);
	}
    
	/* 
	*  ֹбIPRͤ0ˤ롥
	*/
	set_irc_ipr(address, offset, 0x00);

	return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ׵ػߥե饰β
 *
 *  ͥ쥸(IPRAG)򸵤᤹ͤ
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	uint16_t iintno  = INT_INTNO(INTNO_MASK(intno));
	uint32_t address = ipr_info_tbl[iintno].address;
	uint32_t offset  = ipr_info_tbl[iintno].offset;
	uint32_t iipm    = int_iipm_tbl[iintno];

	/*
	 *  °ꤵƤʤ
	 */
	if ((iipm & 0x01U) != 0) {
		return(false);
	}

	/* 
	*  ֹбIPRͤ򥻥åȤ
	*/
	set_irc_ipr(address, offset, (-EXT_IPM(iipm & 0xF0U)));
    
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)
/*
 * ߥޥ쥸
 */
Inline void
set_target_irc(INTNO intno, uint_t cpuindex)
{
	uint16_t iintno  = INT_INTNO(INTNO_MASK(intno));
	uint32_t address = mskclr_info_tbl[iintno].address;
	uint32_t mask  = mskclr_info_tbl[iintno].mask;

	address = address + CALC_CPU_MSKCLR_OFFSET(cpuindex);
	sil_wrw_mem((void *) address, mask);
}


/*
 *  ߥϥɥɬפIRC
 *
 *  PINTIRQߤǤġåȥꥬξϳ׵򥯥ꥢ롥
 *  åȥꥬȽǤΤݤʤΤǡ˥ꥢ롥
 */
Inline void
i_begin_int(INTNO intno)
{
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  CPU㳰ϥɥط
 */ 

/*
 *  㳰ϥɥ p_excinf ƼФΥޥ
 */
#ifdef FPU_ENABLE

#ifdef FPU_SAVE_BANKED_REG

#define P_EXCINF_OFFSET_SSR     (12U + 14U + 16U)
#define P_EXCINF_OFFSET_SPC     (14U + 14U + 16U)
#define P_EXCINF_OFFSET_PR      (13U + 14U + 16U)
#define P_EXCINF_OFFSET_EXPEVT    0U 

#else

#define P_EXCINF_OFFSET_SSR     (12U + 14U)
#define P_EXCINF_OFFSET_SPC     (14U + 14U)
#define P_EXCINF_OFFSET_PR      (13U + 14U)
#define P_EXCINF_OFFSET_EXPEVT    0U

#endif /* FPU_SAVE_BANKED_REG */

#else

#define P_EXCINF_OFFSET_SSR     12U
#define P_EXCINF_OFFSET_SPC     14U
#define P_EXCINF_OFFSET_PR      13U
#define P_EXCINF_OFFSET_EXPEVT   0U

#endif /* FPU_ENABLE */

/*
 *  CPU㳰ϥɥϿѥơ֥
 */
extern const FP exch_tbl[TNUM_EXC];

/*
 *  CPU㳰ϥɥ
 */
Inline void
x_define_exc(EXCNO excno, FP exchdr)
{       
}

/*
 *  CPU㳰ϥɥޥ
 */
#define EXC_ENTRY(excno, exchdr)    exchdr
#define EXCHDR_ENTRY(excno, exchdr) extern void exchdr(void *p_excinf);

/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤλfalse
 *  Ǥʤtrue֤
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
	uint32_t nest;

	Asm("stc r7_bank,%0" : "=r"(nest));
	return(nest > 1U);
}

/*
 *  CPU㳰ȯIPMʥϡɥγͥ٥ޥɽ
 *  ˤλ
 */
Inline uint16_t
exc_get_iipm(void *p_excinf)
{
	return(*(((uint32_t *) p_excinf) + P_EXCINF_OFFSET_SSR) & 0x00F0U);
}

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥ֤Ǥtrue
Ǥʤ
 *  false֤CPU㳰ͥγ߽ȯ
 *  ˤfalse֤ˡ
 *
 *  SHǤϡCPU㳰ȯIPMʥϡɥγͥ٥ޥ
 *  ٤ƤγߤĤ֤Ǥ뤳Ȥå뤳Ȥǡ
 *  ͥ¹Ǥʤȡߥå֤ǤʤȡCPUå֤Ǥ
 *  ȡʥǥΡ˳ͥ٥ޥ֤Ǥ뤳Ȥ4Ĥ
 *  å뤳ȤǤCPU㳰ȯlock_flag
 *  ȤɬפϤʤˡ
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
	return(!exc_sense_context(p_excinf)
                    && exc_get_iipm(p_excinf) == IIPM_ENAALL);
}

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  trueǤʤfalse֤CPU㳰ͥγ߽
 *  ȯˤfalse֤ˡ
 *
 *  SH34ǤϡCPU㳰ȯIPMʥϡɥγͥ٥
 *  ˤTIPM_LOCK㤤Ȥå뤳Ȥǡͥ¹
 *  ʤȡߥå֤ǤʤȡCPUå֤ǤʤȤ3
 *  ξåƤCPU㳰ȯlock_flagϻȤ
 *  ʤˡˤꡤʥǥΡ˳ͥ٥ޥTIPM_LOCK
 *  ꤷƥ¹ԤƤˤfalse֤äƤޤȽǤ
 *  Τˤ뤿ΥХإåɤ礭Ȥ顤Ƥ뤳Ȥˤ롥
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)
{
	return(!exc_sense_context(p_excinf)
                    && exc_get_iipm(p_excinf) < IIPM_LOCK);
}

/*
 * Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 * ̤Ͽγߤȯ˸ƤӽФ
 */
extern void default_int_handler(void *p_excinf);

/*
 *  str_ker()ǥޥץåǹԤ
 */
extern void prc_mprc_initialize(void);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

/*
 *  å˻Ѥߡѿ
 */
extern  uint32_t dangling_dummy;

/*
 *  1ܤΥåʥ󥿥ƥȶѡˡ̾ǡ
 */
Inline void
x_acquire_lock(LOCK *p_lock)
{
	bool_t    result;

	while(true){
		Asm("     movli.l	@%2,r0             \n"
		"\t   mov		#0,r3              \n"
		"\t   cmp/eq	r3,r0              \n"
		"\t   bf		1f                 \n"
		"\t   mov		#1,r0              \n"
		"\t   movco.l	r0,@%2             \n"
		"\t   bf		2f                 \n"  //
		"\t   mov		#0,%1              \n"
		"\t   bra		3f                 \n"
		"\t    nop                         \n"
		"1:\t                              \n"  //󥰥󥰡
		"\t   movco.l	r0,%0              \n"
		"2:\t                              \n"  //ԤΥѥ
		"\t   mov		#1,%1              \n"
		"3:\t                              \n"  //λ
		:"=m"(dangling_dummy),"=r"(result)
		:"r"(p_lock):"r0","r3", "cc");

		if(!result){
			return;
		}
		/* ߤε */
		x_unlock_cpu();
		x_lock_cpu();
	}
}

#define t_acquire_lock(p_lock) x_acquire_lock(p_lock)
#define i_acquire_lock(p_lock) x_acquire_lock(p_lock)

#if TTYPE_KLOCK != G_KLOCK

/*
 *  2ܰʾΥåʥ󥿥ƥȶѡ
 */
Inline bool_t
x_acquire_nested_lock(LOCK *p_lock)
{
	bool_t    result;
	PCB		*p_pcb;

	while(true){
		Asm("     movli.l	@%2,r0             \n"
		"\t   mov		#0,r3              \n"
		"\t   cmp/eq	r3,r0              \n"
		"\t   bf		1f                 \n"
		"\t   mov		#1,r0              \n"
		"\t   movco.l	r0,@%2             \n"
		"\t   bf		2f                 \n"  //
		"\t   mov		#0,%1              \n"
		"\t   bra		3f                 \n"
		"\t    nop                         \n"
		"1:\t                              \n"  //󥰥󥰡
		"\t   movco.l	r0,%0              \n"
		"2:\t                              \n"  //ԤΥѥ
		"\t   mov		#1,%1              \n"
		"3:\t                              \n"  //λ
		:"=m"(dangling_dummy),"=r"(result)
		:"r"(p_lock):"r0","r3", "cc");

		if(!result){
			return(false);
		}
		/* ߤε */
		x_unlock_cpu();
		x_lock_cpu();

		/*
		 *  ޥ졼󤹤ǽΤǤ  
		 *  󥿥ƥȤξ硤ޥ졼󤷤ʤᡤ
		 *  while˼¹ԤƤ褤1ǥåȤ줿硤
		 *  ΨΤǡǼ롥
		 */
		p_pcb = get_my_p_pcb(); 
		if (p_pcb->p_firstlock == NULL) {
			return(true);
		}
	}
}

#define t_acquire_nested_lock(p_lock) x_acquire_nested_lock(p_lock)
#define i_acquire_nested_lock(p_lock) x_acquire_nested_lock(p_lock)

#endif /* TTYPE_KLOCK != G_KLOCK */

/*
 *  Ĥʤåؿ
 */
Inline void 
x_acquire_lock_without_preemption(LOCK *p_lock)
{
	bool_t    result;

	while(true){
		Asm("     movli.l	@%2,r0             \n"
		"\t   mov		#0,r3              \n"
		"\t   cmp/eq	r3,r0              \n"
		"\t   bf		1f                 \n"
		"\t   mov		#1,r0              \n"
		"\t   movco.l	r0,@%2             \n"
		"\t   bf		2f                 \n"  //
		"\t   mov		#0,%1              \n"
		"\t   bra		3f                 \n"
		"\t    nop                         \n"
		"1:\t                              \n"  //󥰥󥰡
		"\t   movco.l	r0,%0              \n"
		"2:\t                              \n"  //ԤΥѥ
		"\t   mov		#1,%1              \n"
		"3:\t                              \n"  //λ
		:"=m"(dangling_dummy),"=r"(result)
		:"r"(p_lock):"r0","r3", "cc");

		if(!result){
			return;
		}
	}
}

/*
 *  åβ̾ǡ
 */
Inline void
x_release_lock(LOCK *p_lock)
{
	*p_lock = 0;
}

/*
 *  ԥåǽΥͥƥ֥åǻѤؿ
 */

/*
 *  ԥåηʥͥƥ֥åξ
 */
typedef uint32_t SPNLOCK;

/*
 *  ԥåIDºݤΥåIDؤѴ
 */
#define TO_NATIVE_ID(spnid)		(spnid * 10)

/*
 *  ԥåν
 */
Inline void
x_initialize_spin(ID spnid, SPNLOCK *p_spn_lock)
{
	*p_spn_lock = 0;
}

/*
 *  ԥåμ
 */
Inline void
x_lock_spin(SPNLOCK *p_spn_lock)
{
	x_acquire_lock(p_spn_lock);
}

#define t_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)
#define i_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)

/*
 *  ԥåμλԡ̾åǡ
 */
Inline bool_t
x_try_lock_spin(SPNLOCK *p_spn_lock)
{
	bool_t    result;

	Asm("     movli.l	@%2,r0             \n"
		"\t   mov		#0,r3              \n"
		"\t   cmp/eq	r3,r0              \n"
		"\t   bf		1f                 \n"
		"\t   mov		#1,r0              \n"
		"\t   movco.l	r0,@%2             \n"
		"\t   bf		2f                 \n"  //
		"\t   mov		#0,%1              \n"
		"\t   bra		3f                 \n"
		"\t    nop                         \n"
		"1:\t                              \n"  //󥰥󥰡
		"\t   movco.l	r0,%0              \n"
		"2:\t                              \n"  //ԤΥѥ
		"\t   mov		#1,%1              \n"
		"3:\t                              \n"  //λ
		:"=m"(dangling_dummy),"=r"(result)
		:"r"(p_spn_lock):"r0","r3", "cc");

	return result;
}

#define t_try_lock_spin(p_spn_lock) x_try_lock_spin(p_spn_lock)
#define i_try_lock_spin(p_spn_lock) x_try_lock_spin(p_spn_lock)

/*
 *  ԥåβ
 */
Inline void
x_unlock_spin(SPNLOCK *p_spn_lock)
{
  x_release_lock(p_spn_lock);
}

#define t_unlock_spin(p_spn_lock) x_unlock_spin(p_spn_lock)
#define i_unlock_spin(p_spn_lock) x_unlock_spin(p_spn_lock)

/*
 *  㥤ȥåνG_LOCKξ
 */
Inline void
x_initialize_giant_lock(LOCK *p_giant_lock)
{
	*p_giant_lock = 0;
}



/*
 *  åν
 */
Inline void
x_initialize_tsk_lock(LOCK *p_tsk_lock)
{
	*p_tsk_lock = 0;
}


/*
 *  ֥ȥåν
 */
Inline void
x_initialize_obj_lock(LOCK *p_obj_lock)
{
	*p_obj_lock = 0;
}


#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
