/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_sil.h 512 2010-02-01 05:33:27Z ertl-honda $
 */

/*
 *  sil.hΥץå¸SH4Aѡ
 */
#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  NMI٤Ƥγߤζػ
 */
Inline uint8_t
TOPPERS_disint(void)
{
	uint32_t  TOPPERS_sr;

	Asm("stc  sr,%0" : "=r"(TOPPERS_sr));
	Asm("ldc %0, sr" : : "r"(TOPPERS_sr | 0x000000f0U) : "memory");
	return((uint8_t)(TOPPERS_sr & 0x000000f0U));
}

/*
 *  ͥ٥ޥɽˤθͤ
 */
Inline void
TOPPERS_set_iipm(uint8_t TOPPERS_iipm)
{
	uint32_t  TOPPERS_sr;

	Asm("stc  sr,%0" : "=r"(TOPPERS_sr));
	Asm("ldc %0, sr" : : "r"((TOPPERS_sr & ~0x000000f0U) | TOPPERS_iipm) : "memory");
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC      uint8_t TOPPERS_iipm
#define SIL_LOC_INT()    ((void)(TOPPERS_iipm = TOPPERS_disint()))
#define SIL_UNL_INT()    (TOPPERS_set_iipm(TOPPERS_iipm))

/*
 *  ץåIDμ
 */
Inline void
sil_get_pid(ID *p_prcid)
{
	*p_prcid = *((volatile uint_t *) 0xFF000048) + 1;
}

/*
 *  ԥåѿprc_config.c
 */
extern uint32_t TOPPERS_spn_var;

/*
 *  å˻Ѥߡѿ
 */
extern  uint32_t dangling_dummy;

/*
 *  ԥåμ̾ǡ
 */
Inline uint32_t
TOPPERS_sil_loc_spn(void)
{
	uint8_t   iipm;
	uint32_t  result;

retry:
	/* ߥå֤*/
	iipm = TOPPERS_disint();

	Asm("     movli.l	@%2,r0             \n"
		"\t   mov       #0,r3              \n"
		"\t   cmp/eq	r3,r0              \n"
		"\t   bf		1f                 \n"
		"\t   mov		#1,r0              \n"
		"\t   movco.l	r0,@%2             \n"
		"\t   bf		2f           	   \n"  //
		"\t   mov		#0,%1          	   \n"
		"\t   bra       3f                 \n"
		"\t    nop                         \n"
		"1:\t                              \n"  //󥰥󥰡
		"\t   movco.l	r0,%0              \n"
		"2:\t                              \n"  //ԤΥѥ
		"\t   mov       #1,%1              \n"
		"3:\t                              \n"  //λ
		:"=m"(dangling_dummy),"=r"(result)
		:"r"(&TOPPERS_spn_var):"r0","r3", "cc");

	if (result != 0) {
		/* ԥåǤʤä */
		/* ߥå֤ξ֤ */
		TOPPERS_set_iipm(iipm);
		goto retry;
	}

	return iipm;
}

/*
 *  ԥåβ̾ǡ
 *  Ȥrelease_lockƱ
 */
Inline void
TOPPERS_sil_unl_spn(uint8_t iipm)
{
	TOPPERS_spn_var = 0;
	/* ԥåξ֤ */
	TOPPERS_set_iipm(iipm);
}

/*
 *  ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_iipm = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_iipm))

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_SIL_H */
