/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_support.S 583 2010-05-06 06:59:05Z ertl-honda $
 */


/*
 *  ץå¸⥸塼 ֥SH4Aѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

/*
 *  ֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"

#include "prc_asm.inc"

#define CPIDR  UINT_C(0xFF000048)     

#ifdef FPU_ENABLE

/*
 *  FPUϢ쥸¸
 */        
#ifdef FPU_SAVE_BANKED_REG
.macro save_banked_fpureg
    frchg  /* Х󥯤ڤؤ */
    fmov.s  fr15, @-r15
    fmov.s  fr14, @-r15
    fmov.s  fr13, @-r15
    fmov.s  fr12, @-r15
    fmov.s  fr11, @-r15
    fmov.s  fr10, @-r15
    fmov.s  fr9, @-r15
    fmov.s  fr8, @-r15
    fmov.s  fr7, @-r15
    fmov.s  fr6, @-r15
    fmov.s  fr5, @-r15
    fmov.s  fr4, @-r15
    fmov.s  fr3, @-r15
    fmov.s  fr2, @-r15
    fmov.s  fr1, @-r15
    fmov.s  fr0, @-r15
    frchg  /* Х󥯤᤹ */
.endm

.macro restore_banked_fpureg
#ifdef FPU_SAVE_BANKED_REG
    frchg  /* Х󥯤ڤؤ */
    fmov.s  @r15+, fr0
    fmov.s  @r15+, fr1
    fmov.s  @r15+, fr2
    fmov.s  @r15+, fr3
    fmov.s  @r15+, fr4
    fmov.s  @r15+, fr5
    fmov.s  @r15+, fr6
    fmov.s  @r15+, fr7
    fmov.s  @r15+, fr8
    fmov.s  @r15+, fr9
    fmov.s  @r15+, fr10
    fmov.s  @r15+, fr11
    fmov.s  @r15+, fr12
    fmov.s  @r15+, fr13
    fmov.s  @r15+, fr14
    fmov.s  @r15+, fr15
    frchg  /* Х󥯤᤹ */
#endif /* FPU_SAVE_BANKED_REG */
.endm

#else

.macro save_banked_fpureg
.endm

.macro restore_banked_fpureg
.endm

#endif

.macro save_scratch_fpureg label
    save_banked_fpureg
    sts.l   fpul, @-r15
    fmov.s  fr11, @-r15
    fmov.s  fr10, @-r15
    fmov.s  fr9,  @-r15
    fmov.s  fr8,  @-r15
    fmov.s  fr7,  @-r15
    fmov.s  fr6,  @-r15
    fmov.s  fr5,  @-r15
    fmov.s  fr4,  @-r15
    fmov.s  fr3,  @-r15
    fmov.s  fr2,  @-r15
    fmov.s  fr1,  @-r15
    fmov.s  fr0,  @-r15
    sts.l   fpscr, @-r15
    mov.l   _fpscr_init_\label, r0 /* fpscr νͤ */
    lds     r0,   fpscr
.endm

.macro restore_scratch_fpureg 
    lds.l   @r15+, fpscr
    fmov.s  @r15+, fr0
    fmov.s  @r15+, fr1
    fmov.s  @r15+, fr2
    fmov.s  @r15+, fr3
    fmov.s  @r15+, fr4
    fmov.s  @r15+, fr5
    fmov.s  @r15+, fr6
    fmov.s  @r15+, fr7
    fmov.s  @r15+, fr8
    fmov.s  @r15+, fr9
    fmov.s  @r15+, fr10
    fmov.s  @r15+, fr11
    lds.l   @r15+, fpul
    restore_banked_fpureg
.endm

.macro save_fpureg_data label
_fpscr_init_\label:    
    .long     (FPSCR_PR_INIT|FPSCR_INIT)
.endm

.macro save_callsaved_fpureg_dis
    save_banked_fpureg
    fmov.s  fr15, @-r15
    fmov.s  fr14, @-r15
    fmov.s  fr13, @-r15
    fmov.s  fr12, @-r15
    sts.l   fpscr, @-r15
.endm

.macro restore_callsaved_fpureg_dis
    lds.l   @r15+, fpscr
    fmov.s  @r15+, fr12
    fmov.s  @r15+, fr13
    fmov.s  @r15+, fr14
    fmov.s  @r15+, fr15
    save_banked_fpureg
.endm

.macro save_callsaved_fpureg_int
    lds.l   @r15+, fpscr   /* åfpscr */
    sts.l   fpscr, @-r15   /* åѤ¸    */
    fmov.s  fr15, @-r15
    fmov.s  fr14, @-r15
    fmov.s  fr13, @-r15
    fmov.s  fr12, @-r15
    sts.l   fpscr, @-r15
.endm

.macro restore_callsaved_fpureg_int
    lds.l   @r15+, fpscr
    fmov.s  @r15+, fr12
    fmov.s  @r15+, fr13
    fmov.s  @r15+, fr14
    fmov.s  @r15+, fr15
.endm

.macro set_fpscr label
    mov.l   _fpscr_init_\label, r2
    lds     r2, fpscr
.endm

#else

.macro save_scratch_fpureg label
.endm

.macro restore_scratch_fpureg
.endm

.macro save_fpureg_data label
.endm

.macro save_callsaved_fpureg_dis
.endm

.macro restore_callsaved_fpureg_dis
.endm

.macro save_callsaved_fpureg_int
.endm

.macro restore_callsaved_fpureg_int
.endm

.macro set_fpscr label
.endm

#endif /* FPU_ENABLE */



/*
 *  ȥ졼Ϣεǽ
 */
#ifdef TOPPERS_ENABLE_TRACE

/*
 *  ǥѥåǤΥν
 *  r0˥ǥѥåΥTCBͤäƤ
 */
.macro log_dsp_enter
    mov		r0, r1
    my_pcb r0, r2, dis
    mov.l  r1,@(PCB_p_runtsk, r0) 
    mov    r1, r0 
    cmp/eq #0,r0                
    bt     1f
    mov.l log_dsp_enter_dis, r1 /* ϴؿ */
    mov.l log_dsp_enter_arg1, r4    /* 1      */
    mov   r0, r5                    /* 2      */
    jsr   @r1
     nop
1:
.endm
/*
.macro log_dsp_enter_data
log_dsp_enter_arg1:
    .long (LOG_TYPE_DSP|LOG_ENTER)
log_dsp_enter_dis:
    .long _log_dsp_enter
_cpidr_addr_log_dsp_enter:
    .long CPIDR
_kernel_p_pcb_table_log_dsp_enter:
    .long __kernel_p_pcb_table
.endm
*/

/*
 *  ǥѥåνиǤΥν
 *  r0˥ǥѥåΥTCBͤäƤ
 */
.macro log_dsp_leave	
    mov   r0, r8                    /* r0ϥå쥸ʤΤ r8˥ԡ */
    mov.l log_dsp_leave_trace_1, r1 /* ϴؿ */
    mov.l log_dsp_leave_dis1, r4    /* 1      */
    mov   r0, r5                    /* 2      */
    jsr   @r1
     nop
    mov  r8, r0                     /* r0TCBؤΥݥ󥿤᤹ */
.endm

.macro log_dsp_leave_data
log_dsp_leave_arg1:
    .long (LOG_TYPE_DSP|LOG_LEAVE)
log_dsp_leave_dis_1:
    .long  _log_dsp_leave_dis
.endm

/*
 *  ߥϥɥν
 */
.macro log_inh_enter
    mov.l _intevt_int,r0              /* װ쥸 */
    mov.l @r0,r5                      /* 2 */
    mov.l r5, @-r15                   /* װ򥹥å¸ */
    mov.l r2, @-r15
    mov.l log_inh_enter1, r1    /* ϴؿ */
    mov.l log_inh_enter_data_arg1, r4 /* 1 */
    jsr   @r1
     nop
    mov.l @r15+,r2                    /* r2 */
.endm

.macro log_inh_leave
    mov.l @r15+,r5                    /* 2 */
    mov.l log_inh_data_trace_1, r1    /* ϴؿ */
    mov.l log_inh_leave_data_arg1, r4 /* 1 */
    jsr   @r1
     nop
.endm

.macro log_inh_data
log_inh_enter_data_arg1:
    .long (LOG_TYPE_INH|LOG_ENTER)
log_inh_leave_data_arg1:
    .long (LOG_TYPE_INH|LOG_LEAVE)
log_inh_enter1:
    .long _log_inh_enter
.endm

#else

.macro log_dsp_enter
.endm

.macro log_dsp_enter_data
.endm

.macro log_dsp_leave
.endm

.macro log_dsp_leave_data
.endm

.macro log_inh_enter
.endm

.macro log_inh_leave
.endm

.macro log_inh_data
.endm

#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  㳰/߽롼
 *  SH34ϥ٥ơ֥㳰,TRAPAȯVBR+0x100Ϥ
 *  //NMIߤȯȡVBR+0x600Ϥ¹Ԥ롣
 */

/*
 *  VBR ꤹ
 */
    .section .text
    .align 2
    .global _base_vec
_base_vec:
     nop 
     nop
     nop

/*
 *  Exception 100 vector
 *  ɥ쥹顼,å̿㳰Trapa㳰ȯȼ¹Ԥ롣
 *
 *  CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롢ΤᡢCPU㳰ϥ
 *  ɥƤӽФ㳰/ߤ򼨤쥸Х1 r7 쥸򥤥
 *  Ȥ꥿󤷤Ƥ˥ǥȤ롣CPU㳰ƥ
 *  Ȥȯϡret_exc ʬ롣
 *  regflg å˳ߤػߤʤȡreqflg å˵
 *  ư줿ߥϥɥǥǥѥå׵ᤵ줿ˡǥѥå
 *  ʤ
 *
 *
 *  㳰ȯȡ㳰ȯΥƥȤǤspc,pr,ssr,r0r7
 *  롣㳰ȯǤΥƥȤĴ󥿥ƥȤʤ
 *  _exception_from_int¹Ԥ򳫻Ϥ롣㳰װEXPEVT쥸ɤߡ
 *  exc_tableCPU㳰ϥɥγϤɤ߹ࡣCPU㳰ϥɥ餫
 *  ꥿󤷤Ƥ顢reqflgĴ0ʳʤrec_exc()ӡ0ʤ鸵
 *  ˥꥿󤹤롣
 *
 *
 *  BLӥåȤΰˤĤ
 *  ssr,spc ΥƥȤᤷ rte ȯԤݤˤϡߡNMI 
 *  ޤˤդʤ褦 BL ӥåȤ1ˤɬפ롥㳰/ߥ
 *  ɥ齪λˤ BL ӥåȤ1ˤ öIPM  MAX_IPM ꤹ롥
 *  ϡBL ӥåȤ1ξ㳰ȯ CPU ꥻåȤ뤳Ȥ
 *  θơΤᡤssr,spcľBL1ꤷƤ롥
 *       
 *          ----------------------
 *  0      |       EXPEVT         |  <-- p_excinf
 *          ----------------------
 *  1      |         R7           |
 *          ----------------------
 *  2      |         R6           |
 *          ----------------------
 *  3      |         R5           |
 *          ----------------------
 *  4      |         R4           |
 *          ----------------------
 *  5      |         R3           |
 *          ----------------------
 *  6      |         R2           |
 *         ----------------------
 *  7      |         R1           |
 *          ----------------------
 *  8      |         R0           |
 *          ----------------------
 *  9      |        MACH          |
 *          ----------------------
 * 10      |        MACL          |
 *          ----------------------
 * 11      |        GBR           |
 *          ----------------------
 * 12      |         SR           |
 *          ----------------------
 * 13      |         PR           |
 *          ----------------------
 * 14      |         PC           |
 *          ----------------------
 */


    .org   0x0100              /*  _BASE_VBR + 0x0100Ϥ   */
    .align 2
    .global _general_exc_vec
_general_exc_vec:
    stc.l  spc,@-r15           /* spc,pr,ssr 򥹥å¸ */
    sts.l  pr,@-r15
    stc.l  ssr,@-r15
    stc.l  gbr,@-r15
    sts.l  macl,@-r15
    sts.l  mach,@-r15                                            
    stc.l  r0_bank,@-r15       /* 㳰ȯr0r7¸        */
    stc.l  r1_bank,@-r15
    stc.l  r2_bank,@-r15
    stc.l  r3_bank,@-r15
    stc.l  r4_bank,@-r15
    stc.l  r5_bank,@-r15
    stc.l  r6_bank,@-r15
    stc.l  r7_bank,@-r15
    save_scratch_fpureg exc
    mov.l  _expevt_exc,r0      /* 㳰ĤȾä쥸¸      */
    mov.l  @r0,r5              /* EXPEVT쥸                      */
    mov.l  r5,@-r15            /* å¸(̤Ͽ㳰ȯ)    */
    ldc    r15,r4_bank         /* CPU㳰ϥɥؤΰ                   */
    ldc    r5, r5_bank         /* EXPEVT쥸                        */
    tst    r7,r7               /* 㳰ȯΥƥȤȽ            */
    bf/s   _general_exc_vec_1  /* ȯ㳰/ߥϥɥʤ饸 */
     add    #0x01,r7           /* 㳰ߥͥȲ򥤥󥯥    */
    my_istkpt  r0, r2, exc
    mov    r15,r4
    mov    r0,r15
    mov.l  r4,@-r15            /* åؤΥåݥ󥿤¸ */
_general_exc_vec_1:
    my_pcb  r0, r3, exc
    mov     r0,r3
    mov.l @(PCB_lock_flag, r0),r2
    mov.l  r2,@-r15
    mov    #PCB_saved_iipm, r0
    mov.b  @(r0, r3),r2
    mov.l  r2,@-r15
    mov.l  _unmak_rb_bl_exc,r2 /* BLӥåȤ0ˡ쥸Х󥯤ڤؤ   */
    stc    sr,r3               
    and    r3,r2            
    ldc    r2,sr
    index_excno r5             /* EXPEVTexc_tableΥǥå */
    my_exch_table r0, r2, exc  /* ʥexch_tblΥɥ쥹r0        */
    mov.l  @(r0,r5),r2         /* ϥɥΥɥ쥹                  */
    jsr    @r2                 /* CPU㳰ϥɥ                         */
     nop

    /*
     * CPU㳰ϥɥи
     */
_ret_exc:
    mov.l  _mask_md_ipm_exc,r0 /* ߶ػ                              */
    ldc    r0,sr               
    mov.l  @r15+,r2            /* saved_iipm 򸵤᤹                     */
    my_pcb r0, r3, exc
    mov    #PCB_saved_iipm, r1
    mov.b  r2, @(r0,r1) 
    mov.l  @r15+,r2            /* lock_flag 򸵤᤹                      */
    mov.l  r2, @(PCB_lock_flag, r0)

    /*
     * ߤΥͥʿ r7_bank1 ȥåݥ(r15)
     * ƤԲʬ˹Ԥɬפ롥
     * ñ˳ߤػߤǤϡͥγߤػߤǤʤ
     * ᡤBLӥåȤ1˥åȤơͥγߤػߤ롥
     */
    mov.l  _mask_md_bl_exc,r1  /* BLӥå  1                           */
    ldc    r1,sr               /* ߶ػ                              */
    stc    r7_bank,r7          /* 㳰/ߤΥͥȲǥ   */
    dt     r7
    ldc    r7,r7_bank
    tst    r7,r7
    bf     _ret_exc_1          /* ȯʳʤ餹˥꥿      */
    mov.l  @r15,r15            /* 褬ʤΤǥå᤹        */
    mov.l  @(PCB_reqflg, r0),r2
    xor    r1,r1
    tst    r2,r2               /* reqflgFALSEʤ_ret_exc_1             */
    bt/s   _ret_exc_1 
     mov.l  r1,@(PCB_reqflg, r0)  /* reqflg򥯥ꥢ                         */
    /*
     *  CPUå֤CPU㳰ȯ硤reqflgtrueˤʤ뤳Ȥ
     *  ʤΤǡCPUå֤ξret_int_2ؤʬʤ
     */
    mov.l  _mask_md_ipm_exc,r1 /* BLӥå  0                        */
    ldc    r1, sr              /* ͥγߵ             */
    mov.l  _ret_int_2_exc, r1  /* ret_int_2                               */
    jmp    @r1                 
     mov.l  @r15+,r2           /* EXPEVT򥹥åФ              */

_ret_exc_1:
    mov.l  @r15+,r2            /* EXPEVT򥹥åФ              */
    restore_scratch_fpureg
    mov.l  @r15+,r7            /* r0r1,ssr,pr,spc     */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    mov.l  @r15+,r0
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,spc
    rte
     nop

    .align  4
_cpidr_addr_exc:
    .long CPIDR
_kernel_istkpt_table_exc:
    .long __kernel_istkpt_table
_kernel_p_pcb_table_exc:
    .long __kernel_p_pcb_table
_expevt_exc:
    .long  EXPEVT
_unmak_rb_bl_exc:
    .long  0x4fffffff
_kernel_p_exch_table_exc:
    .long  __kernel_p_exch_table
_mask_md_ipm_exc:
    .long  (0x40000000 + INT_IPM(TMIN_INTPRI))
_mask_md_bl_exc:
    .long  (0x50000000 + INT_IPM(TMIN_INTPRI))
_ret_int_2_exc:
    .long _ret_int_2
save_fpureg_data exc

    
/*
 *  ǥѥå
 *
 *  Υ롼ϡƥ(r7_bank1 = 0)CPUå֡
 *  ǥѥåľ֡ʥǥΡ˳ͥ٥ޥ֤
 *  ƤӽФ롥
 */

    .text
    .align 2
    .global _dispatch
_dispatch:
    save_callsaved_fpureg_dis
    sts.l  pr,@-r15          /* pr,r8r14 򥹥å¸           */
    mov.l  r14,@-r15         /* r0r7ϸƤӽФ¸Ƥ뤿  */
    mov.l  r13,@-r15         /* ¸ɬפ̵                    */
    mov.l  r12,@-r15
    mov.l  r11,@-r15
    mov.l  r10,@-r15
    mov.l  r9, @-r15
    mov.l  r8, @-r15
    my_pcb r0, r2, dis
    mov.l  @(PCB_p_runtsk,r0),r2
    mov.l  r15,@(TCB_sp,r2)  /* åTCB¸ 60ʲʤOK*/
    mov.l  _dispatch_r_dis,r1/* ¹ԺƳϤ¸                    */
    mov.l  r1,@(TCB_pc,r2)   /* ¹ԺƳϤTCB¸  60ʲʤOK */
    bra    _dispatcher
     nop

_dispatch_r:
    mov.l  @r15+,r8         /* 쥸                       */
    mov.l  @r15+,r9
    mov.l  @r15+,r10
    mov.l  @r15+,r11
    mov.l  @r15+,r12
    mov.l  @r15+,r13
    mov.l  @r15+,r14
    lds.l  @r15+,pr
    set_fpscr dis           /* fpscr ν r2˲ */
    /*
     *  㳰롼εư
     *  dispatch_rdispatcherƤӽФ뤿ᡤ
     *  tcbΥɥ쥹r0äƤ롥
     */
    mov    r0,r1
    mov.b  @(TCB_enatex,r1),r0
    mov.l  _enatex_mask_dis,r2
    tst    r0,r2
    bt/s   _dispatch_r_1        /* enatex  FALSE ʤ꥿ */
     mov.l  @(TCB_texptn,r1),r0  /* texptn               */
    tst    r0,r0
    bt     _dispatch_r_1        /* texptn  0̵        */
    mov.l  _dispatch_call_texrtn_dis,r1  /* 㳰롼θƤӽФ */
    jmp    @r1
     nop
_dispatch_r_1:
    restore_callsaved_fpureg_dis
    rts
     nop


    /*
     *  Υޥ졼
     */
    .text
    .align 2
    .globl _dispatch_and_migrate
_dispatch_and_migrate:
    save_callsaved_fpureg_dis
    sts.l  pr,@-r15          /* pr,r8r14 򥹥å¸           */
    mov.l  r14,@-r15         /* r0r7ϸƤӽФ¸Ƥ뤿  */
    mov.l  r13,@-r15         /* ¸ɬפ̵                    */
    mov.l  r12,@-r15
    mov.l  r11,@-r15
    mov.l  r10,@-r15
    mov.l  r9, @-r15
    mov.l  r8, @-r15
    my_pcb r0, r2, dis
    mov.l  @(PCB_p_runtsk,r0),r2
    mov.l  r15,@(TCB_sp,r2)  /* åTCB¸ 60ʲʤOK*/
    mov.l  _dispatch_r_dis,r1/* ¹ԺƳϤ¸                    */
    mov.l  r1,@(TCB_pc,r2)   /* ¹ԺƳϤTCB¸  60ʲʤOK */
    my_istkpt  r0, r2, dis 
    mov    r0,r15
    mov.l  p_migrate_self, r0
    jsr    @r0
     nop


    /*
     *  ߤΥƥȤΤƥޥ졼
     */
    .text
    .align 2
    .globl _exit_and_migrate
_exit_and_migrate:
    my_istkpt  r0, r2, dis 				/* 󥿥ƥѥåڤؤ */
    mov    r0,r15
    mov.l  p_exit_and_migrate_self, r0
    jsr    @r0						    /* exitȥޥ졼롼 */
     nop
/*
 * ǥѥåưϡprc_support.S
 */
    .global _start_dispatch
_start_dispatch:
    /*
     *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
     * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
     *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
     *
     *  prc_initializeǡlock_flagTRUEˡsaved_iipmIIPM_ENAALL
     *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
     *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
     *  ޤtask_initializedisdspFALSE˽Ƥ뤿ᡤǥ
     *  ѥåľ֤ˤʤäƤ롥
     */
    xor    r1,r1                /* r7_bank10ꥢ             */
    ldc    r1,r7_bank
    bt     _dispatcher_0

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    .globl _exit_and_dispatch
_exit_and_dispatch:
    /* ǥѥåΡdispatcherˤ */
/*
 * ǥѥå
 */

_dispatcher:
   /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥
     *
     *  ʤr7_bank10lock_flagTRUEdisdspFALSEdspflg
     *  TRUEsaved_iipmIIPM_ENAALLȤʤäƤ롥¹ԺƳϤؤ⤳
     *  ξ֤Τޤʬ롥
     */

#ifdef LOG_DSP_ENTER
    my_pcb r0, r4, dis			/* r4 <- p_runtskѥ᡼ */
    mov.l  @(PCB_p_runtsk, r0), r4
    log_dsp_enter
#endif /* LOG_DSP_ENTER */

_dispatcher_0:

    my_pcb r0, r12, dis			/* r12 <- p_schedtsk */
    mov.l  @(PCB_p_schedtsk, r0), r12
    mov.l  r12,@(PCB_p_runtsk, r0)	   /* schedtskruntsk               */
    mov    r12,r0
    cmp/eq #0,r0                /* schedtsk 뤫              */
    bt     _dispatcher_1        /* ̵Х                 */
    mov.l  @(TCB_sp,r0),r15     /* TCB饿å      */
#ifdef LOG_DSP_LEAVE
    my_pcb r0, r4, dis			/* r4 <- p_runtskѥ᡼ */
    mov.l  @(PCB_p_runtsk, r0), r4
    log_dsp_leave
#endif /* LOG_DSP_LEAVE */

    mov.l  @(TCB_pc,r0),r1      /* TCB¹ԺƳϤ        */
    jmp    @r1 
     nop

_dispatcher_1:

    /* ߥǥͤɤ߹ΤϸΨΤǻѰդ
     * r8  : ߶ػߤΤSR
     * r9  : ԤSR
     * r10 : reqflg
     * r11 : 0x01
     * r12 : 0x00
     * r13 : sleepSRξ
     * r14 : lock_flag
     */

    mov.l  _mask_md_ipm_dis,r8  /* ߶ػߤSR             */
#ifdef NO_SLEEP
    mov.l  _mask_md_dis,r9      /* ԤSR(BL=0)     */
#else
    mov.l  _mask_md_bl_dis,r9   /* ԤSR(BL=1)     */
#endif /* NO_SLEEP */
    my_istkpt  r0, r2, dis 
    mov    r0,r15
    mov    #0x01,r11
    xor    r12,r12
    ldc    r11,r7_bank         /* r7_bank1 1ˤƳ߾֤ */
    my_pcb  r0, r14, dis
    mov    r0,  r14
    mov.l  r12, @(PCB_lock_flag, r0)   /* CPUå֤ */


_dispatcher_2:
    /*
     *  ǳߥ⡼ɤڤ괹Τϡȯ߽
     *  ˤɤΥåȤȤβȡߥϥɥ
     *  ΥǥѥåɻߤȤĤΰ̣롥
     */
     /*
      *  ߵĸsleep̿¹Ԥȡߵ̿μ¹
      *  ׵᤬äƤ硤ߵ̿μ¹Ԥȶ˳ߤ
      *  դ줽ˡ	reqflgΥåǤϤʤ sleep 
      *  äƤޤ
      *  ϡߤεĤ sleep ֤ؤΰܹԤȥߥå˼
      *  ԤǤʤȤ˵롥
      *  Τᡤsleep ¹ľ SR ѹǤ BL ӥåȤ'1'ꤹ
      *  뤳ȤǡߤεĤ sleep ֤ؤΰʹߤ򥢥ȥߥå˼¹
      *  롥
      *  ldc r9,sr ǤBLӥåȤåȤ뤿ᡤߤϼդ
      *  ꡼ץ⡼ɤ˰ܹԤ롥꡼ץ⡼ϡBLӥåȤ1Ǥ
      *  ߤդ뤿(SH7709ϡɥޥ˥奢 8-10)꡼
      *  ץ⡼ɤؤΰܹľ˳ߤե꡼ץ⡼ɤ롥
      */
               
    ldc    r9,sr               /* ߤε                   */
#ifndef NO_SLEEP
    sleep                      /* Ԥ                       */
#endif /* NO_SLEEP */    
    ldc    r8,sr               /* ߶ػ                     */

    my_pcb r0, r10, dis
    mov.l  @(PCB_reqflg, r0),r10
    mov    r10,r7             /* r7 <- reqflg                     */
    tst    r7,r7               /* reqflg  FALSEʤ              */
    bt     _dispatcher_2       /* dispatcher_2                   */

    ldc    r12,r7_bank         /* r7_bank1 򥯥ꥢ                */
    mov.l  r12,@(PCB_reqflg, r0)            /* reqflg  FALSE   */

    /*
     *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
     *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
     *  פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
     *  ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
     *  Ф褤
     */
    mov.l  r11,@(PCB_lock_flag, r0)            /* CPUå֤ */
    mov    #PCB_saved_iipm, r3
    bra    _dispatcher_0
     mov.b  r12,@(r0,r3)

    .align 4
_cpidr_addr_dis:
    .long CPIDR
_kernel_istkpt_table_dis:
    .long __kernel_istkpt_table
_kernel_p_pcb_table_dis:
    .long __kernel_p_pcb_table

p_migrate_self:
    .long _migrate_self
p_exit_and_migrate_self:
    .long _exit_and_migrate_self
_dispatch_r_dis:
    .long _dispatch_r


_enatex_mask_dis:
    .long TCB_enatex_mask
_dispatch_call_texrtn_dis:
    .long _dispatch_call_texrtn
_mask_md_ipm_dis:
    .long (0x40000000 + INT_IPM(TMIN_INTPRI))
_mask_md_dis:
    .long 0x40000000
_mask_md_bl_dis:
    .long 0x50000000
save_fpureg_data dis

log_dsp_enter_arg1:
    .long (LOG_TYPE_DSP|LOG_ENTER)
log_dsp_leave_data


/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    .globl _call_exit_kernel
_call_exit_kernel:
    mov.l _mask_md_ipm_exit, r0
    ldc   r0,sr    
    my_istkpt  r0, r2, exit 
    mov   r0,r15
    mov.l _exit_kernel_exit,r0
    jmp   @r0
     nop

    .align 4
_mask_md_ipm_exit:
    .long 0x400000f0
_cpidr_addr_exit:
    .long CPIDR
_kernel_istkpt_table_exit:
    .long __kernel_istkpt_table

_exit_kernel_exit:
    .long _exit_kernel


/*
 *  ư
 *
 *  ǥѥå㤫ƤӽФ뤿ᡤTCBΥɥ쥹r0
 *  äƤ
 */ 
    .text
    .align 2
    .globl _start_r
_start_r:
    mov    r0, r3
    my_pcb r0, r1, start
    mov    r0, r1
    xor    r2,r2 
    mov.l  r2, @(PCB_lock_flag, r0)
    set_fpscr start
    mov.l  _mask_md_start,r4     /* ߵ */
    ldc    r4,sr
    mov.l  _ext_tsk_start,r2     /* Ϥ */
    lds    r2,pr 
    mov.l  @(TCB_p_tinib,r3),r2  /* p_runtsk->p_tinibr3  */
    mov.l  @(TINIB_task,r2),r1   /* ưϤr1     */
    mov    r3, r0
    jmp    @r1
     mov.l  @(TINIB_exinf,r2),r4 /* exinf쥸r4  */

    .align 4
_cpidr_addr_start:
    .long CPIDR
_kernel_p_pcb_table_start:
    .long __kernel_p_pcb_table
_mask_md_start:    
    .long 0x40000000
_ext_tsk_start:
    .long _ext_tsk
save_fpureg_data start


/*
 *  Exception 600 vector
 *  ߤȯȼ¹Ԥ롣
 *
 *
 *  SH34ϳߤȯȤ٤VBR+0x600Ϥץ¹Ԥ뤿ᡢ
 *  ֤롼Ǥޤåڤؤ쥸¸,IPM,
 *  װȽԤθBLӥåȤ0ˤƳߥϥɥƤɬ
 *  롣
 *  װбߥϥɥγϤinh_tbl[]Ͽ
 *  ƸƤӽФեåȤη׻ϡװ쥸롥
 *  װ쥸INTEVTINTEVT2ब¸ߤ뤬ɤѤ뤫
 *  ץåη˻ꤹ롥
 *  ͥ٥ޥϡint_iipm_tbl[]SRꤹ롥
 *
 *  reqflg å˳ߤػߤʤȡreqflg å
 *  ˵ư줿ߥϥɥǥǥѥå׵ᤵ줿ˡǥ
 *  ѥåʤ
 *
 */

    .org    0x0600         /* _BASE_VBR + 0x0600Ϥ */
    .align 2
    .global _interrupt_vec
_interrupt_vec:
    stc.l  spc,@-r15       /* ¿ųߤȾäƤޤΤ        */
    sts.l  pr,@-r15        /* spc,pr,ssr,gbr,macl,mach                    */
    stc.l  ssr,@-r15    
    stc.l  gbr,@-r15                    
    sts.l  macl,@-r15                    
    sts.l  mach,@-r15                                                    
    stc.l  r0_bank,@-r15   /* ,r0r7򥹥å¸   */ 
    stc.l  r1_bank,@-r15
    stc.l  r2_bank,@-r15
    stc.l  r3_bank,@-r15
    stc.l  r4_bank,@-r15
    stc.l  r5_bank,@-r15
    stc.l  r6_bank,@-r15
    stc.l  r7_bank,@-r15
    save_scratch_fpureg int
    /*
     *  PCBμ
     */ 
    my_pcb r0, r4, int
#if TTYPE_KLOCK != G_KLOCK
    /*
     *  ץåγ٥åξϥåƤ뤫å
     *  ƤХå롥
     */ 
release_lock:
    mov.l  @(PCB_p_firstlock, r0),r4   /* p_firstlock ->r4 */
    tst    r4,r4
    bt     release_lock_end            /* NULLʤ齪λ       */
    xor    r1,r1                       /* r1 */
    mov.l  @r4,r2                      /* p_firstlockλؤƤ륢ɥ쥹r2 */
    mov.l  r1,@r2                      /* p_firstlock */
    mov.l  r1,@r4                      /* p_firstlock  NULL  */
    mov.l  @(PCB_p_secondlock, r0),r4  /* p_secondlock ->r4 */
    tst    r4,r4
    bt     release_lock_end            /* NULLʤ齪λ       */
    mov.l  @r4,r2                      /* p_secondlockλؤƤ륢ɥ쥹r2 */
    mov.l  r1,@r2                      /* p_secondlock */
    mov.l  r1,@r4                      /* p_secondlock  NULL  */
release_lock_end:
#endif /* TTYPE_KLOCK != G_KLOCK */

    tst    r7,r7                 /* ȯΥƥȤȽ  */
    bf/s   _interrupt_vec_1      /* 㳰/ߥϥɥʤ饸   */
     add    #0x01,r7             /* ߤΥͥȲ򥤥󥯥*/
    mov    r15,r1                /* åؤΥåݥ  */
    my_istkpt  r0, r2, int       /* 󥿤¸                          */
    mov    r0,r15              
    mov.l  r1,@-r15            
_interrupt_vec_1:
    mov.l  _intevt_int,r0        /* 㳰װ쥸              */
    mov.l  @r0,r4             
    index_intno r4               /* եåȤ                  */
    mov.l  _int_iipm_tbl_int,r0  /* ͥ٥ޥͤ      */
    mov.l  @(r0,r4),r5        
    mov.l  _inh_tbl_int,r0       /* ߥϥɥΥɥ쥹    */
    mov.l  @(r0,r4),r2           
    ldc    r2,r2_bank            /* Х0ڤؤ뤿ᥳԡ       */
    ldc    r5,sr                 /* ʹ߳ߤդ롣      */
    log_inh_enter
    jsr    @r2                   /* ߥϥɥ                  */
     nop

    /*
     * ߥϥɥи
     */
_ret_int:
    /*
     * ߤΥͥʿ r7_bank1 ȥåݥ(r15)
     * ƤԲʬ˹Ԥɬפ롥
     * ñ˳ߤػߤǤϡͥγߤػߤǤʤ
     * ᡤBLӥåȤ1åȤơͥγߤػߤ롥
     * 
     */
    mov.l  _mask_md_bl_ret,r0     /* BL  1 (߶ػ)  */
    ldc    r0,sr
    log_inh_leave
    stc    r7_bank,r7            /* 㳰/ߤΥͥȲǥ*/
    dt     r7
    ldc    r7,r7_bank
    tst    r7,r7                 /* 褬󥿥ƥȤʤ餹 */
    bf     _ret_int_1            /* ꥿                               */
    mov.l  @r15, r15             /* 褬ʤΤǥå᤹     */
    my_pcb r0, r4, ret
    mov.l  @(PCB_reqflg, r0),r4
    xor    r1,r1
    tst    r4,r4                 /* reqflgFALSEʤret_int_1           */
    bt     _ret_int_1
    mov.l  _mask_md_ipm_ret,r4   /* BL0 ˥ͥγ߶ػ     */    
    ldc    r4, sr
    bra    _ret_int_2;
     mov.l  r1,@(PCB_reqflg, r0)                /* reqflg򥯥ꥢ                        */

_ret_int_1:
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ褦
     *  롥ͥ٥ޥϡRTE̿ˤ긵ͤ뤿ᡤ
     *  lock_flagFALSEˤƤФ褤lock_flagFALSEˤΤϡ
     *  CPUå֤Τޤ޳ߥϥɥ餫äкˡ
     */
    my_pcb  r0, r1, ret
    mov   r0, r2
    xor   r1,r1
    mov.l  r1, @(PCB_lock_flag, r0)
    restore_scratch_fpureg
    mov.l  @r15+,r7                /* ߸                 */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    mov.l  @r15+,r0
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,spc
    rte
     nop

_ret_int_2:
    /*
     *  ؤϡCPU㳰ϥɥνиʬƤ롥
     *
     *  Ǥϡ褬Ǥꡤåϡå
     *  å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
     *  ͥγߤػߤ֤ȤʤäƤ롥
     *
     *  r0ˤϡPCBؤΥݥ󥿤äƤ롥
     */
    /*
     *  CPUå֤˰ܹԤ롥ͥγߤϤǤ˶ػߤ
     *  Τǡlock_flagsaved_iipm򹹿롥saved_iipmϡ
     *  γͥ٥ޥʤɽˤꤹ롥
     *
     *  λCPUå֤ȤΤϡdispatcherʬȡ
     *  _dispatch_call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
     *  Ǥ롥
     */
    mov   r0, r4
    mov   #0x01,r1
    mov.l r1, @(PCB_lock_flag, r4)
    mov.l @(11*4,r15), r0        /* IPMФ */
    and   #0xf0,r0              /* saved_iipm              */
    mov   r0, r3
    mov   #PCB_saved_iipm, r0
    mov.b r3, @(r0, r4)

    /*
     *  dspflgFALSEǤȡp_runtskp_schedtskƱˤϡ
     *  ǥѥåԤʤΥåɬפʤΤϡ㳰
     *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
     *  reqflgTRUEˤ뤿Ǥ롥
     */
    mov.l  @(PCB_p_runtsk, r4), r0  /* r0 <- p_runtsk               */
    mov.l  @(PCB_dspflg, r4), r2
    tst    r2,r2
    bt     _ret_int_3    
    mov.l  @(PCB_p_schedtsk, r4), r1 /* r1 <- schedtsk                */ 
    cmp/eq r0,r4                /* runtsk  schedtsk      */
    bt     _ret_int_3           /* Ʊʤret_int_3           */
    save_callsaved_fpureg_int
    mov.l  r14,@-r15            /* ĤΥ쥸¸          */
    mov.l  r13,@-r15
    mov.l  r12,@-r15
    mov.l  r11,@-r15
    mov.l  r10,@-r15
    mov.l  r9,@-r15
    mov.l  r8,@-r15
    mov.l  r15,@(TCB_sp,r0)    /* å¸           */
    mov.l  _ret_int_r_ret,r1    /* ¹ԺƳϤ¸             */
    bra    _dispatcher
     mov.l  r1,@(TCB_pc,r0)


_ret_int_r:
    mov.l  @r15+,r8
    mov.l  @r15+,r9
    mov.l  @r15+,r10
    mov.l  @r15+,r11
    mov.l  @r15+,r12
    mov.l  @r15+,r13
    mov.l  @r15+,r14
_ret_int_3:
    /*
     *  㳰롼εư
     *  ret_int_r  dispatcher ƤӽФ뤿ᡤtcbΥɥ쥹r0
     *  äƤ롥
     *  ʤߤνиǥåȯʤϥǥѥå
     *  ̤餺 ret_int ľ ret_int_1 
     */
    mov    r0,r1
    mov.b  @(TCB_enatex,r1),r0
    mov.l  _enatex_mask_ret,r2
    tst    r0,r2
    bt/s   _ret_int_4           /* enatex  FALSE ʤret_int_4  */
     mov.l  @(TCB_texptn,r1),r0 /* texptn                   */
    tst    r0,r0
    bt     _ret_int_4           /* texptn  0ʤret_int_4       */
    mov.l _dispatch_call_texrtn_ret,r1   /* 㳰롼θƤӽФ     */
    jsr   @r1
     nop
_ret_int_4:
    my_pcb  r0, r2, ret
    mov    r0,r2
    xor    r1,r1 
    mov.l  r1, @(PCB_lock_flag, r0)
    restore_callsaved_fpureg_int
    restore_scratch_fpureg
    mov.l  @r15+,r7            /* spc,pr,ssr,å쥸 */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    mov.l  _mask_md_bl_ret,r0
    ldc    r0,sr               /* BL1                             */
    mov.l  @r15+,r0
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,spc
    rte
     nop


    .align  4
_cpidr_addr_int:
    .long CPIDR
_kernel_istkpt_table_int:
    .long __kernel_istkpt_table
_kernel_p_pcb_table_int:
    .long __kernel_p_pcb_table

_intevt_int:
#ifdef USE_INTEVT2
    .long  INTEVT2
#else
    .long  INTEVT
#endif /* USE_INTEVT2 */
_int_iipm_tbl_int:
    .long  _int_iipm_tbl
_inh_tbl_int:
    .long  _inh_tbl

_mask_md_ipm_ret:
    .long  (0x40000000 + INT_IPM(TMIN_INTPRI))
_mask_md_bl_ret:
    .long  0x50000000
_cpidr_addr_ret:
	.long CPIDR
_kernel_istkpt_table_ret:
    .long __kernel_istkpt_table
_kernel_p_pcb_table_ret:
    .long __kernel_p_pcb_table

_ret_int_r_ret:
    .long _ret_int_r
_enatex_mask_ret:
    .long TCB_enatex_mask
_dispatch_call_texrtn_ret:
    .long _dispatch_call_texrtn
save_fpureg_data int
log_inh_data

/*
 *  Ԥ
 */
    .globl _sil_dly_nse
_sil_dly_nse:
    mov.l  _sil_dly_tim1, r1
    add    r1, r4
    cmp/pl r4
    bt     _sil_dly_nse1
    rts
     nop
_sil_dly_nse1:
    mov.l  _sil_dly_tim2, r1
    add    r1, r4
    cmp/pl r4
    bt     _sil_dly_nse1
    rts
     nop   
    .align 4
_sil_dly_tim1:
    .long  -SIL_DLY_TIM1
_sil_dly_tim2:
    .long  -SIL_DLY_TIM2
