/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_timer.c 512 2010-02-01 05:33:27Z ertl-honda $
 */

/*
 *  ޥɥ饤СSH4Aѡ
 */
#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"

#ifdef TOPPERS_TRACE_ENABLE
SYSTIM target_time;
#endif /* TOPPERS_TRACE_ENABLE */

/*
 *  ޥݡȽ֥å
 */
typedef struct tim_initialization_block {
	void  *tcor_w;   /* ޥ󥹥ȥ쥸 */
	void  *tcnt_w;   /* ޥ */
	void  *tcr_h;    /* ޥȥ쥸 */
	void  *tstr_b;
	uint8_t str;
} TIMINIB;

/*
 *  ޽֥å
 */
const TIMINIB timinib_table[6] = {
	{
		(void *)(TIM0_BASE + TIM_TCOR),
		(void *)(TIM0_BASE + TIM_TCNT),
		(void *)(TIM0_BASE + TIM_TCR),
		(void *)(TMU_TSTR0),
		TMU_STR0
	},
	{
		(void *)(TIM1_BASE + TIM_TCOR),
		(void *)(TIM1_BASE + TIM_TCNT),
		(void *)(TIM1_BASE + TIM_TCR),
		(void *)(TMU_TSTR0),
		TMU_STR1
	},
	{
		(void *)(TIM2_BASE + TIM_TCOR),
		(void *)(TIM2_BASE + TIM_TCNT),
		(void *)(TIM2_BASE + TIM_TCR),
		(void *)(TMU_TSTR0),
		TMU_STR2
	},
	{
		(void *)(TIM3_BASE + TIM_TCOR),
		(void *)(TIM3_BASE + TIM_TCNT),
		(void *)(TIM3_BASE + TIM_TCR),
		(void *)(TMU_TSTR1),
		TMU_STR0
	},
	{
		(void *)(TIM4_BASE + TIM_TCOR),
		(void *)(TIM4_BASE + TIM_TCNT),
		(void *)(TIM4_BASE + TIM_TCR),
		(void *)(TMU_TSTR1),
		TMU_STR1
	},
	{
		(void *)(TIM5_BASE + TIM_TCOR),
		(void *)(TIM5_BASE + TIM_TCNT),
		(void *)(TIM5_BASE + TIM_TCR),
		(void *)(TMU_TSTR1),
		TMU_STR2
	}
};

/*
 *  CPUID֥åФΥޥ
 */
#define get_timinib (&(timinib_table[x_prc_index()]))
#define get_timinib_atr(intatr) (&(timinib_table[intatr]))

int_t const tmu_intevt[6] = {
	TMU0_INTEVT,
	TMU1_INTEVT,
	TMU2_INTEVT,
	TMU3_INTEVT,
	TMU4_INTEVT,
	TMU5_INTEVT
};

/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
	CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);
	const TIMINIB *p_timinib;
	p_timinib =   &(timinib_table[(int)exinf - 1]);
	SIL_PRE_LOC;

	/*
	*  ޼ꤷޤư򳫻Ϥ롥
	*/
	sil_wrb_mem(p_timinib->tstr_b,
                (sil_reb_mem(p_timinib->tstr_b) & ~p_timinib->str));  /*  */
	assert(cyc <= MAX_CLOCK);             /* ޾ͤΥå */

    /* ʬꡢߵ */
	sil_wrh_mem(p_timinib->tcr_h,(0x020 | TCR0_TPSC));
	sil_wrw_mem(p_timinib->tcor_w, cyc); /* timer constant쥸򥻥å */
	sil_wrw_mem(p_timinib->tcnt_w, cyc); /* 󥿡򥻥å */    

	/* ޥ */
	/* ޥȥ쥸ʣǶͭƤΤ¾椬ɬ */

	SIL_LOC_SPN();
	sil_wrb_mem(p_timinib->tstr_b,
                (sil_reb_mem(p_timinib->tstr_b) | p_timinib->str));
	SIL_UNL_SPN();

	/*
	*  ޳׵򥯥ꥢ롥
	*/
	
	/* ׵򥯥ꥢ */
	sil_wrh_mem(p_timinib->tcr_h,
                (sil_reh_mem(p_timinib->tcr_h) & ~TCR_UNF));
 
#ifdef TOPPERS_TRACE_ENABLE
	target_time = 0;
#endif /* TOPPERS_TRACE_ENABLE */    
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
	const TIMINIB *p_timinib;
	p_timinib =   &(timinib_table[(int)exinf - 1]);
  
	/* ޤ */
	sil_wrb_mem(p_timinib->tstr_b,
                (sil_reb_mem(p_timinib->tstr_b) & ~p_timinib->str));
	/* ׵򥯥ꥢ */
	sil_wrh_mem(p_timinib->tcr_h,0);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(intptr_t exinf)
{
	const TIMINIB *p_timinib;

	p_timinib =   &(timinib_table[exinf - 1]);
  
	/* ׵򥯥ꥢ */
	sil_wrh_mem(p_timinib->tcr_h,
                (sil_reh_mem(p_timinib->tcr_h) & ~TCR_UNF));

#ifdef TOPPERS_TRACE_ENABLE    
	target_time++;
#endif /* TOPPERS_TRACE_ENABLE */    

	i_begin_int(tmu_intevt[exinf - 1]);
	signal_time();                    /* ƥåζ */
	i_end_int(tmu_intevt[exinf - 1]);
}


/*
 *  ǽɾѥޤεư
 */
void
perf_timer_initialize(intptr_t exinf)
{
	CLOCK    cyc = 0xffffffff;
	const TIMINIB *p_timinib;
	p_timinib =   &(timinib_table[4]);

	/*
	*  ޼ꤷޤư򳫻Ϥ롥
	*/
	sil_wrb_mem(p_timinib->tstr_b,
                (sil_reb_mem(p_timinib->tstr_b) & ~p_timinib->str));  /*  */
	assert(cyc <= MAX_CLOCK);             /* ޾ͤΥå */

	/* ʬꡢߵ */
 
	sil_wrh_mem(p_timinib->tcr_h,(0x020 | TCR0_TPSC)); //1/4ʬ
	sil_wrw_mem(p_timinib->tcor_w, cyc); /* timer constant쥸򥻥å */
	sil_wrw_mem(p_timinib->tcnt_w, cyc); /* 󥿡򥻥å */    

	/* ޥ */
	sil_wrb_mem(p_timinib->tstr_b,
                (sil_reb_mem(p_timinib->tstr_b) | p_timinib->str));

	/*
	*  ޳׵򥯥ꥢ롥
	*/
	/* ׵򥯥ꥢ */
	sil_wrh_mem(p_timinib->tcr_h,
                (sil_reh_mem(p_timinib->tcr_h) & ~TCR_UNF));
}

void
synco_asm(void)
{
	Asm("synco");
}
