/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_timer.h 512 2010-02-01 05:33:27Z ertl-honda $
 */

/*
 *  ޥɥ饤СSH4Aѡ
 */
#ifndef TOPPERS_PRC_TIMER_H
#define TOPPERS_PRC_TIMER_H

#include <sil.h>

/*
 *  ޳ߥϥɥϿΤ
 */
#define INHNO_TIMER0     TMU0_INTEVT   /* ߥϥɥֹ */
#define INTNO_TIMER0     TMU0_INTEVT   /* ֹ */
#define INHNO_TIMER1     TMU1_INTEVT   /* ߥϥɥֹ */
#define INTNO_TIMER1     TMU1_INTEVT   /* ֹ */
#define INHNO_TIMER2     TMU2_INTEVT   /* ߥϥɥֹ */
#define INTNO_TIMER2     TMU2_INTEVT   /* ֹ */
#define INHNO_TIMER3     TMU3_INTEVT   /* ߥϥɥֹ */
#define INTNO_TIMER3     TMU3_INTEVT   /* ֹ */

#define INTPRI_TIMER    (-6)          /* ͥ */
#define INTATR_TIMER    0U            /* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽη
 */
typedef uint32_t    CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *
 */
#define TO_CLOCK(nume, deno)    ((CLOCK)(TIMER_CLOCK * (nume) / (deno)))

/*
 *  ʥñ̤Ѵ10-9
 */
#define TO_USEC(clock)          (((SYSUTM) clock) * 80U) 

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK    ((CLOCK) 0xffffU)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void target_timer_initialize(intptr_t exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void target_timer_terminate(intptr_t exinf);

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
	return(0xffffffff - sil_rew_mem((void*)TMU_TCNT4));
}

/*
 *  ǽɾѥʥûּ
 */
Inline void
get_ntim(SYSUTM *p_sysutm)
{
	uint32_t	clock1;

	clock1 = target_timer_get_current();

	/*
	 *  180n
	 */
	*p_sysutm = clock1 * 80;
}

/*
 *  ޳׵Υå(ǽɾ)
 */
Inline bool_t
target_timer_probe_int(void)
{
	return(sil_reh_mem((void*)TMU_TCR4) & TCR_UNF);
}

/*
 *  ޳ߥϥɥ
 */
extern void target_timer_handler(intptr_t exinf);
extern void perf_timer_initialize(intptr_t exinf);
extern void synco_asm(void);

#ifdef TOPPERS_TRACE_ENABLE
extern SYSTIM target_time;
#endif /* TOPPERS_TRACE_ENABLE */

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_TIMER_H */
