/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: mp.c 470 2009-11-19 06:51:04Z ertl-honda $
 */

/*
 *		ޥץå⥸塼
 */
#include "kernel_impl.h"
#include "mp.h"
#include "target_ipi.h"

#ifdef TOPPERS_mpini

#if TTYPE_KLOCK == G_KLOCK
/*
 *  㥤ȥå
 */
LOCK giant_lock;
#endif /* TTYPE_KLOCK == G_KLOCK */

#ifndef OMIT_KER_REQ_ON_IPI
/*
 *  λ׵ե饰
 */
bool_t ext_ker_reqflg;
#endif /* OMIT_KER_REQ_ON_IPI */

/*
 *  ޥץå⥸塼ν
 */
void
initialize_pcb(void)
{
	uint_t	i;
	PCB *my_p_pcb = get_my_p_pcb();

	/*
	 *  PCB prcid 
	 */
	my_p_pcb->prcid = ID_PRC(x_prc_index());

#if TTYPE_KLOCK == G_KLOCK
	/*
	 *  㥤ȥåν(ޥץåΤ)
	 */
	if (x_sense_mprc()) {
		x_initialize_giant_lock(&giant_lock);
	}
#else /* TTYPE_KLOCK != G_KLOCK */
	/*
	 *  åν
	 */
	x_initialize_tsk_lock(&(my_p_pcb->tsk_lock));

	/*
	 *  1ܤμΥåν
	 */
	my_p_pcb->p_firstlock = NULL;

	/*
	 *  2ܤμΥå
	 */
	my_p_pcb->p_secondlock = NULL;
#endif /* TTYPE_KLOCK != G_KLOCK */

#if TTYPE_KLOCK == P_KLOCK
	/*
	 *  ֥ȥåν
	 */
	x_initialize_obj_lock(&(my_p_pcb->obj_lock));
#endif /* TTYPE_KLOCK == P_KLOCK */

	/*
	 *  طν
	 */
	my_p_pcb->p_runtsk = my_p_pcb->p_schedtsk = NULL;
	my_p_pcb->reqflg = false;
	my_p_pcb->disdsp = false;
	my_p_pcb->dspflg = true;

	for (i = 0; i < TNUM_TPRI; i++) {
		queue_initialize(&(my_p_pcb->ready_queue[i]));
	}

	my_p_pcb->ready_primap = 0U;

	my_p_pcb->locspnid = 0U;

#ifndef OMIT_KER_REQ_ON_IPI
	if (x_sense_mprc()) {
		ext_ker_reqflg = false;
	}
#endif /*  OMIT_KER_REQ_ON_IPI */
}

#endif /* TOPPERS_mpini */

#ifdef TOPPERS_ipi_handler

/*
 *  ץåֳߥϥɥ
 */
void
ipi_handler(void)
{
	PCB *my_p_pcb = get_my_p_pcb();

	target_ipi_clear();

#ifndef OMIT_KER_REQ_ON_IPI
	/*
	 *  λ׵å
	 */
	if (ext_ker_reqflg) {
		ext_ker();
	}
#endif /* OMIT_KER_REQ_ON_IPI */

	my_p_pcb->reqflg = true;
}

#endif /* TOPPERS_ipi_handler */

#ifdef TOPPERS_disp_req

/*
 *  ǥѥå׵
 *  оݤ¾ץåξϥץåֳߤȯԤ
 *  ToDo  : ¾ץåξƤ֤褦ѹǤʤ
 */
bool_t
dispatch_request(PCB* p_pcb)
{
	if (p_pcb == get_my_p_pcb()) {
		return(true);
	}
	else {
		target_ipi_raise(p_pcb->prcid);
		return(false);
	}
}

#endif /* TOPPERS_disp_req */

#ifdef TOPPERS_ext_ker_req

#ifndef OMIT_KER_REQ_ON_IPI

/*
 *  λ׵
 */
void
ext_ker_request(void)
{
	ID prcid;

	/* Ǥ׵᤬ФƤХ꥿ */
	if (ext_ker_reqflg) {
		return;
	}

	ext_ker_reqflg = true;

	for(prcid = 1; prcid <= TNUM_PRCID; prcid++){
		if (prcid != ID_PRC(x_prc_index())) {
			target_ipi_raise(prcid);
		}
	}
}

#endif /* OMIT_KER_REQ_ON_IPI */

#ifndef OMIT_BARRIER_SYNC

/*
 *  ХꥢƱѿ
 */
static volatile uint_t prc_init[TNUM_PRCID];
static volatile uint_t sys_start;

/*
 *  ХꥢƱ
 */
void
barrier_sync(uint_t phase)
{
	volatile uint_t i, j;
	volatile uint_t flag;

	prc_init[x_prc_index()] = phase;

	if (x_sense_mprc()) {
		do{
			flag = 0;
			for(i = 0; i < TNUM_PRCID; i++){
				if(prc_init[i] == phase){
					flag++;
				}
			}
			for(j = 0; j < 100; j++);
		}while (flag < TNUM_PRCID);
		sys_start = phase;
	}
	else {
		while(sys_start != phase) {
			for(j = 0; j < 100; j++);
		}
	}
}

#endif  /* OMIT_BARRIER_SYNC */

#if TTYPE_KLOCK != G_KLOCK

/*
 *  ץååʤγ٥åΥåؿ
 */

/*
 *		ƥѤΥåؿ
 */

/*
 *  ǤեץåΥåμʥƥȡ
 */
PCB*
t_acquire_tsk_lock_prcid(ID prcid)
{
	PCB *p_pcb;

	p_pcb = get_mp_p_pcb(prcid);
 	t_acquire_lock(&(p_pcb->tsk_lock));
	return(p_pcb);
}

/*
 *  ץåΥåμʥƥ/1ܡ
 *
 *  t_acquire_lock()ǳߤĤ뤿ᡤޥ졼åɬ
 *  Ȥʤ롥
 * 
 *  TSTAT_RUNNABLE()falseξ˳ߤĤΤϡߤդ
 *  Ȥˤꡤǥѥåȯ뤿Ǥ롥ߤĤʤȡ
 *  Ƥӥå1Ǽ硤TSTAT_RUNNABLE()falseȤʤꡤ̵
 *  ¤˥롼פ롥
 */
PCB*
t_acquire_tsk_lock_self(void)
{
	TCB *my_p_tcb;
	PCB *my_p_pcb;

	while(true) {
		my_p_pcb = get_my_p_pcb();
		my_p_tcb = my_p_pcb->p_runtsk;
		t_acquire_lock(&(my_p_pcb->tsk_lock));
		if (!TSTAT_RUNNABLE(my_p_tcb->tstat)) { 
			/* RUNNABLEǤʤ */
			x_release_lock(&(my_p_pcb->tsk_lock));
			t_unlock_cpu();
			t_lock_cpu();
		} else if (my_p_pcb != my_p_tcb->p_pcb) {
			/* ޥ졼Ȥ */
			x_release_lock(&(my_p_pcb->tsk_lock));
		} else {
			return(my_p_pcb);
		}
	}
}

/*
 *  ץåΥåμʥƥ/2ܡ
 *  
 *  TSTAT_RUNNABLE()falseξ˳ߤĤΤϡߤդ
 *  뤳Ȥˤꡤǥѥåȯ뤿Ǥ롥ߤĤʤ
 *  ȡƤӥå1Ǽ硤TSTAT_RUNNABLE()falseȤʤꡤ̵
 *  ¤˥롼פ롥
 * 
 *  t_acquire_nested_lock()ǳߤĤ̡ߤꡤޥ
 *  ȯǽ뤬ξϡt_acquire_nested_lock()
 *  true֤롥ΤᡤåΥޥ졼åɬ
 *  Ϥʤʥޥ졼󤷤Ƥretryˡ
 *
 *  t_acquire_nested_lock()false֤äƤϡǼ¹Ԥ
 *  åѤ뤳Ȥʤᡤp_pcbͭǤ롥
 */
PCB*
t_acquire_nested_tsk_lock_self(LOCK *p_objlock)
{
	PCB *my_p_pcb;

	my_p_pcb = get_my_p_pcb();
	my_p_pcb->p_firstlock = p_objlock;
	if (t_acquire_nested_lock(&(my_p_pcb->tsk_lock))) {
		return(NULL);
	}
	my_p_pcb->p_firstlock = NULL;
	if (!TSTAT_RUNNABLE(my_p_pcb->p_runtsk->tstat)){
		x_release_lock(&(my_p_pcb->tsk_lock));
		x_release_lock(p_objlock);
		t_unlock_cpu();
		t_lock_cpu();
		return(NULL);
	}
	return(my_p_pcb);
}

/*
 *  ǤեʼޤˤΥåμʥƥ/1ܡ
 *
 */
PCB*
t_acquire_tsk_lock(TCB *p_tcb)
{
	PCB *p_pcb;

	while(true) {
		p_pcb = p_tcb->p_pcb;
		t_acquire_lock(&(p_pcb->tsk_lock));
		if (p_pcb != p_tcb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}

/*
 *  ǤեʼޤˤΥåμʥƥ/2ܡ
 * 
 *  t_acquire_nested_lock()ǳߤĤ̡ߤꡤ
 *  ޥ졼󤬤ǽ뤬ξϡ
 *  t_acquire_nested_lock()true֤롥
 *
 *  t_acquire_nested_lock()false֤äƤϡǼ
 *  ¹ԤץåѤ뤳Ȥʤᡤmy_p_pcbͭǤ롥
 */
PCB*
t_acquire_nested_tsk_lock(TCB *p_tcb, LOCK *p_objlock)
{
	PCB *my_p_pcb;
	PCB *p_pcb;
 
	while(true) {
		my_p_pcb = get_my_p_pcb();
		my_p_pcb->p_firstlock = p_objlock;
		p_pcb = p_tcb->p_pcb;
		if (t_acquire_nested_lock(&(p_pcb->tsk_lock))) {
			return(NULL);
		}
		my_p_pcb->p_firstlock = NULL;
		if (p_pcb != p_tcb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}

/*
 *  ǤդΥ顼ϥɥΥåμʥƥ/1ܡ
 */
PCB*
t_acquire_tsk_lock_alm(ALMCB *p_almcb)
{
	PCB *p_pcb;

	while(true){
		p_pcb = p_almcb->p_pcb;
		t_acquire_lock(&(p_pcb->tsk_lock));
		if (p_pcb != p_almcb->p_pcb) {
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}

/*
 *  ǤդμϥɥΥåμʥƥ/1ܡ
 */
PCB*
t_acquire_tsk_lock_cyc(CYCCB *p_cyccb)
{
	PCB *p_pcb;

	while(true){
		p_pcb = p_cyccb->p_pcb;
		t_acquire_lock(&(p_pcb->tsk_lock));
		if (p_pcb != p_cyccb->p_pcb) {
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}


/*
 *  2ĤΥåμʥƥ/1ܡ
 * 
 *  t_acquire_nested_lock()ǳߤĤ̡ߤꡤޥ
 *  ȯǽ뤬ξϡt_acquire_nested_lock()
 *  true֤롥
 *
 *  t_acquire_nested_lock()false֤äƤϡǼ¹Ԥ
 *  åѤ뤳Ȥʤᡤmy_p_pcbͭǤ롥
 */
void 
t_acquire_dual_tsk_lock(TCB *p_tcb, ID dstprcid, 
						PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	PCB* my_p_pcb;

	*pp_dstpcb = get_mp_p_pcb(dstprcid);

	while(true) {
		*pp_srcpcb = p_tcb->p_pcb;
		if ((*pp_srcpcb)->prcid > dstprcid) {
			/* 1ܤΥå */
			t_acquire_lock(&((*pp_dstpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_dstpcb)->tsk_lock);
			if (!t_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				/* 2ܤΥåǤ */
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_tcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
				} else {
					return;
				}
			}
		} else if ((*pp_srcpcb)->prcid < dstprcid) {
			/* 1ܤΥå */
			t_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_srcpcb)->tsk_lock);
			if (!t_acquire_nested_lock(&((*pp_dstpcb)->tsk_lock))) {
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_tcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
				} else {
					return;
				}
			}
		}
		else {
			t_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			if (*pp_srcpcb != p_tcb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
			} else {
				return;
			}
		}
	}
}

/*
 *  顼ϥɥ2ĤΥåμʥƥ/1ܡ
 */
void
t_acquire_dual_tsk_lock_alm(ALMCB *p_almcb, ID dstprcid, 
							PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	PCB* my_p_pcb;

	*pp_dstpcb = get_mp_p_pcb(dstprcid);

	while(true) {
		*pp_srcpcb = p_almcb->p_pcb;
		if ((*pp_srcpcb)->prcid > dstprcid) {
			/* 1ܤΥå */
			t_acquire_lock(&((*pp_dstpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_dstpcb)->tsk_lock);
			if (!t_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				/* 2ܤΥåǤ */
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_almcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
				} else {
					return;
				}
			}
		} else if ((*pp_srcpcb)->prcid < dstprcid) {
			/* 1ܤΥå */
			t_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_srcpcb)->tsk_lock);
			if (!t_acquire_nested_lock(&((*pp_dstpcb)->tsk_lock))) {
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_almcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
				} else {
					return;
				}
			}
		}
		else {
			t_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			if (*pp_srcpcb != p_almcb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
			} else {
				return;
			}
		}
	}
}

/*
 *  ϥɥ2ĤΥåμʥƥ/1ܡ
 */
void
t_acquire_dual_tsk_lock_cyc(CYCCB *p_cyccb, ID dstprcid, 
							PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	PCB* my_p_pcb;

	*pp_dstpcb = get_mp_p_pcb(dstprcid);

	while(true) {
		*pp_srcpcb = p_cyccb->p_pcb;
		if ((*pp_srcpcb)->prcid > dstprcid) {
			/* 1ܤΥå */
			t_acquire_lock(&((*pp_dstpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_dstpcb)->tsk_lock);
			if (!t_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				/* 2ܤΥåǤ */
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_cyccb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
				} else {
					return;
				}
			}
		} else if ((*pp_srcpcb)->prcid < dstprcid) {
			/* 1ܤΥå */
			t_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_srcpcb)->tsk_lock);
			if (!t_acquire_nested_lock(&((*pp_dstpcb)->tsk_lock))) {
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_cyccb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
				} else {
					return;
				}
			}
		}
		else {
			t_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			if (*pp_srcpcb != p_cyccb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
			} else {
				return;
			}
		}
	}
}

/*
 *  2ĤΥåμʥƥ/2ܡ
 *
 *  t_acquire_nested_lock()ǳߤĤ̡ߤꡤޥ
 *  ȯǽ뤬ξϡt_acquire_nested_lock()
 *  true֤롥
 *
 *  t_acquire_nested_lock()false֤äƤϡǼ¹Ԥ
 *  åѤ뤳Ȥʤᡤmy_p_pcbͭǤ롥
 */
bool_t 
t_acquire_nested_dual_tsk_lock(TCB *p_tcb, ID dstprcid, LOCK *p_objlock,
							   PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	PCB* my_p_pcb;

	*pp_dstpcb = get_mp_p_pcb(dstprcid);

	while(true) {
		*pp_srcpcb = p_tcb->p_pcb;
		my_p_pcb = get_my_p_pcb();
		my_p_pcb->p_firstlock = p_objlock;
		if ((*pp_srcpcb)->prcid > dstprcid) {
			/* 2ܤΥå */
			if (t_acquire_nested_lock(&((*pp_dstpcb)->tsk_lock))) {
				return(true);
			}
			my_p_pcb->p_secondlock = &((*pp_dstpcb)->tsk_lock);
			/* 3ܤΥå */
			if (t_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				return(true);
			}
			my_p_pcb->p_secondlock = NULL;
			my_p_pcb->p_firstlock = NULL;
			if (*pp_srcpcb != p_tcb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
				x_release_lock(&((*pp_dstpcb)->tsk_lock));
			} else {
				return(false);
			}
		} else if ((*pp_srcpcb)->prcid < dstprcid) {
			/* 2ܤΥå */
			if (t_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				return(true);
			}
			my_p_pcb->p_secondlock = &((*pp_srcpcb)->tsk_lock);
			/* 3ܤΥå */
			if (t_acquire_nested_lock(&((*pp_dstpcb)->tsk_lock))) {
				return(true);
			}
			my_p_pcb->p_secondlock = NULL;
			my_p_pcb->p_firstlock = NULL;
			if (*pp_srcpcb != p_tcb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_dstpcb)->tsk_lock));
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
			}else {
				return(false);
			}
		} else {
			/* 2ܤΥå */
			if (t_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				return(true);
			}
			my_p_pcb->p_firstlock = NULL;
			if (*pp_srcpcb != p_tcb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
			} else {
				return(false);
			}
		}
	}
}

/*
 *		󥿥ƥѤΥåؿ
 */

/*
 *  ǤեץåΥåμ󥿥ƥȡ
 */
PCB*
i_acquire_tsk_lock_prcid(ID prcid)
{
	PCB *p_pcb;

	p_pcb = get_mp_p_pcb(prcid);
	i_acquire_lock(&(p_pcb->tsk_lock));
	return(get_mp_p_pcb(prcid));
}

/*
 *  ץåΥåμ󥿥ƥ/1ܡ
 *
 *  ޥ졼󤹤뤳ȤϤʤᡤƥȤǼ»ܤƤ
 *  ޥ졼åɬפʤ  
 */ 
PCB*
i_acquire_tsk_lock_self(void)
{
	PCB *my_p_pcb;

	my_p_pcb = get_my_p_pcb();
	i_acquire_lock(&(my_p_pcb->tsk_lock));
	return(get_my_p_pcb());
}


/*
 *  ǤեΥåμ󥿥ƥ/1ܡ
 *
 */
PCB*
i_acquire_tsk_lock(TCB *p_tcb) 
{
	PCB *p_pcb;

	while(true) {
		p_pcb = p_tcb->p_pcb;
		i_acquire_lock(&(p_pcb->tsk_lock));
		if (p_pcb != p_tcb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}

/*
 *  ǤեΥåμ󥿥ƥ/2ܡ
 */
PCB*
i_acquire_nested_tsk_lock(TCB *p_tcb, LOCK *p_objlock)
{
	PCB* my_p_pcb;
	PCB* p_pcb;

	while(true) {
		my_p_pcb = get_my_p_pcb();
		my_p_pcb->p_firstlock = p_objlock;
		p_pcb = p_tcb->p_pcb;
		if (i_acquire_nested_lock(&(p_pcb->tsk_lock))) {
			return(NULL);
		}
		my_p_pcb->p_firstlock = NULL;
		if (p_pcb != p_tcb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}

/*
 *  ǤդΥ顼ϥɥΥåμ󥿥ƥȡ
 */
PCB*
i_acquire_tsk_lock_alm(ALMCB *p_almcb)
{
	PCB *p_pcb;

	while(true){
		p_pcb = p_almcb->p_pcb;
		i_acquire_lock(&(p_pcb->tsk_lock));
		if (p_pcb != p_almcb->p_pcb) {
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}

/*
 *  2ĤΥåμ󥿥ƥ/1ܡ
 */
void 
i_acquire_dual_tsk_lock(TCB *p_tcb, ID dstprcid, 
                                    PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	PCB* my_p_pcb;

	*pp_dstpcb = get_mp_p_pcb(dstprcid);

	while(true) {
		*pp_srcpcb = p_tcb->p_pcb;
		if ((*pp_srcpcb)->prcid > dstprcid) {
			/* 1ܤΥå */
			i_acquire_lock(&((*pp_dstpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_dstpcb)->tsk_lock);
			if (!i_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				/* 2ܤΥåǤ */
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_tcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
				} else {
					return;
				}
			}
		} else if ((*pp_srcpcb)->prcid < dstprcid) {
			/* 1ܤΥå */
			i_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_srcpcb)->tsk_lock);
			if (!i_acquire_nested_lock(&((*pp_dstpcb)->tsk_lock))) {
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_tcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
				} else {
					return;
				}
			}
		}
		else {
			i_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			if (*pp_srcpcb != p_tcb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
			} else {
				return;
			}
		}
	}
}

/*
 *  顼ϥɥ2ĤΥåμʥƥ/1ܡ
 */
void
i_acquire_dual_tsk_lock_alm(ALMCB *p_almcb, ID dstprcid, 
							PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	PCB* my_p_pcb;

	*pp_dstpcb = get_mp_p_pcb(dstprcid);

	while(true) {
		*pp_srcpcb = p_almcb->p_pcb;
		if ((*pp_srcpcb)->prcid > dstprcid) {
			/* 1ܤΥå */
			i_acquire_lock(&((*pp_dstpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_dstpcb)->tsk_lock);
			if (!i_acquire_nested_lock(&((*pp_srcpcb)->tsk_lock))) {
				/* 2ܤΥåǤ */
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_almcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
				} else {
					return;
				}
			}
		} else if ((*pp_srcpcb)->prcid < dstprcid) {
			/* 1ܤΥå */
			i_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			my_p_pcb = get_my_p_pcb();
			my_p_pcb->p_firstlock = &((*pp_srcpcb)->tsk_lock);
			if (!i_acquire_nested_lock(&((*pp_dstpcb)->tsk_lock))) {
				my_p_pcb->p_firstlock = NULL;
				if (*pp_srcpcb != p_almcb->p_pcb) {
					/* оݥޥ졼Ȥ */
					x_release_lock(&((*pp_dstpcb)->tsk_lock));
					x_release_lock(&((*pp_srcpcb)->tsk_lock));
				} else {
					return;
				}
			}
		}
		else {
			i_acquire_lock(&((*pp_srcpcb)->tsk_lock));
			if (*pp_srcpcb != p_almcb->p_pcb) {
				/* оݥޥ졼Ȥ */
				x_release_lock(&((*pp_srcpcb)->tsk_lock));
			} else {
				return;
			}
		}
	}
}

/*
 *		ƥѤΥ֥ȥåؿ
 */

/*
 *  ֥ȥåμʥƥȡ
 */
void
t_acquire_obj_lock(LOCK *p_objlock) 
{ 
	t_acquire_lock(p_objlock);
}

/*
 *		󥿥ƥѤΥ֥ȥåؿ
 */

/*
 * ֥ȥåμ󥿥ƥȡ
 */
void 
i_acquire_obj_lock(LOCK *p_objlock) 
{ 
	i_acquire_lock(p_objlock);
}

/*
 *		åؿ
 */

/*
 *  åβʥƥȡ
 */ 
void
release_tsk_lock(PCB *p_pcb)
{
	x_release_lock(&(p_pcb->tsk_lock));
}

/*
 *  åβ2ܡ
 */ 
void
release_nested_tsk_lock(PCB *p_pcb)
{
	x_release_lock(&(p_pcb->tsk_lock));
}

/*
 *  åβȥǥѥå
 */
void
release_tsk_lock_and_dispatch(PCB *p_pcb,  bool_t dspreq)
{
	x_release_lock(&(p_pcb->tsk_lock));
	if (dspreq) {
		dispatch();
	}
}

/*
 *  2ĤΥåβ
 */ 
void
release_dual_tsk_lock(PCB *p_srcpcb,  PCB *p_dstpcb)
{
	x_release_lock(&(p_srcpcb->tsk_lock));
	x_release_lock(&(p_dstpcb->tsk_lock));
}

/*
 *  2ĤΥåβȥǥѥå
 */
void
release_dual_tsk_lock_and_dispatch(PCB *p_srcpcb,  PCB *p_dstpcb, bool_t dspreq)
{
	x_release_lock(&(p_srcpcb->tsk_lock));
	x_release_lock(&(p_dstpcb->tsk_lock));
	if (dspreq) {
		dispatch();
	}
}

/*
 *		֥ȥåؿ
 */

/*
 * ֥ȥåβ󥿥ƥȡ
 */ 
void
release_obj_lock(LOCK *p_objlock)
{
	x_release_lock(p_objlock);
}

/*
 * ֥ȥåβȥǥѥå
 */ 
void
release_obj_lock_and_dispatch(LOCK *p_objlock, bool_t dspreq)
{
	x_release_lock(p_objlock);
	if (dspreq) {
		dispatch();
	}
}

/*
 *		¾Υåؿ
 */

/*
 *  ץꥨץ󤷤ʤΥåμ
 */
PCB* 
acquire_tsk_lock_without_preemption_self(void)
{
	PCB *my_p_pcb;

	my_p_pcb = get_my_p_pcb();
	x_acquire_lock_without_preemption(&(my_p_pcb->tsk_lock));

	return(my_p_pcb);
}

/*
 *  ץꥨץ󤷤ʤåμ2ܡ
 */
PCB*
acquire_nested_tsk_lock_without_preemption(TCB *p_tcb)
{
	PCB *p_pcb;

	while(true) {
		p_pcb = p_tcb->p_pcb;
		x_acquire_lock_without_preemption(&(p_pcb->tsk_lock));
		if (p_pcb != p_tcb->p_pcb) {
			/* оݥޥ졼Ȥ */
			x_release_lock(&(p_pcb->tsk_lock));
		} else {
			return(p_pcb);
		}
	}
}

#endif /* TTYPE_KLOCK != G_KLOCK */




#endif /* TOPPERS_ext_ker_req */
