/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: mp.h 444 2009-10-16 06:45:49Z ertl-honda $
 */

/*
 *		ޥץå⥸塼
 *		깽¤Ѥޥ
 */

#ifndef TOPPERS_MP_H
#define TOPPERS_MP_H

#include <queue.h>
#include "task.h"
#include "alarm.h"
#include "cyclic.h"

/*
 *  ץåIDץåINDEXؤѴ
 */
#define INDEX_PRC(prcid)	((uint_t)((prcid) - TMIN_PRCID))

/*
 *  ץåINDEXץåIDؤѴ
 */
#define ID_PRC(prcindex)	((uint_t)((prcindex) + TMIN_PRCID))

/*
 *  ưν
 */
extern void initialize_pcb(void);

/*
 *  ץåֳߥϥɥ
 */
extern void ipi_handler(void);

#ifndef OMIT_KER_REQ_ON_IPI
/*
 *  λ׵ե饰
 */
extern bool_t ext_ker_reqflg;

/*
 *  λ׵
 */
extern void ext_ker_request(void);
#endif /* OMIT_KER_REQ_ON_IPI */

#ifndef OMIT_BARRIER_SYNC
/*
 *  ХꥢƱ
 */
extern void barrier_sync(uint_t phase);
#endif  /* OMIT_BARRIER_SYNC */

/*
 *		⥸塼Ϣ
 */

/*
 *  ǥѥå׵
 */
extern bool_t dispatch_request(PCB* p_pcb);

/*
 *  󥿥ƥѤΥåϢΥǡkernel_cfg.c
 */
extern const SIZE _kernel_istksz_table[];

extern STK_T *const _kernel_istk_table[];

#ifdef TOPPERS_ISTKPT
extern STK_T *const _kernel_istkpt_table[];
#endif /* TOPPERS_ISTKPT */

/*
 *		åطǽ
 */

#if TTYPE_KLOCK == G_KLOCK

/*
 *  㥤ȥå
 */

/*
 *  㥤ȥåѤΥåѿ
 */
extern LOCK giant_lock;

/*
 *  ֥ȥȥ֥ååѿμФ
 */
#define GET_OBJLOCK(p_wobjcb)   (giant_lock)

/*
 *		ƥѤΥåؿ
 */

/*
 *  ǤեץåΥåμʥƥȡ
 */
Inline PCB*
t_acquire_tsk_lock_prcid(ID prcid)
{
	t_acquire_lock(&giant_lock);
	return(get_mp_p_pcb(prcid));
}

/*
 *  ץåΥåμʥƥ/1ܡ
 *
 *  å塤Υޥ졼åˡ⤢뤬
 *  åΥȤͤȡå˰Χ p_pcb 
 *  Ψ褤ȽǤ 
 */
Inline PCB*
t_acquire_tsk_lock_self(void)
{
	PCB *p_pcb;

	while(true) {
		t_acquire_lock(&giant_lock);
		/* ޥ졼Ȥθp_pcbå˼ */
		p_pcb = get_my_p_pcb();
		if (!TSTAT_RUNNABLE(p_pcb->p_runtsk->tstat)) { 
			/* RUNNABLEǤʤ */
			x_release_lock(&giant_lock);
			t_unlock_cpu();
			t_lock_cpu();
		} else {
			return(p_pcb);
		}
	}
}

/*
 *  ץåΥåμʥƥ/2ܡ
 */ 
Inline PCB*
t_acquire_nested_tsk_lock_self(LOCK *p_objlock)
{
	return(get_my_p_pcb());
}

/*
 *  ǤեʼޤˤΥåμʥƥ/1ܡ
 * 
 *  оݥޥ졼󤹤ǽΤǡåˡp_pcb롥  
 */ 
Inline  PCB*
t_acquire_tsk_lock(TCB *p_tcb)
{
	t_acquire_lock(&giant_lock);
	return(p_tcb->p_pcb);
}

/*
 *  ǤեʼޤˤΥåμʥƥ/2ܡ
 */
Inline PCB*
t_acquire_nested_tsk_lock(TCB *p_tcb, LOCK *p_objlock)
{
	return(p_tcb->p_pcb);
}

/*
 *  ǤդΥ顼ϥɥΥåμʥƥ/1ܡ
 * 
 *  оݥ顼ϥɥ餬ޥ졼󤹤ǽΤǡåˡ
 *  p_pcb롥
 */
Inline PCB*
t_acquire_tsk_lock_alm(ALMCB *p_almcb)
{
	t_acquire_lock(&giant_lock);
	return(p_almcb->p_pcb);
}

/*
 *  ǤդμϥɥΥåμʥƥ/1ܡ
 *  
 *  оݼϥɥ餬ޥ졼󤹤ǽΤǡåˡ
 *  p_pcb롥  
 */
Inline PCB*
t_acquire_tsk_lock_cyc(CYCCB *p_cyccb)
{
	t_acquire_lock(&giant_lock);
	return(p_cyccb->p_pcb);
}

/*
 *  2ĤΥåμʥƥ/1ܡ
 * 
 *  оݥޥ졼󤹤ǽΤǡåˡp_pcb롥    
 */  
Inline void
t_acquire_dual_tsk_lock(TCB *p_tcb, ID dstprcid, 
						PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	t_acquire_lock(&giant_lock);
	*pp_srcpcb = p_tcb->p_pcb;
	*pp_dstpcb = get_mp_p_pcb(dstprcid);
}

/*
 *  顼ϥɥ2ĤΥåμʥƥ/1ܡ
 * 
 *  оݥ顼ϥɥ餬ޥ졼󤹤ǽΤǡåˡ
 *  p_pcb롥  
 */  
Inline void
t_acquire_dual_tsk_lock_alm(ALMCB *p_almcb, ID dstprcid, 
							PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	t_acquire_lock(&giant_lock);
	*pp_srcpcb = p_almcb->p_pcb;
	*pp_dstpcb = get_mp_p_pcb(dstprcid);
}

/*
 *  ϥɥ2ĤΥåμʥƥ/1ܡ
 *  
 *  оݼϥɥ餬ޥ졼󤹤ǽΤǡåˡ
 *  p_pcb롥    
 */  
Inline void
t_acquire_dual_tsk_lock_cyc(CYCCB *p_cyccb, ID dstprcid, 
							PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	t_acquire_lock(&giant_lock);
	*pp_srcpcb = p_cyccb->p_pcb;
	*pp_dstpcb = get_mp_p_pcb(dstprcid);
}

/*
 *  2ĤΥåμʥƥ/2ܡ
 */
Inline bool_t
t_acquire_nested_dual_tsk_lock(TCB *p_tcb, ID dstprcid, LOCK *p_objlock,
							   PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	*pp_srcpcb = p_tcb->p_pcb;
	*pp_dstpcb = get_mp_p_pcb(dstprcid);
	return(false);
}

/*
 *		󥿥ƥѤΥåؿ
 */

/*
 *  ǤեץåΥåμ󥿥ƥȡ
 */
Inline PCB*
i_acquire_tsk_lock_prcid(ID prcid)
{
	i_acquire_lock(&giant_lock);
	return(get_mp_p_pcb(prcid));
}

/*
 *  ץåΥåμ󥿥ƥ/1ܡ
 */ 
Inline PCB*
i_acquire_tsk_lock_self(void)
{
	i_acquire_lock(&giant_lock);
	return(get_my_p_pcb());
}

/*
 *  ǤեΥåμ󥿥ƥ/1ܡ
 *
 *  оݥޥ졼󤹤ǽΤǡåˡ
 *  pp_pcb롥
 */
Inline PCB*
i_acquire_tsk_lock(TCB *p_tcb)
{
	i_acquire_lock(&giant_lock);
	return(p_tcb->p_pcb);
}

/*
 *  ǤեΥåμ󥿥ƥ/2ܡ
 */
Inline PCB*
i_acquire_nested_tsk_lock(TCB *p_tcb, LOCK *p_objlock)
{
	return(p_tcb->p_pcb);
}

/*
 *  ǤդΥ顼ϥɥΥåμ󥿥ƥȡ
 *
 *  оݥ顼ϥɥ餬ޥ졼󤹤ǽΤǡåˡ
 *  pp_pcb롥
 */
Inline PCB*
i_acquire_tsk_lock_alm(ALMCB *p_almcb)
{
	i_acquire_lock(&giant_lock);
	return(p_almcb->p_pcb);
}

/*
 *  2ĤΥåμ󥿥ƥ/1ܡ
 *
 *  оݥޥ졼󤹤ǽΤǡåˡ
 *  pp_srcpcb롥  
 */  
Inline void
i_acquire_dual_tsk_lock(TCB *p_tcb, ID dstprcid, 
						PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	i_acquire_lock(&giant_lock);
	*pp_srcpcb = p_tcb->p_pcb;
	*pp_dstpcb = get_mp_p_pcb(dstprcid);
}

/*
 *  顼ϥɥ2ĤΥåμʥƥ/1ܡ
 *
 *  оݥ顼ϥɥ餬ޥ졼󤹤ǽΤǡå
 *  ˡpp_srcpcb롥  
 */  
Inline void
i_acquire_dual_tsk_lock_alm(ALMCB *p_almcb, ID dstprcid, 
							PCB **pp_srcpcb, PCB **pp_dstpcb)
{
	i_acquire_lock(&giant_lock);
	*pp_srcpcb = p_almcb->p_pcb;
	*pp_dstpcb = get_mp_p_pcb(dstprcid);
}

/*
 *		ƥѤΥ֥ȥåؿ
 */

/*
 *  ֥ȥåμʥƥȡ
 */
Inline void
t_acquire_obj_lock(LOCK *p_objlock)
{
	t_acquire_lock(&giant_lock);
}

/*
 *		󥿥ƥѤΥ֥ȥåؿ
 */

/*
 * ֥ȥåμ󥿥ƥȡ
 */ 
Inline void
i_acquire_obj_lock(LOCK *p_objlock)
{
	t_acquire_lock(&giant_lock);
}

/*
 *		åؿ
 */

/*
 *  åβʥƥȡ
 */ 
Inline void
release_tsk_lock(PCB *p_pcb)
{
	x_release_lock(&giant_lock);
}

/*
 *  åβ2ܡ
 */ 
Inline void
release_nested_tsk_lock(PCB *p_pcb)
{
	
}

/*
 *  åβȥǥѥå
 */
Inline void
release_tsk_lock_and_dispatch(PCB *p_pcb,  bool_t dspreq)
{
	x_release_lock(&giant_lock);
	if (dspreq) {
		dispatch();
	}
}

/*
 *  2ĤΥåβ
 */ 
Inline void
release_dual_tsk_lock(PCB *p_srcpcb,  PCB *p_dstpcb)
{
	x_release_lock(&giant_lock);
}

/*
 *  2ĤΥåβȥǥѥå
 */
Inline void
release_dual_tsk_lock_and_dispatch(PCB *p_srcpcb,  PCB *p_dstpcb, bool_t dspreq)
{
	x_release_lock(&giant_lock);
	if (dspreq) {
		dispatch();
	}
}

/*
 *		֥ȥåؿ
 */

/*
 * ֥ȥåβ󥿥ƥȡ
 */ 
Inline void
release_obj_lock(LOCK *p_objlock)
{
	x_release_lock(&giant_lock);
}

/*
 * ֥ȥåβȥǥѥå
 */ 
Inline void
release_obj_lock_and_dispatch(LOCK *p_objlock, bool_t dspreq)
{
	x_release_lock(&giant_lock);
	if (dspreq) {
		dispatch();
	}
}

/*
 *		¾Υåؿ
 */

/*
 *  ץꥨץ󤷤ʤΥåμ
 */
Inline PCB*
acquire_tsk_lock_without_preemption_self(void)
{
	x_acquire_lock_without_preemption(&giant_lock);
	return(get_my_p_pcb());
} 
  
/*
 *  ץꥨץ󤷤ʤåμ2ܡ
 */
Inline PCB*
acquire_nested_tsk_lock_without_preemption(TCB *p_tcb)
{
	return(p_tcb->p_pcb);
}

#else /* TTYPE_KLOCK != G_KLOCK */

#if TTYPE_KLOCK == P_KLOCK
#define GET_OBJLOCK(p_wobjcb)   (*((WOBJCB*)p_wobjcb)->p_wobjinib->p_obj_lock)
#else /* TTYPE_KLOCK == F_KLOCK */
#define GET_OBJLOCK(p_wobjcb)   (p_wobjcb->obj_lock)
#endif /* TTYPE_KLOCK == F_KLOCK */

/*
 *  ץååʤγ٥å
 */

/*
 *		ƥѤΥåؿ
 */

/*
 *  ǤեץåΥåμʥƥȡ
 */
extern PCB* t_acquire_tsk_lock_prcid(ID prcid);

/*
 *  ץåΥåμʥƥ/1ܡ
 */ 
extern PCB* t_acquire_tsk_lock_self(void);

/*
 *  ץåΥåμʥƥ/2ܡ
 */ 
extern PCB* t_acquire_nested_tsk_lock_self(LOCK *p_objlock);

/*
 *  ǤեʼޤˤΥåμʥƥ/1ܡ
 */ 
extern PCB* t_acquire_tsk_lock(TCB *p_tcb);

/*
 *  ǤեʼޤˤΥåμʥƥ/2ܡ
 */ 
extern PCB* t_acquire_nested_tsk_lock(TCB *p_tcb, LOCK *p_objlock);

/*
 *  ǤդΥ顼ϥɥΥåμʥƥ/1ܡ 
 */
extern PCB* t_acquire_tsk_lock_alm(ALMCB *p_almcb);

/*
 *  ǤդμϥɥΥåμʥƥ/1ܡ 
 */
extern PCB* t_acquire_tsk_lock_cyc(CYCCB *p_cyccb);

/*
 *  2ĤΥåμʥƥ/1ܡ
 */  
extern void t_acquire_dual_tsk_lock(TCB *p_tcb, ID dstprcid, 
									PCB **pp_srcpcb, PCB **pp_dstpcb);

/*
 *  2ĤΥåμʥƥ/2ܡ
 */
extern bool_t t_acquire_nested_dual_tsk_lock(TCB *p_tcb, ID dstprcid, LOCK *p_objlock,
										 PCB **pp_srcpcb, PCB **pp_dstpcb);

/*
 *  顼ϥɥ2ĤΥåμʥƥ/1ܡ
 */  
extern void t_acquire_dual_tsk_lock_alm(ALMCB *p_almcb, ID dstprcid, 
										PCB **pp_srcpcb, PCB **pp_dstpcb);

/*
 *  ϥɥ2ĤΥåμʥƥ/1ܡ
 */  
extern void t_acquire_dual_tsk_lock_cyc(CYCCB *p_cyccb, ID dstprcid, 
										PCB **pp_srcpcb, PCB **pp_dstpcb);

/*
 *		󥿥ƥѤΥåؿ
 */

/*
 *  ǤեץåΥåμ󥿥ƥȡ
 */
extern PCB* i_acquire_tsk_lock_prcid(ID prcid);

/*
 *  ץåΥåμ󥿥ƥ/1ܡ
 */ 
extern PCB* i_acquire_tsk_lock_self(void);

/*
 *  ǤեΥåμ󥿥ƥ/1ܡ
 */
extern PCB* i_acquire_tsk_lock(TCB *p_tcb);

/*
 *  ǤեΥåμ󥿥ƥ/2ܡ
 */
extern PCB* i_acquire_nested_tsk_lock(TCB *p_tcb, LOCK *p_objlock);

/*
 *  ǤդΥ顼ϥɥΥåμ󥿥ƥȡ 
 */
extern PCB* i_acquire_tsk_lock_alm(ALMCB *p_almcb);

/*
 *  2ĤΥåμ󥿥ƥ/1ܡ
 */  
extern void i_acquire_dual_tsk_lock(TCB *p_tcb, ID dstprcid, 
									PCB **pp_srcpcb, PCB **pp_dstpcb);

/*
 *  顼ϥɥ2ĤΥåμʥƥ/1ܡ
 */  
extern void i_acquire_dual_tsk_lock_alm(ALMCB *p_almcb, ID dstprcid, 
										PCB **pp_srcpcb, PCB **pp_dstpcb);

/*
 *		ƥѤΥ֥ȥåؿ
 */

/*
 *  ֥ȥåμʥƥȡ
 */
extern void t_acquire_obj_lock(LOCK *p_objlock);

/*
 *  ֥ȥåβʥƥȡ
 */
extern void t_release_obj_lock(LOCK *p_objlock);

/*
 *		󥿥ƥѤΥ֥ȥåؿ
 */

/*
 * ֥ȥåμ󥿥ƥȡ
 */ 
extern void i_acquire_obj_lock(LOCK *p_objlock);

/*
 *		åؿ
 */

/*
 *  åβ
 */ 
extern void release_tsk_lock(PCB *p_pcb);

/*
 *  åβ2ܡ
 */ 
extern void release_nested_tsk_lock(PCB *p_pcb);

/*
 *  åβȥǥѥå
 */
extern void release_tsk_lock_and_dispatch(PCB *p_pcb, bool_t dspreq);

/*
 *  2ĤΥåβʥƥȡ
 */ 
extern void release_dual_tsk_lock(PCB *p_srcpcb,  PCB *p_dstpcb);

/*
 *  2ĤΥåβȥǥѥåʥƥȡ
 */
extern void release_dual_tsk_lock_and_dispatch(PCB *p_srcpcb,  PCB *p_dstpcb,
											   bool_t dspreq);

/*
 *		֥ȥåؿ
 */

/*
 * ֥ȥåβ
 */
extern void release_obj_lock(LOCK *p_objlock);

/*
 * ֥ȥåβȥǥѥå
 */ 
extern void release_obj_lock_and_dispatch(LOCK *p_objlock, bool_t dspreq);

/*
 *		¾Υåؿ
 */

/*
 *  ץꥨץ󤷤ʤΥåμ
 */
extern PCB* acquire_tsk_lock_without_preemption_self(void);

/*
 *  ץꥨץ󤷤ʤåμ2ܡ
 */
extern PCB* acquire_nested_tsk_lock_without_preemption(TCB *p_tcb);

#endif /* TTYPE_KLOCK != G_KLOCK */

#endif /* TOPPERS_MP_H */
