/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: wait.c 532 2010-02-16 10:09:15Z ertl-honda $
 */

/*
 *		Ԥִ⥸塼
 */

#include "kernel_impl.h"
#include "wait.h"
#include "mp.h"

/*
 *  Ԥ֤ؤΰܹԡʥॢȻ
 */
#ifdef TOPPERS_waimake

void
make_wait_tmout(TMO tmout, PCB *p_pcb)
{
	TCB *p_runtsk = p_pcb->p_runtsk;

	(void) make_non_runnable(p_runtsk);
	if (tmout > 0) {
		tmevtb_enqueue(p_pcb->p_tevtcb, &(p_runtsk->tmevtb), (RELTIM) tmout,
						(CBACK) wait_tmout, (void *) p_runtsk);
	}
	else {
		assert(tmout == TMO_FEVR);
		(p_runtsk->tmevtb).callback = NULL;
	}
}

#endif /* TOPPERS_waimake */

/*
 *  ԤΤΥ֤ι
 *
 *  p_tcbǻꤵ륿Ԥ褦֤򹹿롥
 *  Ԥ륿¹ԤǤ֤ˤʤϡǥ塼ˤĤ
 *  ޤǥѥåɬפʾˤtrue֤
 *    
 *  Ԥ֤ϡɬδؿƤӽФᡤǥåɥå
 *  ΤΥڥǥ󥰥ե饰ΥåޤȤƹԤ
 */
Inline bool_t
make_non_wait(TCB *p_tcb)
{
	assert(TSTAT_WAITING(p_tcb->tstat));

#if TTYPE_KLOCK != G_KLOCK
	/* ͥѹե饰å */
	if (p_tcb->pend_chgpri) {
		p_tcb->priority = p_tcb->pend_newpri;
		/* ͥѹե饰Υꥢ */
		p_tcb->pend_chgpri = false;
	}

	/* Ԥαꥢ */
	p_tcb->pend_relwai = false;
#endif /* TTYPE_KLOCK != G_KLOCK */

	if (!TSTAT_SUSPENDED(p_tcb->tstat)) {
		/*
		 *  Ԥ֤¹ԤǤ֤ؤ
		 */
		p_tcb->tstat = TS_RUNNABLE;
		LOG_TSKSTAT(p_tcb);
		return(make_runnable(p_tcb));
	}
	else {
		/*
		 *  Ԥ֤鶯Ԥ֤ؤ
		 */
		p_tcb->tstat = TS_SUSPENDED;
		LOG_TSKSTAT(p_tcb);
		return(false);
	}
}

/*
 *  Ԥ
 */
#ifdef TOPPERS_waicmp

bool_t
wait_complete(TCB *p_tcb)
{
	wait_dequeue_tmevtb(p_tcb);
	p_tcb->wercd = E_OK;
	return(make_non_wait(p_tcb));
}

#endif /* TOPPERS_waicmp */

/*
 *  ॢȤȼԤ
 *
 *  ܴؿ make_wait_tmout() ˤ꥿ҡפϿ쥿ॢ
 *  ˥ХåؿȤƸƤӽФ롥ΤᡤCPUå֤ġ
 *  å֤ǸƤӽФ롥 
 */
#ifdef TOPPERS_waitmo

void
wait_tmout(TCB *p_tcb)
{
	PCB		*my_p_pcb;

#if TTYPE_KLOCK == G_KLOCK
	/*
	 *  㥤ȥåξñwait塼
	 */
	wait_dequeue_wobj(p_tcb);
#else /* TTYPE_KLOCK != G_KLOCK */
	/*
	 *  ¾Υå
	 *
	 *  ֥åϡǥåɥåԤ
	 */
	if (TSTAT_WAIT_WOBJ(p_tcb->tstat)) {
		/* ֥Ԥξ */
		WOBJCB* volatile p_wobjcb = p_tcb->p_wobjcb;
		p_tcb->pend_relwai = true;
		release_tsk_lock(p_tcb->p_pcb);

		/*
		 * 餿
		 * ֥ȥå -> åνǥå
		 */
	  retry:
		i_acquire_obj_lock(&GET_OBJLOCK(p_wobjcb));
		if (i_acquire_nested_tsk_lock(p_tcb, &GET_OBJLOCK(p_wobjcb)) == NULL){
			goto retry;
		}

		/* ξ֤ѲƤʤå */
		if (!(p_tcb->pend_relwai)) {
			/* ¾βսԤʤ줿 */
			release_obj_lock(&GET_OBJLOCK(p_wobjcb));
			return;
		}
		p_tcb->pend_relwai = false;
		wait_dequeue_wobj(p_tcb);
		release_obj_lock(&GET_OBJLOCK(p_wobjcb));
	}
#endif /* TTYPE_KLOCK != G_KLOCK */

	p_tcb->wercd = E_TMOUT;
	if (make_non_wait(p_tcb)) {
		if (dispatch_request(p_tcb->p_pcb)) {
			p_tcb->p_pcb->reqflg = true;
		}
	}

	/*
	 *  ͥ٤ι⤤ߤդ롥
	 */
	my_p_pcb = get_my_p_pcb();
	release_tsk_lock(my_p_pcb);
	i_unlock_cpu();
	i_lock_cpu();
	i_acquire_tsk_lock_self();
}

#endif /* TOPPERS_waitmo */

#ifdef TOPPERS_waitmook

void
wait_tmout_ok(TCB *p_tcb)
{
	PCB *p_pcb = p_tcb->p_pcb;
	PCB *my_p_pcb;

	p_tcb->wercd = E_OK;
	if (make_non_wait(p_tcb)) {
		if (dispatch_request(p_tcb->p_pcb)) {
			p_pcb->reqflg = true;
		}
	}

	/*
	 *  ͥ٤ι⤤ߤդ롥
	 */
	my_p_pcb = get_my_p_pcb();
	release_tsk_lock(my_p_pcb);
	i_unlock_cpu();
	i_lock_cpu();
	i_acquire_tsk_lock_self();
}

#endif /* TOPPERS_waitmook */

/*
 *  Ԥ֤ζ
 */
#ifdef TOPPERS_wairel

bool_t
wait_release(TCB *p_tcb)
{
	wait_dequeue_wobj(p_tcb);
	wait_dequeue_tmevtb(p_tcb);
	p_tcb->wercd = E_RLWAI;
	return(make_non_wait(p_tcb));
}

#endif /* TOPPERS_wairel */

/*
 *  ¹ΥƱ֥̿ȤԤ塼ؤ
 *
 *  ¹ΥƱ֥̿ȤԤ塼롥
 *  ֥Ȥ°˱ơFIFOޤϥͥٽ롥
 */
Inline void
wobj_queue_insert(WOBJCB *p_wobjcb, TCB *p_runtsk)
{
	if ((p_wobjcb->p_wobjinib->wobjatr & TA_TPRI) != 0U) {
		queue_insert_tpri(&(p_wobjcb->wait_queue), p_runtsk);
	}
	else {
		queue_insert_prev(&(p_wobjcb->wait_queue), &(p_runtsk->task_queue));
	}
}

/*
 *  Ʊ֥̿ȤФԤ֤ؤΰܹ
 */
#ifdef TOPPERS_wobjwai

void
wobj_make_wait(WOBJCB *p_wobjcb, TCB *p_runtsk)
{
	make_wait(p_runtsk);
	wobj_queue_insert(p_wobjcb, p_runtsk);
	p_runtsk->p_wobjcb = p_wobjcb;
	LOG_TSKSTAT(p_runtsk);
}

#endif /* TOPPERS_wobjwai */
#ifdef TOPPERS_wobjwaitmo

void
wobj_make_wait_tmout(WOBJCB *p_wobjcb, TMO tmout, TCB *p_runtsk)
{
	make_wait_tmout(tmout, p_runtsk->p_pcb);
	wobj_queue_insert(p_wobjcb, p_runtsk);
	p_runtsk->p_wobjcb = p_wobjcb;
	LOG_TSKSTAT(p_runtsk);
}

#endif /* TOPPERS_wobjwaitmo */

/*
 *  Ԥ塼ν
 */
#ifdef TOPPERS_iniwque

bool_t
init_wait_queue(QUEUE *p_wait_queue)
{
	TCB		*p_tcb;
	bool_t	dspreq = false;
	PCB		*p_pcb;     

	while (!queue_empty(p_wait_queue)) {
		p_tcb = (TCB *) queue_delete_next(p_wait_queue);
		/* åμ */
		p_pcb = acquire_nested_tsk_lock_without_preemption(p_tcb);
		wait_dequeue_tmevtb(p_tcb);
		p_tcb->wercd = E_DLT;
		if (make_non_wait(p_tcb)) {
			if (dispatch_request(p_pcb)) {
				dspreq = true;
			}
		}
		release_tsk_lock(p_pcb);
	}

	return(dspreq);
}

#endif /* TOPPERS_iniwque */
