/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: histogram.c 244 2009-04-30 05:08:42Z ertl-honda $
 */

/*
 *		¹Իʬ۽ץ⥸塼
 */

#include <kernel.h>
#include <t_syslog.h>
#include "syssvc/logtask.h"
#include <histogram.h>
#include "target_test.h"
#include "target_timer.h"

/*
 *  ¹Իʬ۷¬ο
 */
#ifndef TNUM_HIST
#define TNUM_HIST		10
#endif /* TNUM_HIST */

/*
 *  åȰ¸ѹ뤿Υޥ
 */
#ifndef HISTTIM
#define HISTTIM		SYSUTM
#endif /* HISTTIM */

#ifndef HIST_GET_TIM
#ifndef TOPPERS_SUPPORT_GET_UTM
#error get_utm is not supported.
#endif /* TOPPERS_SUPPORT_GET_UTM */
#define HIST_GET_TIM(p_time)	((void) get_utm(p_time))
#endif /* HIST_GET_TIM */

#ifndef HIST_CONV_TIM
#define HIST_CONV_TIM(time)		((uint_t)(time))
#endif /* HIST_CONV_TIM */

#ifndef HIST_BM_HOOK
#define HIST_BM_HOOK()			((void) 0)
#endif

/*
 *  ¹Իʬ۷¬֥å
 */
typedef struct histogram_control_block {
	HISTTIM		begin_time;			/* ¬ϻ */
	uint_t		maxval;				/* ʬۤϿ */
	uint_t		*histarea;			/* ʬۤϿΰ */
	uint_t		over;				/* ֤Ķٿ */
	uint_t		under;				/* ֤εžٿ */
} HISTCB;

/*
 *  ¹Իʬ۷¬֥åΥꥢ
 */
HISTCB	histcb_table[TNUM_HIST];

/*
 *  ¹Իʬ۷¬IDκǾͤȺ
 */
#define TMIN_HISTID		1
#define TMAX_HISTID		(TMIN_HISTID + TNUM_HIST - 1)

/*
 *  ¹Իʬ۷¬ν
 */
void
init_hist(ID histid, uint_t maxval, uint_t histarea[])
{
	HISTCB	*p_histcb;
	uint_t	i;

	assert(TMIN_HISTID <= histid && histid <= TMAX_HISTID);
	p_histcb = &(histcb_table[histid - TMIN_HISTID]);

	for (i = 0; i <= maxval; i++) {
		histarea[i] = 0U;
	}
	p_histcb->maxval = maxval;
	p_histcb->histarea = histarea;
	p_histcb->over = 0U;
	p_histcb->under = 0U;
}

/*
 *  ¹Իַ¬γ
 */
 
#define CP15_PM_CONTROL_READ(x) Asm("mrc p15, 0, %0, c9, c12, 0":"=r"(x))
#define CP15_PM_CONTROL_WRITE(x) Asm("mcr p15, 0, %0, c9, c12, 0"::"r"(x))

#define CP15_PM_COUNT_ENABLE_SET_READ(x) Asm("mrc p15, 0, %0, c9, c12, 1":"=r"(x))
#define CP15_PM_COUNT_ENABLE_SET_WRITE(x) Asm("mcr p15, 0, %0, c9, c12, 1"::"r"(x))

#define CP15_PM_COUNT_ENABLE_CLEAR_READ(x) Asm("mrc p15, 0, %0, c9, c12, 2":"=r"(x))
#define CP15_PM_COUNT_ENABLE_CLEAR_WRITE(x) Asm("mcr p15, 0, %0, c9, c12, 2"::"r"(x))

#define CP15_PM_CYCLE_READ(x) Asm("mrc p15, 0, %0, c9, c13, 0":"=r"(x))
#define CP15_PM_CYCLE_WRITE(x) Asm("mcr p15, 0, %0, c9, c13, 0"::"r"(x))

#define CP15_PM_CYCLE_READ(x) Asm("mrc p15, 0, %0, c9, c13, 0":"=r"(x))
#define CP15_PM_CYCLE_WRITE(x) Asm("mcr p15, 0, %0, c9, c13, 0"::"r"(x))

#define CP15_PM_EVENT_COUNTER_SELECT_READ(x) Asm("mrc p15, 0, %0, c9, c12, 5":"=r"(x))
#define CP15_PM_EVENT_COUNTER_SELECT_WRITE(x) Asm("mcr p15, 0, %0, c9, c12, 5"::"r"(x))

#define CP15_PM_EVENT_TYPE_SELECT_READ(x) Asm("mrc p15, 0, %0, c9, c13, 1":"=r"(x))
#define CP15_PM_EVENT_TYPE_SELECT_WRITE(x) Asm("mcr p15, 0, %0, c9, c13, 1"::"r"(x))

void
begin_measure(ID histid)
{
	HISTCB	*p_histcb;

	assert(TMIN_HISTID <= histid && histid <= TMAX_HISTID);
	p_histcb = &(histcb_table[histid - TMIN_HISTID]);

	HIST_BM_HOOK();
	HIST_GET_TIM(&(p_histcb->begin_time));
	
//	p_histcb->begin_time = 0;		
//	CP15_PM_EVENT_COUNTER_SELECT_WRITE(0);
//	CP15_PM_EVENT_TYPE_SELECT_WRITE(0x11);	
//	CP15_PM_COUNT_ENABLE_CLEAR_WRITE((1<<31)); // disable cycle counter
//	CP15_PM_CONTROL_WRITE(0); // disable all counters + count in cycles
//	CP15_PM_CYCLE_WRITE(0);   // load 0 to counter
//	CP15_PM_COUNT_ENABLE_SET_WRITE((1<<31)); // enable cycle counter
//	CP15_PM_CONTROL_WRITE(1); // enable all counters	
}



/*
 *  ¹Իַ¬νλ
 */
void
end_measure(ID histid)
{
	HISTCB	*p_histcb;
	HISTTIM	end_time;
	uint_t	val;

//	CP15_PM_CYCLE_READ(val);
//	CP15_PM_COUNT_ENABLE_CLEAR_WRITE((1<<31)); // disable cycle counter
//	CP15_PM_CONTROL_WRITE(0); // disable all counters + count in cycles

	HIST_GET_TIM(&end_time);

	assert(TMIN_HISTID <= histid && histid <= TMAX_HISTID);
	p_histcb = &(histcb_table[histid - TMIN_HISTID]);

	val = HIST_CONV_TIM(end_time - p_histcb->begin_time);
	
	if (val <= p_histcb->maxval) {
		p_histcb->histarea[val]++;
	}
	else if (val <= ((uint_t) INT_MAX)) {
		p_histcb->over++;
	}
	else {
		p_histcb->under++;
	}
}

/*
 *  ¹Իʬ۷¬ɽ
 */
void
print_hist(ID histid)
{
	HISTCB	*p_histcb;
	uint_t	i;

	assert(TMIN_HISTID <= histid && histid <= TMAX_HISTID);
	p_histcb = &(histcb_table[histid - TMIN_HISTID]);

	for (i = 0; i <= p_histcb->maxval; i++) {
		if (p_histcb->histarea[i] > 0) {
			//syslog_2(LOG_NOTICE, "%d : %d", i, p_histcb->histarea[i]);
			syslog_2(LOG_EMERG, "%d : %d", i, p_histcb->histarea[i]);
			(void) logtask_flush(4U);
		}
	}
	if (p_histcb->over > 0) {
		syslog_2(LOG_NOTICE, "overrun (maxval:num)> %d : %d", p_histcb->maxval, p_histcb->over);
	}
	if (p_histcb->under > 0) {
		syslog_1(LOG_NOTICE, "underrun (intmax:num)> INT_MAX : %d", p_histcb->under);
	}
	(void) logtask_flush(0U);
}
