/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: arm_primecell_uart.c 542 2010-02-24 09:59:10Z ertl-honda $
 */

/*
 *   ARM PrimeCell UART ʰSIOɥ饤
 */

#include <sil.h>
#include "target_syssvc.h"
#include "arm_primecell_uart.h"

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
    void  *dr;    /* ǡ쥸 */
    void  *rsr;   /* ơ쥸 */
    void  *fr;    /* ե饰쥸 */
    void  *ibrd;  /* ܡ졼ȥ쥸 */
    void  *fbrd;  /* ʬܡ졼ȥ쥸 */
    void  *lcr_h; /* 饤󥳥ȥ쥸(H) */
    void  *cr;    /* ȥ쥸 */
    void  *imsc;  /* ߥޥ쥸 */
    uint8_t lcr_h_def; /* 饤󥳥ȥ쥸 */
    uint8_t ibrd_def;  /* ܡ졼ȥ쥸 */
    uint8_t fbrd_def;  /* ʬܡ졼ȥ쥸 */
    uint32_t intno;    /* ֹ */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
    const SIOPINIB  *siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t  exinf;            /* ĥ */
    bool_t    openflag;           /* ץѤߥե饰 */
    bool_t    sendflag;           /* ߥ֥͡ե饰 */
    bool_t    getready;           /* ʸ */
    bool_t    putready;           /* ʸǤ */
};

/*
 *  ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {(void *)(UART0_BASE + UART_DR),
     (void *)(UART0_BASE + UART_RSR),
     (void *)(UART0_BASE + UART_FR),
     (void *)(UART0_BASE + UART_IBRD),
     (void *)(UART0_BASE + UART_FBRD),
     (void *)(UART0_BASE + UART_LCR_H),
     (void *)(UART0_BASE + UART_CR),
     (void *)(UART0_BASE + UART_IMSC),
     UART_LCR_H_WLEN_8,
     UART_IBRD_38400,   
     UART_FBRD_38400,
     INTNO_SIO0,
    },
#if TNUM_PORT >= 2 
    {(void *)(UART1_BASE + UART_DR),
     (void *)(UART1_BASE + UART_RSR),        
     (void *)(UART1_BASE + UART_FR),
     (void *)(UART1_BASE + UART_IBRD),
     (void *)(UART1_BASE + UART_FBRD),
     (void *)(UART1_BASE + UART_LCR_H),
     (void *)(UART1_BASE + UART_CR),
     (void *)(UART1_BASE + UART_IMSC),
     UART_LCR_H_WLEN_8,
     UART_IBRD_38400,   
     UART_FBRD_38400,
     INTNO_SIO1,
    },
#endif /* TNUM_PORT >= 2 */
#if TNUM_PORT >= 3 
    {(void *)(UART2_BASE + UART_DR),
     (void *)(UART2_BASE + UART_RSR),
     (void *)(UART2_BASE + UART_FR),
     (void *)(UART2_BASE + UART_IBRD),
     (void *)(UART2_BASE + UART_FBRD),
     (void *)(UART2_BASE + UART_LCR_H),
     (void *)(UART2_BASE + UART_CR),
     (void *)(UART2_BASE + UART_IMSC),
     UART_LCR_H_WLEN_8,
     UART_IBRD_38400,   
     UART_FBRD_38400,
     INTNO_SIO2,
    },
#endif /* TNUM_PORT >= 3 */
#if TNUM_PORT >= 4 
    {(void *)(UART3_BASE + UART_DR),
     (void *)(UART3_BASE + UART_RSR),        
     (void *)(UART3_BASE + UART_FR),
     (void *)(UART3_BASE + UART_IBRD),
     (void *)(UART3_BASE + UART_FBRD),
     (void *)(UART3_BASE + UART_LCR_H),
     (void *)(UART3_BASE + UART_CR),
     (void *)(UART3_BASE + UART_IMSC),
     UART_LCR_H_WLEN_8,
     UART_IBRD_38400,   
     UART_FBRD_38400,
     INTNO_SIO3,
    }
#endif /* TNUM_PORT >= 4 */
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)	((uint_t)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  ʸǤ뤫
 */
Inline bool_t
arm_primecell_uart_getready(SIOPCB *p_siopcb)
{
    return((sil_rew_mem(p_siopcb->siopinib->fr) & UART_FR_RXFE) != UART_FR_RXFE);
}

/*
 *  ʸǤ뤫
 */
Inline bool_t
arm_primecell_uart_putready(SIOPCB *p_siopcb)
{
    return((sil_rew_mem(p_siopcb->siopinib->fr) & UART_FR_TXFF) != UART_FR_TXFF);
}

/*
 *  ʸμФ
 */
Inline char_t
arm_primecell_uart_getchar(SIOPCB *p_siopcb)
{
    return((char_t)sil_rew_mem(p_siopcb->siopinib->dr));
}

/*
 *  ʸν
 */
Inline void
arm_primecell_uart_putchar(SIOPCB *p_siopcb, char_t c)
{
    sil_wrw_mem(p_siopcb->siopinib->dr, c);
}

/*
 *  ߵ
 */
Inline void
arm_primecell_uart_enable_send(SIOPCB *p_siopcb)
{
    sil_wrw_mem(p_siopcb->siopinib->imsc,
                sil_rew_mem(p_siopcb->siopinib->imsc) | UART_IMSC_TXIM);
}

/*
 *  ߶ػ
 */
Inline void
arm_primecell_uart_disable_send(SIOPCB *p_siopcb)
{
    sil_wrw_mem(p_siopcb->siopinib->imsc, 
				sil_rew_mem(p_siopcb->siopinib->imsc) & ~UART_IMSC_TXIM);
}


/*
 *  ߵ
 */
Inline void
arm_primecell_uart_enable_rcv(SIOPCB *p_siopcb)
{
	sil_wrw_mem(p_siopcb->siopinib->imsc, 
				sil_rew_mem(p_siopcb->siopinib->imsc) | UART_IMSC_RXIM);
}

/*
 *  ߶ػ
 */
Inline void
arm_primecell_uart_disable_rcv(SIOPCB *p_siopcb)
{
	sil_wrw_mem(p_siopcb->siopinib->imsc, 
				sil_rew_mem(p_siopcb->siopinib->imsc) & ~UART_IMSC_RXIM);
}

/*
 *  SIOɥ饤Фν
 */
void
arm_primecell_uart_initialize(void)
{
	SIOPCB	*p_siopcb;
	uint_t	i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
		p_siopcb->siopinib = &(siopinib_table[i]);
		p_siopcb->openflag = false;
		p_siopcb->sendflag = false;
	}
}

/*
 *  ץ󤷤ƤݡȤ뤫
 */
bool_t
arm_primecell_uart_openflag(ID siopid)
{
	SIOPCB          *p_siopcb;

	p_siopcb = get_siopcb(siopid);

	return(p_siopcb->openflag);
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
arm_primecell_uart_opn_por(ID siopid, intptr_t exinf)
{
	char_t c;
    
	SIOPCB          *p_siopcb;
	const SIOPINIB  *p_siopinib;

	p_siopcb = get_siopcb(siopid);
	p_siopinib = p_siopcb->siopinib;

	/* UART */
	sil_wrw_mem(p_siopcb->siopinib->cr, 0x00);

    /* 顼ե饰򥯥ꥢ */
	sil_wrw_mem(p_siopcb->siopinib->rsr, 0x00);

	/* FIFOˤ */
	while(arm_primecell_uart_getready(p_siopcb)){
		/* Хåեɤ߹ */
		c = arm_primecell_uart_getchar(p_siopcb);
	}

	/* ܡ졼Ȥ */
	sil_wrw_mem(p_siopcb->siopinib->ibrd, p_siopcb->siopinib->ibrd_def);
	sil_wrw_mem(p_siopcb->siopinib->fbrd, p_siopcb->siopinib->fbrd_def);
	
	/* ǡեޥåȤȡFIFOΥ⡼ɤ */
	sil_wrw_mem(p_siopcb->siopinib->lcr_h, p_siopcb->siopinib->lcr_h_def);
		
	/* UARTƳ */
	sil_wrw_mem(p_siopcb->siopinib->cr,
				(sil_rew_mem(p_siopcb->siopinib->cr)
                 | UART_CR_RXE | UART_CR_TXE | UART_CR_UARTEN));
    
    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);   
}

/*
 *  ꥢI/OݡȤΥ
 */
void
arm_primecell_uart_cls_por(SIOPCB *p_siopcb)
{
    /* UART */
	sil_wrw_mem(p_siopcb->siopinib->cr, 0x00);
    p_siopcb->openflag = false;
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
arm_primecell_uart_snd_chr(SIOPCB *p_siopcb, char_t c)
{
    if (arm_primecell_uart_putready(p_siopcb)){
        arm_primecell_uart_putchar(p_siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
arm_primecell_uart_rcv_chr(SIOPCB *p_siopcb)
{
	if (arm_primecell_uart_getready(p_siopcb)) {
		return((int_t)(uint8_t) arm_primecell_uart_getchar(p_siopcb));
	}
	return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
arm_primecell_uart_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        arm_primecell_uart_enable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        arm_primecell_uart_enable_rcv(p_siopcb);
        break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
arm_primecell_uart_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        arm_primecell_uart_disable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        arm_primecell_uart_disable_rcv(p_siopcb);
        break;
    }
}

/*
 *  ꥢI/OݡȤФ߽
 */
static void
arm_primecell_uart_isr_siop(SIOPCB *p_siopcb)
{
    if (arm_primecell_uart_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        arm_primecell_uart_irdy_rcv(p_siopcb->exinf);
    }
    if (arm_primecell_uart_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        arm_primecell_uart_irdy_snd(p_siopcb->exinf);
    }
}

/*
 *  SIOγߥӥ롼
 */
void
arm_primecell_uart_isr(intptr_t exinf)
{
    arm_primecell_uart_isr_siop(get_siopcb(exinf));
}

/*
 *  SIOPCBؤΥݥ󥿤ݡֹ֤
 */
ID
arm_primecell_uart_get_siopid(SIOPCB *p_siopcb)
{
	return (ID)((p_siopcb - siopcb_table) + 1);
}

/*
 *  ֹ֤
 */
uint8_t
arm_primecell_uart_get_intno(SIOPCB *p_siopcb)
{
	return p_siopcb->siopinib->intno;
}
