/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh_scif.c 558 2010-04-02 15:00:35Z ertl-honda $
 */


/*
 *   SH SCIF ʰSIOɥ饤
 */

#include <sil.h>
#include "target_syssvc.h"
#include "sh_scif.h"

/*
 * SH SCIFΥ쥸
 */

/*
 * ƥ쥸Υեå
 */
#define SCIF_SCSMR   0x0000U  /* H */
#define SCIF_SCBRR   0x0004U  /* B */
#define SCIF_SCSCR   0x0008U  /* H */
#define SCIF_SCFTDR  0x000cU  /* B */
#define SCIF_SCFSR   0x0010U  /* H */
#define SCIF_SCFRDR  0x0014U  /* B */
#define SCIF_SCFCR   0x0018U  /* H */
#define SCIF_SCFDR   0x001cU  /* H */
#define SCIF_SCSPTR  0x0024U  /* H */

/*
 * ƥ쥸
 */
#define SCSMR_CHR    0x0040U
#define SCSMR_PE     0x0020U
#define SCSMR_OE     0x0010U
#define SCSMR_STOP   0x0008U
#define SCSMR_CKS1   0x0002U
#define SCSMR_CKS0   0x0001U

#define SCSCR_TIE    0x0080U
#define SCSCR_RIE    0x0040U
#define SCSCR_TE     0x0020U
#define SCSCR_RE     0x0010U
#define SCSCR_CKE1   0x0002U
#define SCSCR_CKE0   0x0001U

#define SCFSR_ER     0x0080U
#define SCFSR_TEND   0x0040U
#define SCFSR_TDFE   0x0020U
#define SCFSR_BRK    0x0010U
#define SCFSR_FER    0x0008U
#define SCFSR_PER    0x0004U
#define SCFSR_RDF    0x0002U
#define SCFSR_DR     0x0001U

#define SCFCR_RTRG1  0x0080U
#define SCFCR_RTRG0  0x0040U
#define SCFCR_TTRG1  0x0020U
#define SCFCR_TTRG0  0x0010U
#define SCFCR_MCE    0x0008U
#define SCFCR_TFRST  0x0004U
#define SCFCR_RFRST  0x0002U
#define SCFCR_LOOP   0x0001U

#define SCSPTR_RTSIO  0x0080U
#define SCSPTR_RTSDT  0x0040U
#define SCSPTR_CTSIO  0x0020U
#define SCSPTR_CTSDT  0x0010U
#define SCSPTR_SPB2IO 0x0002U
#define SCSPTR_SPB2DT 0x0001U

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
	void  *scsmr_h;   /* ꥢ⡼ɥ쥸 */
	void  *scbrr_b;   /* ӥåȥ졼ȥ쥸 */
	void  *scscr_h;   /* ꥢ륳ȥ쥸 */
	void  *scftdr_b;  /* ȥ󥹥ߥåFIFOǡ쥸 */
	void  *scfsr_h;   /* ꥢ륹ơ쥸 */
	void  *scfrdr_b;  /* 쥷FIFOǡ쥸 */
	void  *scfcr_h;   /* FIFOȥ쥸 */
	void  *scfdr_h;   /* 쥷FIFOǡ쥸 */
	void  *scsptr_h;  /* ꥢݡȥ쥸 */
	uint32_t bps_setting; /* ܡ졼Ȥ */
	uint32_t cke_setting; /* å */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
	const SIOPINIB  *siopinib;  /* ꥢI/OݡȽ֥å */
	intptr_t  exinf;            /* ĥ */
	bool_t    openflag;         /* ץѤߥե饰 */
	bool_t    sendflag;         /* ߥ֥͡ե饰 */
	bool_t    getready;         /* ʸ */
	bool_t    putready;         /* ʸǤ */
	bool_t    is_initialized;   /* ǥХѤߥե饰 */
};

/*
 *  ꥢI/OݡȽ֥å
 */
static const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{
		(void *)(SH_SCIF0_BASE + SCIF_SCSMR),
		(void *)(SH_SCIF0_BASE + SCIF_SCBRR),
		(void *)(SH_SCIF0_BASE + SCIF_SCSCR),
		(void *)(SH_SCIF0_BASE + SCIF_SCFTDR),
		(void *)(SH_SCIF0_BASE + SCIF_SCFSR),
		(void *)(SH_SCIF0_BASE + SCIF_SCFRDR),
		(void *)(SH_SCIF0_BASE + SCIF_SCFCR),
		(void *)(SH_SCIF0_BASE + SCIF_SCFDR),
		(void *)(SH_SCIF0_BASE + SCIF_SCSPTR),
		SCIF0_BPS_SETTING,
		SCIF0_CKE_SETTING
	},
#if TNUM_SIOP >= 2
	{        
		(void *)(SH_SCIF1_BASE + SCIF_SCSMR),
		(void *)(SH_SCIF1_BASE + SCIF_SCBRR),
		(void *)(SH_SCIF1_BASE + SCIF_SCSCR),
		(void *)(SH_SCIF1_BASE + SCIF_SCFTDR),
		(void *)(SH_SCIF1_BASE + SCIF_SCFSR),
		(void *)(SH_SCIF1_BASE + SCIF_SCFRDR),
		(void *)(SH_SCIF1_BASE + SCIF_SCFCR),
		(void *)(SH_SCIF1_BASE + SCIF_SCFDR),
		(void *)(SH_SCIF1_BASE + SCIF_SCSPTR),
		SCIF1_BPS_SETTING,
		SCIF1_CKE_SETTING
	},
#endif /* TNUM_SIOP >= 2 */
#if TNUM_SIOP >= 3
	{
		(void *)(SH_SCIF2_BASE + SCIF_SCSMR),
		(void *)(SH_SCIF2_BASE + SCIF_SCBRR),
		(void *)(SH_SCIF2_BASE + SCIF_SCSCR),
		(void *)(SH_SCIF2_BASE + SCIF_SCFTDR),
		(void *)(SH_SCIF2_BASE + SCIF_SCFSR),
		(void *)(SH_SCIF2_BASE + SCIF_SCFRDR),
		(void *)(SH_SCIF2_BASE + SCIF_SCFCR),
		(void *)(SH_SCIF2_BASE + SCIF_SCFDR),
		(void *)(SH_SCIF2_BASE + SCIF_SCSPTR),
		SCIF2_BPS_SETTING,
		SCIF2_CKE_SETTING
	},
#endif /* TNUM_SIOP >= 3 */
#if TNUM_SIOP >= 4
	{
		(void *)(SH_SCIF3_BASE + SCIF_SCSMR),
		(void *)(SH_SCIF3_BASE + SCIF_SCBRR),
		(void *)(SH_SCIF3_BASE + SCIF_SCSCR),
		(void *)(SH_SCIF3_BASE + SCIF_SCFTDR),
		(void *)(SH_SCIF3_BASE + SCIF_SCFSR),
		(void *)(SH_SCIF3_BASE + SCIF_SCFRDR),
		(void *)(SH_SCIF3_BASE + SCIF_SCFCR),
		(void *)(SH_SCIF3_BASE + SCIF_SCFDR),
		(void *)(SH_SCIF3_BASE + SCIF_SCSPTR),
		SCIF3_BPS_SETTING,
		SCIF3_CKE_SETTING
	}
#endif /* TNUM_SIOP >= 4 */
};


/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
static SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)	 ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)	 (&(siopcb_table[INDEX_SIOP(siopid)]))
#define get_siopinib(siopid) (&(siopinib_table[INDEX_SIOP(siopid)]))

/*
 *  ֥åؤΥݥ󥿤饷ꥢI/OݡIDФΥޥ
 */
#define SIOPID(p_siopcb)	((ID)(p_siopcb - siopcb_table))

/*
 *  ʸ
 */
Inline bool_t
sh_scif_getready(SIOPCB *p_siopcb)
{
	return((sil_reh_mem(p_siopcb->siopinib->scfsr_h) & SCFSR_RDF) != 0);
}

/*
 *  ʸǤ뤫
 */
Inline bool_t
sh_scif_putready(SIOPCB *p_siopcb)
{
	return((sil_reh_mem(p_siopcb->siopinib->scfsr_h) & SCFSR_TDFE) != 0);
}

/*
 *  ʸμФ
 */
Inline char_t
sh_scif_getchar(SIOPCB *p_siopcb)
{
	uint8_t c;
	c = sil_reb_mem(p_siopcb->siopinib->scfrdr_b);
	sil_wrh_mem(p_siopcb->siopinib->scfsr_h,
                (sil_reh_mem(p_siopcb->siopinib->scfsr_h) & ~SCFSR_RDF));
	return(c);
}

/*
 *  ʸν
 */
Inline void
sh_scif_putchar(SIOPCB *p_siopcb, char_t c)
{
	sil_wrb_mem(p_siopcb->siopinib->scftdr_b, c);
	sil_wrh_mem(p_siopcb->siopinib->scfsr_h,
                (sil_reh_mem(p_siopcb->siopinib->scfsr_h) & ~(SCFSR_TDFE)));
}

/*
 *  ߵ
 */
Inline void
sh_scif_enable_send(SIOPCB *p_siopcb)
{
	sil_wrh_mem(p_siopcb->siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->siopinib->scscr_h) | SCSCR_TIE));
}

/*
 *  ߶ػ
 */
Inline void
sh_scif_disable_send(SIOPCB *p_siopcb)
{
	sil_wrh_mem(p_siopcb->siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->siopinib->scscr_h) & ~SCSCR_TIE));
}


/*
 *  ߵ
 */
Inline void
sh_scif_enable_rcv(SIOPCB *p_siopcb)
{
	sil_wrh_mem(p_siopcb->siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->siopinib->scscr_h) | SCSCR_RIE));    
}

/*
 *  ߶ػ
 */
Inline void
sh_scif_disable_rcv(SIOPCB *p_siopcb)
{
	sil_wrh_mem(p_siopcb->siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->siopinib->scscr_h) & ~SCSCR_RIE));    
}

/*
 *  SIOɥ饤Фν
 */
void
sh_scif_initialize(void)
{
	SIOPCB	*p_siopcb;
	uint_t	i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
		p_siopcb->siopinib = &(siopinib_table[i]);
		p_siopcb->openflag = false;
		p_siopcb->sendflag = false;
	}
}

/*
 *  ϡɥν
 */
void
sh_scif_init_siopinib(const SIOPINIB *p_siopinib)
{
	/* UART */
	sil_wrh_mem(p_siopinib->scscr_h, 0x00U); /* TE=0, RE=0, CKE1=0 */

	/* FIFO򥯥ꥢ */   
	sil_wrh_mem(p_siopinib->scfcr_h, (SCFCR_TFRST|SCFCR_RFRST));

	/* CHR=0, PE=0, STOP=0, CKS=00 */
	/* 8-bit, non-parity, 1 stop bit, pf/1 clock */
	sil_wrh_mem(p_siopinib->scsmr_h, 0x0000U);

	/* ^RTS2 ˽ */
	sil_wrh_mem(p_siopinib->scsptr_h, SCSPTR_RTSIO);
   
	/* ܡ졼Ȥ */
	sil_wrb_mem(p_siopinib->scbrr_b, p_siopinib->bps_setting);

	/*
	 *  1ӥåʬԤɬפ
	 */
	sil_dly_nse(SIO_INIT_DLY);
    
	/* ơΥꥢ */
	sil_wrh_mem(p_siopinib->scfsr_h,
                sil_rew_mem(p_siopinib->scfsr_h) & ~(SCFSR_TEND|SCFSR_TDFE));
    
	/* ȥꥬ R-FIFO=1,T-FIFO=1 */
	sil_wrh_mem(p_siopinib->scfcr_h, (SCFCR_TTRG1|SCFCR_TTRG0));

	/* UART */
	sil_wrh_mem(p_siopinib->scscr_h, (SCSCR_TE|SCSCR_RE|p_siopinib->cke_setting));
}

/*
 *  ͥ뵯ưΥСʽѤν
 */
void
sh_scif_init(ID siopid)
{
	SIOPCB          *p_siopcb   = get_siopcb(siopid);
	const SIOPINIB  *p_siopinib = get_siopinib(siopid);
	/*  λǤϡp_siopcb->p_siopinibϽƤʤ  */
    
	/*  Žɻ  */
	p_siopcb->is_initialized = true;

	/*  ϡɥν  */
	sh_scif_init_siopinib(p_siopinib);
}

/*
 *  ݡnץѤߤʥݡID
 */
bool_t
sh_scif_openflag_id(ID siopid)
{
	return(get_siopcb(siopid)->openflag);
}

/*
 *  ݡnץѤߤ
 *  ʡ֥ꥢI/Oݡȴ֥åפƬϤ
 */
bool_t
sh_scif_openflag_cb(SIOPCB *p_siopcb)
{
	return(p_siopcb->openflag);
}

/*
 *  ݡIDμ
 */
ID
sh_scif_get_siopid(SIOPCB *p_siopcb)
{
	return(SIOPID(p_siopcb));
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sh_scif_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB          *p_siopcb;
	const SIOPINIB  *p_siopinib;
      
	p_siopcb = get_siopcb(siopid);
	p_siopinib = p_siopcb->siopinib;

	/*
	 * ϡɥν     
	 * ˽ƤϡŤ˽ʤ
	 */
	if (!(p_siopcb->is_initialized)) {
		sh_scif_init_siopinib(p_siopinib);
		p_siopcb->is_initialized = true;
	}
        
	p_siopcb->exinf = exinf;
	p_siopcb->getready = p_siopcb->putready = false;
	p_siopcb->openflag = true;

	return(p_siopcb);   
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sh_scif_cls_por(SIOPCB *p_siopcb)
{
	/*
	* UART
	*/
	sil_wrh_mem(p_siopcb->siopinib->scscr_h, 0x00);
	p_siopcb->openflag = false;
}


/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
void
sh_scif_pol_putc(char_t c, ID siopid)
{
	const SIOPINIB *p_siopinib;
    
	p_siopinib = get_siopinib(siopid);
    
	while((sil_reh_mem(p_siopinib->scfsr_h) & SCFSR_TDFE) == 0);
    
	sil_wrb_mem(p_siopinib->scftdr_b, c);
	sil_wrh_mem(p_siopinib->scfsr_h,
                (sil_reh_mem(p_siopinib->scfsr_h) & ~(SCFSR_TDFE)));
    
}


/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sh_scif_snd_chr(SIOPCB *p_siopcb, char_t c)
{
	if (sh_scif_putready(p_siopcb)){
		sh_scif_putchar(p_siopcb, c);
		return(true);
	}
	return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sh_scif_rcv_chr(SIOPCB *p_siopcb)
{
	if (sh_scif_getready(p_siopcb)) {
		return((int_t)(uint8_t) sh_scif_getchar(p_siopcb));
	}
	return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sh_scif_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		sh_scif_enable_send(p_siopcb);
		break;
	case SIO_RDY_RCV:
		sh_scif_enable_rcv(p_siopcb);
	break;
	}
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sh_scif_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		sh_scif_disable_send(p_siopcb);
		break;
	case SIO_RDY_RCV:
		sh_scif_disable_rcv(p_siopcb);
	break;
	}
}

/*
 *  SIOγߥӥ롼
 */
void
sh_scif_tx_isr(ID siopid)
{
	SIOPCB	*p_siopcb = get_siopcb(siopid);

	if (sh_scif_putready(p_siopcb)) {
		/*
		 *  ǽХå롼ƤӽФ
		 */
		sh_scif_irdy_snd(p_siopcb->exinf);
	}
}

/*
 *  SIOγߥӥ롼
 */
void
sh_scif_rx_isr(ID siopid)
{
	SIOPCB	*p_siopcb = get_siopcb(siopid);

	if (sh_scif_getready(p_siopcb)) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		sh_scif_irdy_rcv(p_siopcb->exinf);
	}
}
