/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: syslog.c 592 2010-05-07 01:39:37Z ertl-honda $
 */

/*
 *		ƥǽ
 */

#include <kernel.h>
#include <sil.h>
#undef TOPPERS_OMIT_SYSLOG
#include <t_syslog.h>
#include <log_output.h>
#include "target_syssvc.h"
#include "syslog.h"
#include "kernel_cfg.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_SYSLOG_WRI_LOG_ENTER
#define LOG_SYSLOG_WRI_LOG_ENTER(prio, p_syslog)
#endif /* LOG_SYSLOG_WRI_LOG_ENTER */

#ifndef LOG_SYSLOG_WRI_LOG_LEAVE
#define LOG_SYSLOG_WRI_LOG_LEAVE(ercd)
#endif /* LOG_SYSLOG_WRI_LOG_LEAVE */

#ifndef LOG_SYSLOG_REA_LOG_ENTER
#define LOG_SYSLOG_REA_LOG_ENTER(p_syslog)
#endif /* LOG_SYSLOG_REA_LOG_ENTER */

#ifndef LOG_SYSLOG_REA_LOG_LEAVE
#define LOG_SYSLOG_REA_LOG_LEAVE(ercd, p_syslog)
#endif /* LOG_SYSLOG_REA_LOG_LEAVE */

#ifndef LOG_SYSLOG_MSK_LOG_ENTER
#define LOG_SYSLOG_MSK_LOG_ENTER(logmask, lowmask)
#endif /* LOG_SYSLOG_MSK_LOG_ENTER */

#ifndef LOG_SYSLOG_MSK_LOG_LEAVE
#define LOG_SYSLOG_MSK_LOG_LEAVE(ercd)
#endif /* LOG_SYSLOG_MSK_LOG_LEAVE */

#ifndef LOG_SYSLOG_REF_LOG_ENTER
#define LOG_SYSLOG_REF_LOG_ENTER(pk_rlog)
#endif /* LOG_SYSLOG_REF_LOG_ENTER */

#ifndef LOG_SYSLOG_REF_LOG_LEAVE
#define LOG_SYSLOG_REF_LOG_LEAVE(pk_rlog)
#endif /* LOG_SYSLOG_REF_LOG_LEAVE */

/*
 *  ƥǽѿ֤Υǥե
 */
#ifndef SEC_SYSLOG
#define SEC_SYSLOG(type, variable) type variable
#endif /* SEC_SYSLOG */

#ifndef SEC_SYSLOG_BEGIN
#define SEC_SYSLOG_BEGIN
#endif /* SEC_SYSLOG_BEGIN */

#ifndef SEC_SYSLOG_END
#define SEC_SYSLOG_END
#endif /* SEC_SYSLOG_END */

#ifndef SEC_PRC1_SYSLOG
#define SEC_PRC1_SYSLOG(type, variable) type variable
#endif /* SEC_PRC1_SYSLOG */

#ifndef SEC_PRC1_SYSLOG_BEGIN
#define SEC_PRC1_SYSLOG_BEGIN
#endif /* SEC_PRC1_SYSLOG_BEGIN */

#ifndef SEC_PRC1_SYSLOG_END
#define SEC_PRC1_SYSLOG_END
#endif /* SEC_PRC1_SYSLOG_END */

#ifndef SEC_PRC2_SYSLOG
#define SEC_PRC2_SYSLOG(type, variable) type variable
#endif /* SEC_PRC2_SYSLOG */

#ifndef SEC_PRC2_SYSLOG_BEGIN
#define SEC_PRC2_SYSLOG_BEGIN
#endif /* SEC_PRC2_SYSLOG_BEGIN */

#ifndef SEC_PRC2_SYSLOG_END
#define SEC_PRC2_SYSLOG_END
#endif /* SEC_PRC2_SYSLOG_END */

#ifndef SEC_PRC3_SYSLOG
#define SEC_PRC3_SYSLOG(type, variable) type variable
#endif /* SEC_PRC3_SYSLOG */

#ifndef SEC_PRC3_SYSLOG_BEGIN
#define SEC_PRC3_SYSLOG_BEGIN
#endif /* SEC_PRC3_SYSLOG_BEGIN */

#ifndef SEC_PRC3_SYSLOG_END
#define SEC_PRC3_SYSLOG_END
#endif /* SEC_PRC3_SYSLOG_END */

#ifndef SEC_PRC4_SYSLOG
#define SEC_PRC4_SYSLOG(type, variable) type variable
#endif /* SEC_PRC4_SYSLOG */

#ifndef SEC_PRC4_SYSLOG_BEGIN
#define SEC_PRC4_SYSLOG_BEGIN
#endif /* SEC_PRC4_SYSLOG_BEGIN */

#ifndef SEC_PRC4_SYSLOG_END
#define SEC_PRC4_SYSLOG_END
#endif /* SEC_PRC4_SYSLOG_END */

/*
 *  ƥȥ֥å
 */
typedef struct syslog_control_block{
	SYSLOG	syslog_buffer[TCNT_SYSLOG_BUFFER];	/* Хåե */
	uint_t	syslog_count;		/* ХåեΥο */
	uint_t	syslog_head;		/* ƬΥγǼ */
	uint_t	syslog_tail;		/* ΥγǼ */
	uint_t	syslog_lost;		/* 줿ο */
	uint_t	syslog_logmask;		/* Хåե˵Ͽ٤ */    
	uint_t	syslog_lowmask;		/* ٥Ϥ٤ */    
}SYSLOGCB;

#ifdef G_SYSLOG

SEC_SYSLOG_BEGIN
SEC_SYSLOG(SYSLOGCB, syslogcb);
SEC_SYSLOG_END

#else /* G_SYSLOG */

#if TNUM_PRCID >= 1
SEC_PRC1_SYSLOG_BEGIN
SEC_PRC1_SYSLOG(SYSLOGCB, prc1_syslogcb);
SEC_PRC1_SYSLOG_END
#endif /* TNUM_PRCID >= 1 */

#if TNUM_PRCID >= 2
SEC_PRC2_SYSLOG_BEGIN
SEC_PRC2_SYSLOG(SYSLOGCB, prc2_syslogcb);
SEC_PRC2_SYSLOG_END
#endif /* TNUM_PRCID >= 2 */

#if TNUM_PRCID >= 3
SEC_PRC3_SYSLOG_BEGIN
SEC_PRC3_SYSLOG(SYSLOGCB, prc3_syslogcb);
SEC_PRC3_SYSLOG_END
#endif /* TNUM_PRCID >= 3 */

#if TNUM_PRCID >= 4
SEC_PRC4_SYSLOG_BEGIN
SEC_PRC4_SYSLOG(SYSLOGCB, prc4_syslogcb);
SEC_PRC4_SYSLOG_END
#endif /* TNUM_PRCID >= 4 */

#if TNUM_PRCID >= 5
#error Syslog Not Support more than 5 processor!
#endif /* TNUM_PRCID >= 5 */

static SYSLOGCB* const p_syslogcb_table[TNUM_PRCID] = {
#if TNUM_PRCID >= 1
	&prc1_syslogcb,
#endif /* TNUM_PRCID >= 1 */

#if TNUM_PRCID >= 2
	&prc2_syslogcb,
#endif /* TNUM_PRCID >= 2 */

#if TNUM_PRCID >= 3
	&prc3_syslogcb,
#endif /* TNUM_PRCID >= 3 */

#if TNUM_PRCID >= 4
	&prc4_syslogcb
#endif /* TNUM_PRCID >= 4 */
};

#endif /* G_SYSLOG */


#ifdef G_SYSLOG

/*
 *  ƥȥ֥åؤΥ
 */

Inline SYSLOGCB*
get_p_syslogcb(void){
	return (&syslogcb);
}

#else /* G_SYSLOG */

Inline SYSLOGCB*
get_p_syslogcb(void){
	ID prcid;

	sil_get_pid(&prcid);

	return p_syslogcb_table[prcid - 1];
}

#endif /* G_SYSLOG */

/*
 *  ƥǽν
 */
void
syslog_initialize(intptr_t exinf)
{
	SYSLOGCB *p_syslogcb = get_p_syslogcb();

	p_syslogcb->syslog_count = 0U;
	p_syslogcb->syslog_head = p_syslogcb->syslog_tail = 0U;
	p_syslogcb->syslog_lost = 0U;
    
	p_syslogcb->syslog_logmask = 0U;
	p_syslogcb->syslog_lowmask = LOG_UPTO(LOG_NOTICE);
}     

/*
 *  ߤΥƥ
 *
 *  Фˡʤͥѿ򻲾ȤƤ
 *  롥
 */
extern ulong_t _kernel_get_my_current_time(void);

/* 
 *  ν
 *
 *  CPUå֤¹ԥƥȤˤ餺ưǤ褦˼Ƥ롥
 *  ХξϡSILΥԥå˸ƤӽФ
 *  ưݾڤʤ
 */
ER
syslog_wri_log(uint_t prio, const SYSLOG *p_syslog)
{
	SYSLOGCB *p_syslogcb;

	SIL_PRE_LOC;

	LOG_SYSLOG_WRI_LOG_ENTER(prio, p_syslog);

#ifdef G_SYSLOG
	SIL_LOC_SPN();
#else
	SIL_LOC_INT();
#endif /* G_SYSLOG */

	/*
	 * ޥ졼бΤᡤå˼
	 */
	p_syslogcb = get_p_syslogcb();

	/*
	 *  
	 */
	((SYSLOG *) p_syslog)->logtim = _kernel_get_my_current_time();

	/*
	 *  ץåID
	 */
	sil_get_pid(&(((SYSLOG *) p_syslog)->prcid));

	/*
	 *  Хåե˵Ͽ
	 */
	if ((p_syslogcb->syslog_logmask & LOG_MASK(prio)) != 0U) {
		p_syslogcb->syslog_buffer[p_syslogcb->syslog_tail] = *p_syslog;
		(p_syslogcb->syslog_tail)++;
		if (p_syslogcb->syslog_tail >= TCNT_SYSLOG_BUFFER) {
			p_syslogcb->syslog_tail = 0U;
		}
		if (p_syslogcb->syslog_count < TCNT_SYSLOG_BUFFER) {
			p_syslogcb->syslog_count++;
		}
		else {
			p_syslogcb->syslog_head = p_syslogcb->syslog_tail;
			(p_syslogcb->syslog_lost)++;
		}
	}

	/*
	 *  ٥
	 */
	if ((p_syslogcb->syslog_lowmask & LOG_MASK(prio)) != 0U) {
		syslog_print(p_syslog, target_fput_log);
		(*target_fput_log)('\n');
	}

#ifdef G_SYSLOG
	SIL_UNL_SPN();
#else
	SIL_UNL_INT();
#endif /* G_SYSLOG */

	LOG_SYSLOG_WRI_LOG_LEAVE(E_OK);
	return(E_OK);
}

/*
 *  ХåեɽФ
 *
 *  CPUå֤¹ԥƥȤˤ餺ưǤ褦˼Ƥ롥
 *  ХξϡSILΥԥå˸ƤӽФ
 *  ưݾڤʤ
 */
ER_UINT
syslog_rea_log(SYSLOG *p_syslog)
{
	ER_UINT	ercd;
	SYSLOGCB *p_syslogcb;

	SIL_PRE_LOC;

	LOG_SYSLOG_REA_LOG_ENTER(p_syslog);

#ifdef G_SYSLOG
	SIL_LOC_SPN();
#else
	SIL_LOC_INT();
#endif /* G_SYSLOG */

	/*
	 * ޥ졼бΤᡤå˼
	 */
	p_syslogcb = get_p_syslogcb();

	/*
	 *  ХåեμФ
	 */
	if (p_syslogcb->syslog_count > 0U) {
		*p_syslog = p_syslogcb->syslog_buffer[p_syslogcb->syslog_head];
		(p_syslogcb->syslog_count)--;
		(p_syslogcb->syslog_head)++;
		if (p_syslogcb->syslog_head >= TCNT_SYSLOG_BUFFER) {
			p_syslogcb->syslog_head = 0U;
		}
		ercd = (ER_UINT) (p_syslogcb->syslog_lost);
		p_syslogcb->syslog_lost = 0U;
	}
	else {
		ercd = E_OBJ;
	}

#ifdef G_SYSLOG
	SIL_UNL_SPN();
#else
	SIL_UNL_INT();
#endif /* G_SYSLOG */

	LOG_SYSLOG_REA_LOG_LEAVE(ercd, p_syslog);
	return(ercd);
}

/* 
 *  Ϥ٤ν٤
 *
 *  CPUå֤¹ԥƥȤˤ餺ưǤ褦˼Ƥ롥
 *  ХξϡSILΥԥå˸ƤӽФ
 *  ưݾڤʤ
 */
ER
syslog_msk_log(uint_t logmask, uint_t lowmask)
{
	SYSLOGCB *p_syslogcb;

	SIL_PRE_LOC;

	LOG_SYSLOG_MSK_LOG_ENTER(logmask, lowmask);

#ifdef G_SYSLOG
	SIL_LOC_SPN();
#else
	SIL_LOC_INT();
#endif /* G_SYSLOG */

	/*
	 * ޥ졼бΤᡤå˼
	 */
	p_syslogcb = get_p_syslogcb();

	p_syslogcb->syslog_logmask = logmask;
	p_syslogcb->syslog_lowmask = lowmask;

#ifdef G_SYSLOG
	SIL_UNL_SPN();
#else
	SIL_UNL_INT();
#endif /* G_SYSLOG */

	LOG_SYSLOG_MSK_LOG_LEAVE(E_OK);

	return(E_OK);
}

/*
 *  Хåեξֻ
 *
 *  CPUå֤¹ԥƥȤˤ餺ưǤ褦˼Ƥ롥
 *  ХξϡSILΥԥå˸ƤӽФ
 *  ưݾڤʤ
 */
ER_UINT
syslog_ref_log(T_SYSLOG_RLOG *pk_rlog)
{
	SYSLOGCB *p_syslogcb;

	SIL_PRE_LOC;

	LOG_SYSLOG_REF_LOG_ENTER(pk_rlog);

#ifdef G_SYSLOG
	SIL_LOC_SPN();
#else
	SIL_LOC_INT();
#endif /* G_SYSLOG */

	/*
	 * ޥ졼бΤᡤå˼
	 */
	p_syslogcb = get_p_syslogcb();

	pk_rlog->count = p_syslogcb->syslog_count;
	pk_rlog->lost = p_syslogcb->syslog_lost;
	pk_rlog->logmask = p_syslogcb->syslog_logmask;
	pk_rlog->lowmask = p_syslogcb->syslog_lowmask;

#ifdef G_SYSLOG
	SIL_UNL_SPN();
#else
	SIL_UNL_INT();
#endif /* G_SYSLOG */

	LOG_SYSLOG_REF_LOG_LEAVE(pk_rlog);
	return(E_OK);
}
