/*
 *	TOPPERS/FMP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2009-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *	åȰ¸⥸塼APSH2ADѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic/sh/sh_scif.h"
#include "apsh2ad.h"
#include "target_syssvc.h"		/*  TNUM_PORT  */

/*
 *  str_ker() μ¹˥ޥץåΤ߼¹Ԥ
 */
void
target_mprc_initialize(void)
{
	prc_mprc_initialize();

	/*
	 *	ϥ⡼ɤ
	 */
		/*
		 *	CPU0sleep̿μ¹ԤǡCPU0꡼ץ⡼ɤ
		 *	꡼ץ顼ػ
		 *	ǥѿ徽ȯҤ̵
		 */
	sil_wrb_mem((void *)STBCR1, STBCR1_AXTALE);

		/*
		 *	H-UDIư
		 *	FPU0,FPU1ư
		 *	UBC0,UBC1ư
		 *	
		 *	
		 *	JTAGߥ졼Ѥϡ
		 *	H-UDIFPUUBCߤƤϤʤ
		 */
	sil_wrb_mem((void *)STBCR2, 0x00U);

		/*
		 *	ATAPI
		 *	MTU2
		 *	ADC
		 *	DAC
		 *	RTC
		 */
	sil_wrb_mem((void *)STBCR3, 0xffU);

		/*
		 *	SCFI0ư
		 *	SCFI1ư
		 *	SCFI2
		 *	SCFI3
		 *	SCFI4
		 *	SCFI5
		 */
	sil_wrb_mem((void *)STBCR4, (uint8_t)~(STBCR4_SCIF0 | STBCR4_SCIF1));

		/*
		 *	IIC3_0
		 *	IIC3_1
		 *	IIC3_2
		 *	IIC3_3
		 *	RCAN0
		 *	RCAN1
		 */
	sil_wrb_mem((void *)STBCR5, 0xffU);

		/*
		 *	SSIF0
		 *	SSIF1
		 *	SSIF2
		 *	SSIF3
		 *	SSIF4
		 *	SSIF5
		 */
	sil_wrb_mem((void *)STBCR6, 0xffU);

		/*
		 *	CMT01ư
		 *	CMT23
		 *	FLCTL
		 *	SSU0
		 *	SSU1
		 *	2DG
		 *	USB
		 */
	sil_wrb_mem((void *)STBCR7, (uint8_t)~STBCR7_CMT01);

	/*
	 *	SCIFI/OݡȤ	 ׸Ƥ:PE4/SCK0üҤɬס
	 */
	sil_wrh_mem((void *)PECRL1, 0x1111U);/* SCIF0:RTS0 CTS0 TxD0 RxD0 */
#if TNUM_PORT > 1
	sil_wrh_mem((void *)PECRL2, 0x0110U);/* SCIF1:TxD1 RxD1 */
#endif /* TNUM_PORT > 1 */
	
	/*
	 * СʡѤΥꥢ륳ȥν
	 */
	sh_scif_init(1);
#if TNUM_PORT > 1
	sh_scif_init(2);
#endif /* TNUM_PORT > 1 */
}

/*
 *	åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *	ץå¸ν
	 */
	prc_initialize();
}

/*
 *	åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *	ץå¸νλ
	 */
	prc_exit();

	/*
	 *	ȯĶ¸νλ
	 */
	apsh2ad_exit();

	/*
	 * ˤʤ
	 */
	while(1);
}

/*
 *	ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
#if TNUM_PORT == 1
	ID siopid = TARGET_PUTC_PORTID;
#else	/* TNUM_PORT == 1 */
	ID siopid = sil_get_pindex() + 1;
#endif	/* TNUM_PORT == 1 */

	if (c == '\n') {
		sh_scif_pol_putc('\r', siopid);
	}
	sh_scif_pol_putc(c, siopid);
}


/*
 *	μԻμ¹ǽT.B.D
 */
void
TOPPERS_assert_abort(void)
{
	uint_t index = sil_get_pindex();
	
	syslog(LOG_EMERG, "prcindex = %d" ,index);
	while(1);
}

