#include "kernel_impl.h"
#include <sil.h>
#include "target_test.h"

#define AIC_ISET (0xfffff12C)

/*
 *  ƥåѥޥǥ֥ѿ
 */
static volatile bool_t target_timer_disable[TNUM_PRCID];

/*
 *  ƥåѥޥ󥷥åȼ¹
 */
static volatile bool_t target_timer_oneshot[TNUM_PRCID];

/*
 *  ޥϥɥ鳫ϻ˸ƤӽФեå
 *  (falsesignal_time()ƤӽФʤ)
 */
bool_t
ttsp_timer_handler_begin_hook(void){
	return !target_timer_disable[x_prc_index()];
}

/*
 *  ޥϥɥ齪λ˸ƤӽФեå
 */
void
ttsp_timer_handler_end_hook(void){
	uint_t prc_index = x_prc_index();
	if (target_timer_oneshot[prc_index]) {
		target_timer_disable[prc_index] = true;
		target_timer_oneshot[prc_index] = false;
	}
}

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick(void)
{
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_stop_tick_pe(i);
	}
}

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick_pe(ID prcid)
{
	uint_t prc_index = prcid - 1;
	target_timer_disable[prc_index] = true;
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick(void)
{
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_start_tick_pe(i);
	}
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick_pe(ID prcid)
{
	uint_t prc_index = prcid - 1;
	target_timer_disable[prc_index] = false;
}

/*
 *  ƥåιץå
 */
void
ttsp_target_gain_tick_pe(ID prcid)
{
	int prc_index = prcid - 1;
	ID pid;

	/*
	 *  ιäƤ뤳Ȥǧ
	 *  PEФƤϥåɬפϤʤåƤʤᡤ
	 *  å롥 
	 */
	while(target_timer_oneshot[prc_index] == true);

	target_timer_oneshot[prc_index] = true;
	target_timer_disable[prc_index] = false;

	/* PEФƤϡϥɥ餬λޤԤ碌 */
	sil_get_pid(&pid);
	if (pid == prcid) {
		while(target_timer_oneshot[prc_index] == true);
	}
}

/*
 *  ƥåιץå
 */
void
ttsp_target_gain_tick(void)
{
	uint_t i;
	ID pid;

	/*
	 *  ιäƤ뤳Ȥǧ
	 *  PEФƤϥåɬפϤʤåƤʤᡤ
	 *  å롥 
	 */
	for(i = 0; i < TNUM_PRCID; i++) {
		while(target_timer_oneshot[i] == true);
	}

	for(i = 0; i < TNUM_PRCID; i++) {
		target_timer_oneshot[i] = true;
	}

	for(i = 0; i < TNUM_PRCID; i++) {
		target_timer_disable[i] = false;
	}

	/* PEФƤϡϥɥ餬λޤԤ碌 */
	sil_get_pid(&pid);
	while(target_timer_oneshot[pid-1] == true);
}

/*
 *  ƥåѥ޳׵ȯʼץå
 */ 
void
ttsp_target_raise_tick_int(void)
{
	sil_wrw_mem((void *)AIC_ISET, (1 << IRQ_TC1));
}

/*
 *  ͥٳߤȯ   
 */
void
ttsp_highpri_int_raise(void)
{
	sil_wrw_mem((void *)AIC_ISET, (1 << TTSP_INTNO_HIGHPRI_INT));
}

/*
 *  ͥٳߤȯ   
 */
void
ttsp_midpri_int_raise(void)
{
	sil_wrw_mem((void *)AIC_ISET, (1 << TTSP_INTNO_MIDPRI_INT));
}

/*
 *  ͥٳߤȯ   
 */
void
ttsp_lowpri_int_raise(void)
{
	sil_wrw_mem((void *)AIC_ISET, (1 << TTSP_INTNO_LOWPRI_INT));
}

/*
 *  CPU㳰ȯ
 */
void
ttsp_cpuexc_raise(void)
{
	Asm("svc #0");
}
