/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: ct11mpcore.c 447 2009-10-16 08:51:47Z ertl-honda $
 */

#include "kernel_impl.h"
#include "pdic/arm_primecell_uart/arm_primecell_uart.h"

/*
 * GIC CPU󥿥եϢ
 */

/*
 * CPU󥿥եν
 */
void
gic_cpu_init(void)
{
	/* ͥ٤ */
	gic_cpu_set_priority(0xf);
    
	/* CPU󥿥եͭ */
	sil_wrw_mem((void *)(GIC_BASE + GIC_CPUIF_CCR), 1);
}

/*
 * CPU󥿥եνλ
 */
void
gic_cpu_stop(void)
{
	/* CPU󥿥ե̵ */
	sil_wrw_mem((void *)(GIC_BASE + GIC_CPUIF_CCR), 0);    
}

/*
 * GIC DIS󥿥եϢ
 */

/*
 * ߶ػ
 */
void
gic_dis_disable_int(uint8_t id)
{
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_ECR + offset_addr), (1 << offset_bit));
}

/*
 * ߵ
 */
void
gic_dis_enable_int(uint8_t id)
{
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;
    
	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_ESR + offset_addr), (1 << offset_bit));
}

/*
 * ߥڥǥ󥰥ꥢ
 */
void
gic_dis_clear_pending(uint8_t id)
{
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_PCR + offset_addr), (1 << offset_bit));
}

/*
 * ߥڥǥ󥰥å
 */
void
gic_dis_set_pending(uint8_t id){
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_PSR + offset_addr), (1 << offset_bit));    
}

/*
 * ׵Υå
 */
bool_t
gic_dis_probe_int(uint8_t id){
	uint32_t state;
	uint16_t offset_addr;
	uint16_t offset_bit;

	offset_addr = (id / 32) * 4;
	offset_bit  = id % 32;

	state = sil_rew_mem((void *)(GIC_BASE + GIC_DIS_PSR + offset_addr));
    
	if((state & (1 << offset_bit)) == (1 << offset_bit)){
		return(true);
	}else{
		return(false);
	}
}

/*
 * Υå
 */
void
gic_dis_config(uint8_t id, uint8_t config){
	uint16_t offset_addr;
	uint16_t offset_bit;
	uint32_t cfgr_reg_val;

	offset_addr = (id / 16) * 4;
	offset_bit  = (id % 16) * 2;

	cfgr_reg_val  = sil_rew_mem((void *)(GIC_BASE + GIC_DIS_CFGR + offset_addr));
	cfgr_reg_val &= ~(0x03U << offset_bit);
	cfgr_reg_val |= (0x03U & config) << offset_bit;
      
	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_CFGR + offset_addr), cfgr_reg_val);
}

/*
 * ͥ٤Υå
 * ɽϤ 
 */
void
gic_dis_set_priority(uint8_t id, int pri){
	uint16_t offset_addr;
	uint16_t offset_bit;
	uint32_t pr_reg_val;

	offset_addr = (id / 4) * 4;
	offset_bit  = (id % 4) * 8;

	pr_reg_val  = sil_rew_mem((void *)(GIC_BASE + GIC_DIS_PR + offset_addr));
	pr_reg_val &= ~(0xffU << offset_bit);
	pr_reg_val |= (0x0fU & pri) << (offset_bit + 4); 
    
	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_PR + offset_addr), pr_reg_val);
}

/*
 * DIC󥿥եν
 */
void
gic_dis_init(void)
{
	int i;
    
	/* DIC󥿥ե̵ */
	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_CR), 0);        

	/* ߤƶػ */
	for(i = 0; i < GIC_TNUM_INT/32; i++){
		sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_ECR + (4 * i)), 0xffffffff);    
	}

	/* ڥǥ󥰤򥯥ꥢ */
	for(i = 0; i < GIC_TNUM_INT/32; i++){
		sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_PCR + (4 * i)), 0xffffffff);    
	}

	/* ͥٺ  */
	for(i = 0; i < GIC_TNUM_INT/4; i++){
		sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_PR + (4 * i)), 0xffffffff);    
	}

	/* åȽ */
	for(i = 0; i < GIC_TNUM_INT/4; i++){
		sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_TAR + (4 * i)), 0x01010101);
	}

	/* ⡼ɽ(1-N Level) */
	for(i = 0; i < GIC_TNUM_INT/16; i++){
		sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_CFGR + (4 * i)), 0x55555555);
	}

	/* DIC󥿥եͭ */
	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_CR), 1);       
}

/*
 * DIC󥿥եνλ
 */
void
gic_dis_stop(void)
{
	/* DIC󥿥ե̵ */
	sil_wrw_mem((void *)(GIC_BASE + GIC_DIS_CR), 0);    
}

/*
 *  ٥Ϥǥץå˻ѤUARTΥɥ쥹
 */
static const uint32_t prc_uart_base_table[TNUM_PRCID] = {
	UART0_BASE,
#if TNUM_PRCID >= 2
	UART1_BASE,
#endif /* TNUM_PRCID >= 2 */
#if TNUM_PRCID >= 3
	UART2_BASE,  
#endif /* TNUM_PRCID >= 3 */
#if TNUM_PRCID >= 4
	UART3_BASE,
#endif /* TNUM_PRCID >= 4 */
};

/*
 *  ץåѤUARTΥɥ쥹
 */
#define my_prc_uart_base	(prc_uart_base_table[x_prc_index()])

/*
 *  UARTΥݡ󥰽
 */
void
ct11mpcore_putc(char_t c){
	/* ХåեΤԤ */
	while((sil_rew_mem((void *)(my_prc_uart_base + UART_FR)) & UART_FR_TXFF)
		  == UART_FR_TXFF);
	/* 񤭹 */
	sil_wrw_mem((void *)(my_prc_uart_base + UART_DR), c);
}

/*
 * ݡ󥰽ϤΤν
 */
void
ct11mpcore_uart_init(void){
	char_t c;
    
	/* UART */
	sil_wrw_mem((void *)(my_prc_uart_base + UART_CR), 0x00);

	/* 顼ե饰򥯥ꥢ */
	sil_wrw_mem((void *)(my_prc_uart_base + UART_RSR), 0x00);
    
	/* FIFOˤ */
	while((sil_rew_mem((void *)(my_prc_uart_base + UART_FR)) & UART_FR_RXFE)
		  != UART_FR_RXFE){
		/* Хåեɤ߹ */
		c = sil_rew_mem((void *)(my_prc_uart_base + UART_DR));
	}

	/* ܡ졼Ȥ */
	sil_wrw_mem((void *)(my_prc_uart_base + UART_IBRD), UART_IBRD_38400);
	sil_wrw_mem((void *)(my_prc_uart_base + UART_FBRD), UART_FBRD_38400);
    
    
	/* ǡեޥåȤȡFIFOΥ⡼ɤ */
	sil_wrw_mem((void *)(my_prc_uart_base + UART_LCR_H), UART_LCR_H_WLEN_8);
        
	/* UARTƳ */
	sil_wrw_mem((void *)(my_prc_uart_base + UART_CR),
				(sil_rew_mem((void *)(my_prc_uart_base + UART_CR))
				 | UART_CR_RXE | UART_CR_TXE | UART_CR_UARTEN));
}

/*
 * EB¢ޤν
 */
void
ebtimer_init(void)
{
	/*
	 * 󥿡å1MHz
	 */
	sil_wrw_mem((void *)SYSTEM_CONTROLER, 
				(sil_rew_mem((void *)SYSTEM_CONTROLER)) | SYSTEM_CONTROLER_TIMER01_1MHZ);

	/*  */
	sil_wrw_mem((void *)TIMER01_0_CTRL, 0x00);
	/* ͤ򥻥å */
	sil_wrw_mem((void *)TIMER01_0_LOAD, 0xffffffff);
	/* ޥȡޡߵġ32bit */
	sil_wrw_mem((void *)TIMER01_0_CTRL,
				(TIMER_CTRL_TIMER_EN|TIMER_CTRL_PERIODIC|TIMER_CTRL_TIMESIZE_32));
}
