/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: kzm_ca9.h 599 2010-05-07 08:00:38Z ertl-honda $
 */

/*
 * KZM_CA9ѥɥ饤
 */

#ifndef TOPPERS_KZM_CA9_H
#define TOPPERS_KZM_CA9_H

#include <sil.h>

/*
 * å400MHz
 */
#define KZM_CA9_CORE_CLK  400
        
/*
 *  MPCore Private Memory Regin Base Address
 */
#define MPCORE_PMR_BASE  0x1e000000

/*
 *  MPCore¢Υޤ1MHzư뤿Υץꥹ顼
 */
#define MPCORE_TM_PS_1MHZ    199   /* å400Mhz */

/*
 * ١ɥ쥹
 */
#define SYS_BASE   0x10000000

/*
 *  ֹ
 */
#define DIC_IRQNO_UART2   64
#define DIC_IRQNO_TM_SP804_0 80
#define DIC_IRQNO_TM_SP804_1 81
#define DIC_IRQNO_UART0   84


/*
 * TestChip¢޴Ϣ(SP804)
 */

/* 
 * ١ɥ쥹
 */
#define TIMER_BASE_REG  (SYS_BASE + 0xe4000)

#ifndef TOPPERS_MACRO_ONLY


#endif /* TOPPERS_MACRO_ONLY */

/*
 * UARTϢ
 * 쥸
 * 	arm_primecell_uart.h(UART0)
 * 	tl16c554a.h(UART2)
 * ǹԤäƤ
 */
 
/* 
 * ١ɥ쥹
 */
#define UART0_BASE  (SYS_BASE + 0xe3000)
#define SMC0_CS2_BASE	0x48000000
#define UART2_CSA_BASE (SMC0_CS2_BASE + 0x00000000) 
#define UART2_CSB_BASE (SMC0_CS2_BASE + 0x00800000) 
#define UART2_CSC_BASE (SMC0_CS2_BASE + 0x01000000) 
#define UART2_CSD_BASE (SMC0_CS2_BASE + 0x01800000) 


/*
 *  BPS(38400bps)
 */ 
#define UART_IBRD_38400   0x0c
#define UART_FBRD_38400   0x00

#ifndef TOPPERS_MACRO_ONLY
/*
 *  UARTΥݡ󥰽
 */
extern void kzm_ca9_putc(char_t c);

/*
 * ݡ󥰽ϤΤν
 */
extern void kzm_ca9_uart_init(void);

/*
 *  ȯĶ¸ν(T.B.D)
 */
Inline void
kzm_ca9_exit(void){
	while(1);
}

/*
 *  ȥ졼˴ؤ
 *  SCUѤ롥 
 */
#define TRACE_HW_INIT()   scu_counter_init()
#define TRACE_GET_TIM()   ((scu_counter_get_current() * 1000) / CORE_CLK)

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_KZM_CA9_H */
