/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 599 2010-05-07 08:00:38Z ertl-honda $
 */

/*
 * åȰ¸⥸塼KZM_CA9ѡ
 */
#include "kernel_impl.h"
#include <sil.h>

extern void *vector_table;

#define CP15_SET_VBAR(x)    Asm("mcr p15, 0, %0, c12, c0, 0"::"r"(x))


/*
 *  str_ker() ǥޥץåǹԤ
 */
void
target_mprc_initialize(void)
{
	/* MPCore¸Ǥν */
	chip_mprc_initialize();
}

/*
 * Υ١ɥ쥹ȥ
 */
#define DDR_ADDR 0x00000000
#define DDR_SIZE 0x04000000 /* 64MB */


/*
 * ޥåפνchip¸ƤӽФ
 * Ʊ˥åͭˤ
 */
void
target_mmu_init(void)
{
	MEMORY_ATTRIBUTE m_attribute;

	/*
     *  Enable caching for the DDR
	 */
    m_attribute.pa   = DDR_ADDR;
	m_attribute.va   = m_attribute.pa;
	m_attribute.size = DDR_SIZE;
	m_attribute.s    = 1;		  /* ͭ		 */
	m_attribute.ap   = 3;		  /* ե륢 */
	m_attribute.tex  = 1;		  /* Outer and Inner */
	m_attribute.c    = 1;		  /* Inner Write-Back, Write Allocate */ 
	m_attribute.b    = 1;

	mmu_map_memory(&m_attribute);

#if 0
    m_attribute.pa   = 0x00200000;
    m_attribute.va   = m_attribute.pa;
    m_attribute.size = 0x00100000;
    m_attribute.s    = 1;    /* not-shared */
    m_attribute.ap   = 3;    /* ե륢 */
    m_attribute.tex  = 1;    /* 0: Outer and Inner Write-Back */
    m_attribute.c    = 1;    /* cb:11 No Allocate on Write */
    m_attribute.b    = 1;

    mmu_map_memory (&m_attribute);
#endif    
    
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 * åװ¸ν
	 */
	chip_initialize();
        
	/*
	 *  UART
	 */
#ifdef G_SYSLOG
	if (x_sense_mprc()) {
		kzm_ca9_uart_init();
	}
#else
	naviengine_uart_init();
#endif /* G_SYSLOG */

    /*
     * ߥ٥ơ֥ VECTOR_TABLE_BASE 쥸ꤹ
     */
	CP15_SET_VBAR((uint32_t) &vector_table);
	
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *  åװ¸νλ
	 */
	chip_exit();

	/*
	 *  ȯĶ¸νλ
	 */
	kzm_ca9_exit();

	while(1);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		kzm_ca9_putc('\r');
	}
	kzm_ca9_putc(c);
}

#include "target_timer.h"

/*
 *  ¹Իʬ۽ץ⥸塼ѤΥ󥿤ˤ¬
 */
void
perf_timer_get(uint32_t *p_time)
{
	*p_time = target_timer_get_current();
}

/*
 *  ¹Իʬ۽ץ⥸塼ѤΥ󥿤ˤ¬̤ñѴ
 *  nsecѴ 
 */
uint32_t
perf_timer_conv_tim(uint32_t time)
{
	return (TO_NSEC(time));
}
