/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: kzm_ca9.c 599 2010-05-07 08:00:38Z ertl-honda $
 */

#include "kernel_impl.h"
//#include "pdic/arm_primecell_uart/arm_primecell_uart.h"
#include "tl16c554a.h"
#include "target_timer.h"
#include "kzm_ca9.h"
#ifdef G_SYSLOG

//#define my_prc_uart_base	UART0_BASE
#define my_prc_uart_base	UART2_CSA_BASE

#else

/*
 *  ٥Ϥǥץå˻ѤUARTΥɥ쥹
 */
static const uint32_t prc_uart_base_table[TNUM_PRCID] = {
	UART0_BASE,
#if TNUM_PRCID >= 2
	UART1_BASE,
#endif /* TNUM_PRCID >= 2 */
#if TNUM_PRCID >= 3
	UART2_BASE,  
#endif /* TNUM_PRCID >= 3 */
#if TNUM_PRCID >= 4
	UART3_BASE,
#endif /* TNUM_PRCID >= 4 */
};

/*
 *  ץåѤUARTΥɥ쥹
 */
#define my_prc_uart_base	(prc_uart_base_tbl[x_prc_index()])

#endif /* G_SYSLOG */



/*
 *  UARTΥݡ󥰽
 */
void
kzm_ca9_putc(char_t c){
	/* ХåեΤԤ */
	while ((sil_rew_mem((void *)(my_prc_uart_base + TL16C554A_LSR)) & LSR_THRE) == 0);
	/* 񤭹 */
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_THR), c);

	/* ХåեΤԤ */
	while ((sil_rew_mem((void *)(my_prc_uart_base + TL16C554A_LSR)) & LSR_THRE) == 0);


}

/*
 * ݡ󥰽ϤΤν
 */
void
kzm_ca9_uart_init(void){

	/* ߶ػ */
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_IER), 0x00);

	/* Access baud rate */
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_LCR), LCR_BKSE);
    
	/* ܡ졼Ȥ */
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_DLL), 12 & 0xff);
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_DLM), (12 >> 8) & 0xff);

    	/* 8 data, 1 stop, no parity */
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_LCR), LCR_8N1);

	/* no RTS/DTR */
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_MCR), MCR_VAL);

	/* Clear & enable FIFOs */
	sil_wrw_mem((void *)(my_prc_uart_base + TL16C554A_FCR), FCR_VAL);

}

/*
 *  TestChip¢ޤν
 */
void
timer_sp804_init(void)
{
#if 0
	/*  */
	sil_wrw_mem((void *)(TIMER_BASE_REG + TIMER_SP804_1CONTROL), 0x00);
	
	/* ͤ򥻥å */
	sil_wrw_mem((void *)(TIMER_BASE_REG + TIMER_SP804_1LOAD), 0xffffffff);

	/* ޥȡե꡼˥󥰡ʬʤ32bit */
	sil_wrw_mem((void *)(TIMER_BASE_REG + TIMER_SP804_1CONTROL),
				(TIMER_SP804_CTRL_TIMER_EN|TIMER_SP804_CTRL_TIMESIZE_32));
#endif
}
