/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.h 599 2010-05-07 08:00:38Z ertl-honda $
 */

/*
 *  ޥɥ饤СKZM_CA9ѡ
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

/*
 *  åװ¸⥸塼MPCOREѡ
 */
#include "arm_gcc/mpcore/chip_wdt.h"
//#include "arm_gcc/mpcore/chip_timer.h"

//////////////////////////////////////////////////////////////////////////
#if 0
#include <sil.h>
//#include "mpcore.h"
#include "kzm_ca9.h"

/*
 *  ޡϢ
 */
//#define TIMER_BASE_REG         0x100E4000
//#define OVRTIMER_BASE_REG    ?

#define TIMER_SP804_1LOAD		0x000
#define TIMER_SP804_1VALUE		0x004
#define TIMER_SP804_1CONTROL	        0x008
#define TIMER_SP804_1CLEAR		0x00C
#define TIMER_SP804_1RIS		0x010
#define TIMER_SP804_2LOAD		0x020
#define TIMER_SP804_2VALUE		0x024
#define TIMER_SP804_2CONTROL	        0x028
#define TIMER_SP804_2CLEAR		0x02C

#define TIMER_SP804_CTRL_TIMER_EN     0x00000080
#define TIMER_SP804_CTRL_PERIODIC     0x00000040
#define TIMER_SP804_CTRL_INT_EN       0x00000020
#define TIMER_SP804_CTRL_PRESCALE_1   0x00000000
#define TIMER_SP804_CTRL_PRESCALE_16  0x00000004
#define TIMER_SP804_CTRL_PRESCALE_256 0x00000008
#define TIMER_SP804_CTRL_TIMESIZE_16  0x00000000
#define TIMER_SP804_CTRL_TIMESIZE_32  0x00000002
#define TIMER_SP804_CTRL_ONE_SHOT     0x00000001

#define INHNO_TIMER     DIC_IRQNO_TM_SP804_0  /* ߥϥɥֹ */
#define INTNO_TIMER     DIC_IRQNO_TM_SP804_0  /* ֹ */

#define INTPRI_TIMER    -6            /* ͥ */
#define INTATR_TIMER    0U            /* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽη
 */
typedef uint32_t    CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *  1(1MHz) ˥ȥ󤹤
 */
#define TIMER_CLOCK          100000U
#define TO_CLOCK(nume, deno) (TIMER_CLOCK * (nume) / (deno))
#define TO_USEC(clock)       (((SYSUTM) clock) * 1000U / TIMER_CLOCK)
#define TO_NSEC(clock)		 (((SYSUTM) clock) * 1000000U / TIMER_CLOCK)

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK        ((CLOCK) 0xffffffffU)

/*
 *  ޤθͤȯͤȤߤʤȽ
 */
#define GET_TOLERANCE    100U    /* ٤θѤ͡ñ̤ɽ*/
#define BEFORE_IREQ(clock) \
            ((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void    target_timer_initialize(intptr_t exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void    target_timer_terminate(intptr_t exinf);

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
  return(TO_CLOCK(TIC_NUME, TIC_DENO) - sil_rew_mem((void *)(TIMER_BASE_REG + TIMER_SP804_1VALUE)));
}

/*
 *  ޳׵Υå
 */
Inline bool_t
target_timer_probe_int(void)
{
    return(x_probe_int(INTNO_TIMER));

}

/*
 *  ޳ߥϥɥ
 */
extern void    target_timer_handler(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
//////////////////////////////////////////////////////////////////////////
#endif

#endif /* TOPPERS_TARGET_TIMER_H */
