/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h 564 2010-04-14 00:53:34Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼RPROTO1_DEVѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "rproto1_dev.h"

/*
 *  get_utm򥵥ݡȤ뤫ɤ
 */
#define SUPPORT_GET_UTM

/*
 *  FMPͥưΥޥåפȴϢ
 *       
 *      0x08000000 -  ΰ
 *      0x08050000 -  ǡΰ
 */

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_PRC1_ISTKSZ  (1024 * 8)  /* 8KB */
#define DEFAULT_PRC2_ISTKSZ  (1024 * 8)  /* 8KB */
#define DEFAULT_PRC3_ISTKSZ  (1024 * 8)  /* 8KB */
#define DEFAULT_PRC4_ISTKSZ  (1024 * 8)  /* 8KB */

/*
 *  åΥ饤ȥХåͭ
 */
#define ENABLE_CACHE_WRITE_BACK

/*
 *  åΥҡ󥷤ͭ
 */
#define ENABLE_CACHE_COHERENCE

/*
 *  ǥѥåFPUΥХ󥯥쥸¸ͭ
 */
//#define FPU_SAVE_BANKED_REG

/*
 *  å
 */
//#define TTYPE_KLOCK G_KLOCK
#define TTYPE_KLOCK P_KLOCK
//#define TTYPE_KLOCK F_KLOCK

/*
 *  ԥåǽ
 */
#define TTYPE_SPN NATIVE_SPN
//#define TTYPE_SPN EMULATE_SPN

/*
 *  ͥƥ֥ԥξΥԥåκ
 */
#define TMAX_NATIVE_SPN  256

#ifndef TOPPERS_MACRO_ONLY

/*
 *  å르ꥺFIFOå
 */
#define ENABLE_FIFO_LOCK

/*
 *  str_ker()ǥޥץåǹԤ
 */
extern void target_mprc_initialize(void);

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

/*
 *  åȥƥʸ
 *
 *  ƥ٥ʸϥ롼ROM˥GDB STUBƽФǼ
 *  롥
 */
extern void target_putc(char c);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1     11
#define SIL_DLY_TIM2     9


/*
 *  ץå¸⥸塼SH4Aѡ
 */
#include "sh4a_gcc/rproto1_config.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */
     
#endif  /* TOPPERS_TARGET_CONFIG_H */
