/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.c 560 2010-04-05 10:07:43Z ertl-honda $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СRPROTO1_DEVѡ
 *  SCIF0  
 */

#include <kernel.h>
#include <t_syslog.h>
#include "target_serial.h"

static INTNO const intno_sio_tx[4] = {
	SCIF0_TXI_INTEVT,
	SCIF1_TXI_INTEVT,
	SCIF2_TXI_INTEVT,
	SCIF3_TXI_INTEVT
};

static INTNO const intno_sio_rx[4] = {
	SCIF0_RXI_INTEVT,
	SCIF1_RXI_INTEVT,
	SCIF2_RXI_INTEVT,
	SCIF3_RXI_INTEVT
};

/*
 *  ꥢI/OݡIDֹФΥޥ
 */
#define INDEX_SIOP(siopid)			 ((uint_t)((siopid) - 1))
#define get_intno_sio_tx(siopid)	 (intno_sio_tx[INDEX_SIOP(siopid)])
#define get_intno_sio_rx(siopid)	 (intno_sio_rx[INDEX_SIOP(siopid)])

/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
	sh_scif_initialize();    
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB    *p_siopcb;
	ER        ercd;

	/*
	 *  ꥢI/Oߤޥ롥
	 */
	ercd = dis_int(get_intno_sio_tx(siopid));
	assert(ercd == E_OK);
	ercd = dis_int(get_intno_sio_rx(siopid));
	assert(ercd == E_OK);

	/*
	 *  ǥХ¸Υץ
	 */
	p_siopcb = sh_scif_opn_por(siopid, exinf);

	/*
	 *  ꥢI/OߤΥޥ롥
	 */
	ercd = ena_int(get_intno_sio_tx(siopid));
	assert(ercd == E_OK);
	ercd = ena_int(get_intno_sio_rx(siopid));
	assert(ercd == E_OK);        

	return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	ER ercd;
	ID siopid;

	/*
	 *  ꥢI/OݡIDμ
	 */
	siopid = sh_scif_get_siopid(p_siopcb);

	/*
	 *  ǥХ¸Υ
	 */
	sh_scif_cls_por(p_siopcb);

	/*
	*  ꥢI/Oߤޥ롥
	*/
	ercd = dis_int(get_intno_sio_tx(siopid));
	assert(ercd == E_OK);
	ercd = dis_int(get_intno_sio_rx(siopid));
	assert(ercd == E_OK);        
}

/*
 *  SIOγߥϥɥ
 */
void
sio_tx_isr(intptr_t siopid)
{
	sh_scif_tx_isr(siopid);
}

/*
 *  SIOγߥϥɥ
 */
int test;
void
sio_rx_isr(intptr_t siopid)
{
	sh_scif_rx_isr(siopid);
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
	return(sh_scif_snd_chr(siopcb, c));
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	return(sh_scif_rcv_chr(siopcb));
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	sh_scif_ena_cbr(siopcb, cbrtn);
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	sh_scif_dis_cbr(siopcb, cbrtn);
}

/*
 *  ꥢI/OݡȤǽХå
 */
void
sh_scif_irdy_snd(intptr_t exinf)
{
	sio_irdy_snd(exinf);
}

/*
 *  ꥢI/OݡȤμΥХå
 */
void
sh_scif_irdy_rcv(intptr_t exinf)
{
	sio_irdy_rcv(exinf);
}
