/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.h 540 2010-02-17 10:48:07Z ertl-honda $
 */


/*
 *  ꥢI/OǥХSIO˥ɥ饤СRPROTO1_DEVѡ
 */
#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "rproto1_dev.h"
#include "pdic/sh/sh_scif.h"

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#define INHNO_SIO_TX0     (0x00010000 | SCIF0_TXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_TX0     (0x00000000 | SCIF0_TXI_INTEVT)	/* ֹ */
#define INHNO_SIO_RX0     (0x00010000 | SCIF0_RXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_RX0     (0x00000000 | SCIF0_RXI_INTEVT)	/* ֹ */

#define INHNO_SIO_TX1     (0x00020000 | SCIF1_TXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_TX1     (0x00000000 | SCIF1_TXI_INTEVT)	/* ֹ */
#define INHNO_SIO_RX1     (0x00020000 | SCIF1_RXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_RX1     (0x00000000 | SCIF1_RXI_INTEVT)	/* ֹ */

#define INHNO_SIO_TX2     (0x00030000 | SCIF2_TXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_TX2     (0x00000000 | SCIF2_TXI_INTEVT)	/* ֹ */
#define INHNO_SIO_RX2     (0x00030000 | SCIF2_RXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_RX2     (0x00000000 | SCIF2_RXI_INTEVT)	/* ֹ */

#define INHNO_SIO_TX3     (0x00040000 | SCIF3_TXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_TX3     (0x00000000 | SCIF3_TXI_INTEVT)	/* ֹ */
#define INHNO_SIO_RX3     (0x00040000 | SCIF3_RXI_INTEVT)	/* ߥϥɥֹ */
#define INTNO_SIO_RX3     (0x00000000 | SCIF3_RXI_INTEVT)	/* ֹ */

#define INTPRI_SIO       (-4)             /* ͥ */
#define INTATR_SIO       0U               /* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  SIOɥ饤Фν
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  SIOγߥϥɥ
 */
extern void sio_tx_isr(intptr_t siopid);
extern void sio_rx_isr(intptr_t siopid);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char_t c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
