/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 516 2010-02-03 05:57:37Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼SH7786_DEVѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "mp.h"
#include "sh7786_dev.h"
#include "../pdic/sh/sh_scif.h"

#ifdef ROM_BOOT
uint32_t __dummy = 1;
#endif

/*
 *  ٥ϤǻѤݡֹ
 */
static const ID prc_fput_log_uart_table[2] = {
	1,
	2
};

/*
 *  ץåѤ٥ϥݡȤμ
 */
Inline ID
get_my_prc_fput_log_uart(void)
{
	return (prc_fput_log_uart_table[x_prc_index()]);
}

/*
 * str_ker()ǥޥץåǹԤ
 */
void
target_mprc_initialize(void)
{
	/*
	 *  SH4A¸Ǥν
	 */
	prc_mprc_initialize();

	/*
	 *  GPIOΥ쥸ꤷSCIF1Υԥͭˤ
	 */
	sil_wrh_mem((void *)GPIO_PDCR,
                (sil_reh_mem((void *)GPIO_PDCR) & GPIO_PDCR_SCIF1_ENABLE));
	/*
	 *  GPIOΥ쥸ꤷSCIF0Υԥͭˤ
	 */
	sil_wrh_mem((void *)GPIO_PHCR,
                (sil_reh_mem((void *)GPIO_PHCR) & GPIO_PHCR_SCIF0_ENABLE));

	/* Хȥ쥸Light Sleep⡼ɤ */
	sil_wrw_mem((void *)C0STBCR,
                (sil_rew_mem((void *)C0STBCR) | CSTBCR_LIGHT_SLEEP));
	sil_wrw_mem((void *)C1STBCR,
                (sil_rew_mem((void *)C1STBCR) | CSTBCR_LIGHT_SLEEP));

	/*
	 *  SCIF0ͭ
	 */
	sil_wrh_mem((void *)SPCAR, 0x0044U);/* enable SCIF0 clock=1.842 MHz */
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  ץå¸ν
	 */
	prc_initialize();

	/*
	 *  ٥ѤΥꥢ륳ȥν
	 */
	sh_scif_init(get_my_prc_fput_log_uart());
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	extern void    software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *  Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}

	/*
	 *  ץå¸νλ
	 */
	prc_terminate();

	/*
	 *  ȯĶ¸νλ
	 */
	sh7786_dev_exit();

	/*
	 * ˤʤ
	 */
	while(1);
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char c)
{
	ID siopid = get_my_prc_fput_log_uart();

	if (c == '\n') {
		sh_scif_pol_putc('\r', siopid);
	}
	sh_scif_pol_putc(c, siopid);
}
