/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2009-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_test.c 547 2010-02-26 02:31:40Z ertl-honda $
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_test.h"

static const uint8_t timer_str[] = {
	TMU_STR0,
	TMU_STR1
};

static void * const timer_tcr[] = {
	(void *)(TIM0_BASE + TIM_TCR),
	(void *)(TIM1_BASE + TIM_TCR)
};

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick(void)
{
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_stop_tick_pe(i);
	}
}

/*
 *  ƥå(ץå)
 */
void
ttsp_target_stop_tick_pe(ID prcid)
{
	uint_t prc_index = prcid - 1;
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	sil_wrb_mem((void*)TMU_TSTR0,
				(sil_reb_mem((void*)TMU_TSTR0) & ~timer_str[prc_index]));
	SIL_UNL_SPN();
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick(void)
{
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_start_tick_pe(i);
	}
}

/*
 *  ƥåκƳץå
 */
void
ttsp_target_start_tick_pe(ID prcid)
{
	uint_t prc_index = prcid - 1;
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	sil_wrb_mem((void*)TMU_TSTR0,
				(sil_reb_mem((void*)TMU_TSTR0) | timer_str[prc_index]));
	SIL_UNL_SPN();
}

/*
 *  ƥåιץå(ƥå߾֤ǸƤӽФ)
 */
void
ttsp_target_gain_tick(void) {
	uint_t i;

	for(i = 1; i <= TNUM_PRCID; i++) {
		ttsp_target_gain_tick_pe(i);
	}
}

/*
 *  ƥåιץå(ƥå߾֤ǸƤӽФ)
 */
void
ttsp_target_gain_tick_pe(ID prcid) {
	uint_t prc_index = prcid - 1;
	volatile PCB *p_pcb = get_mp_p_pcb(prcid);
	EVTTIM	current_time1, current_time2;
	ID pid;
	SIL_PRE_LOC;

	SIL_LOC_SPN();
	current_time1 = p_pcb->p_tevtcb->current_time;
	/* ߤζػ(UNIE򥯥ꥢ) */
	sil_wrh_mem(timer_tcr[prc_index],
				sil_reh_mem(timer_tcr[prc_index]) & ~TCR_UNIE);

	/* ޡΥ */
	sil_wrb_mem((void*)TMU_TSTR0,
				(sil_reb_mem((void*)TMU_TSTR0) | timer_str[prc_index]));

	/* СեԤ */
	while((sil_reh_mem(timer_tcr[prc_index]) & TCR_UNF) != TCR_UNF);

	/* ޡ */
	sil_wrb_mem((void*)TMU_TSTR0,
				(sil_reb_mem((void*)TMU_TSTR0) & ~timer_str[prc_index]));

	/* ߤε(UNIE򥻥å) */
	sil_wrh_mem(timer_tcr[prc_index],
				sil_reh_mem(timer_tcr[prc_index]) | TCR_UNIE);
	SIL_UNL_SPN();

	/* PEФƤϡ֤ʤޤԤ */
	sil_get_pid(&pid);
	if (pid == prcid) {
		do{
			current_time2 = p_pcb->p_tevtcb->current_time;
		}while(current_time1 == current_time2);
	}
}

/*
 *  ƥåѥ޳׵ȯʼץå(ƥå߾֤ǸƤӽФ)
 */ 
void
ttsp_target_raise_tick_int(void)
{
	uint_t prc_index = x_prc_index();

	/* ߤζػ(UNIE򥯥ꥢ) */
	sil_wrh_mem(timer_tcr[prc_index],
				sil_reh_mem(timer_tcr[prc_index]) & ~TCR_UNIE);

	/* ޡΥ */
	sil_wrb_mem((void*)TMU_TSTR0,
				(sil_reb_mem((void*)TMU_TSTR0) | timer_str[prc_index]));

	/* СեԤ */
	while((sil_reh_mem(timer_tcr[prc_index]) & TCR_UNF) != TCR_UNF);

	/* ޡ */
	sil_wrb_mem((void*)TMU_TSTR0,
				(sil_reb_mem((void*)TMU_TSTR0) & ~timer_str[prc_index]));

	/* ߤε(UNIE򥻥å) */
	sil_wrh_mem(timer_tcr[prc_index],
				sil_reh_mem(timer_tcr[prc_index]) | TCR_UNIE);
}
