/*
 *  TOPPERS/SafeG Dual-OS monitor
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Safety Gate Dual-OS monitor
 *
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *     Graduate School of Information Science, Nagoya University, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 */
#ifndef _T_SAFEG_SYSCALLS_H_
#define _T_SAFEG_SYSCALLS_H_

#include "safeg_syscalls.h"

#ifndef __ASSEMBLY__

struct safeg_smc_args {
    int arg0;
    int arg1;
};

static inline
void safeg_switch_to_nt(volatile struct safeg_smc_args *ret_args)
{
    ret_args->arg0 = T_SMC_SWITCH_OK;
    while (1) {
        Asm("mov r0, %0\n\t"
            "mov r1, %1\n\t"
            "smc 0\n\t"
            : /* no output */
            : "I" (T_SMC_SWITCH), "r" (ret_args)
            : "r0", "r1", "memory");
        if (ret_args->arg0 != T_SMC_SWITCH_OK) return;
    }
}

static inline void safeg_reboot_nt(void)
{
    Asm("mov r0, %0\n\t"
        "mov r1, #0x8000\n\t"
        "smc 0\n\t"
        : /* no output */
        : "I" (T_SMC_REBOOT)
        : "r0", "r1", "memory");
}

#endif /* __ASSEMBLY__ */

#endif /* _T_SAFEG_SYSCALLS_H_ */
